package com.mortals.xhx.common.formdesign.component;

import com.mortals.xhx.common.code.ComponentEnum;
import com.mortals.xhx.common.formdesign.*;
import com.mortals.xhx.common.pdu.gen.component.ComponentCons;

import java.util.ArrayList;
import java.util.List;

/**
 * 级联选择组件
 *
 * @author: zxfei
 * @date: 2024/11/22 9:24
 */
public class DesignCascadeComponent extends DesignComponent {

    public DesignCascadeComponent(String type) {
        super(type);
    }

    @Override
    public ListItem buildDefaultComponent(ComponentCons cons) {
        ListItem columnsItem = new ListItem();
        columnsItem.setId(cons.getVal());
        columnsItem.set_id(cons.getVal());
        columnsItem.setCompType("cascader");
        columnsItem.setEle("el-cascader");
        columnsItem.setCompName("级联选择");
        columnsItem.setCompIcon("cascader");
        columnsItem.setViewType("component");
        columnsItem.setConfig(true);
        columnsItem.setShowLabel(true);
        columnsItem.setLabel(cons.getLabel());
        columnsItem.setLabelWidth(120);
        columnsItem.setPlaceholder("请选择" + cons.getLabel());
        columnsItem.setRequired(false);
        columnsItem.setGutter(15);
        columnsItem.setSpan(24);

        columnsItem.setSize("medium");
        columnsItem.setDisabled(false);
        columnsItem.setDataType("static");
        columnsItem.setChinaAreaData("");
        columnsItem.setAction("");

        //Props 设置
        Props props = new Props();
        props.setClearable(false);
        props.setSeparator("-");
        props.setShowAllLevels(true);
        props.setFilterable(false);

        Props propsChild = new Props();
        propsChild.setExpandTrigger("click");
        propsChild.setMultiple(false);
        propsChild.setCheckStrictly(false);
        propsChild.setLabel("label");
        propsChild.setValue("value");
        propsChild.setChildren("children");
        props.setProps(propsChild);
        columnsItem.setProps(props);



        //设置options
        List<OptionsItem> options = new ArrayList<>();
        OptionsItem optionsItem = new OptionsItem();
        optionsItem.setValue("zhinan");
        optionsItem.setLabel("指南");
        List<ChildrenItem> children = new ArrayList<>();
        ChildrenItem child = new ChildrenItem();
        child.setValue("shejiyuanze");
        child.setLabel("设计原则");
        children.add(child);
        optionsItem.setChildren(children);

        List<ChildrenItem> children1 = new ArrayList<>();
        ChildrenItem child1 = new ChildrenItem();
        child1.setValue("yizhi");
        child1.setLabel("一致");
        children1.add(child1);
        child.setChildren(children1);

        columnsItem.setOptions(options);

        //设置默认值
        columnsItem.setLayout("colItem");
        columnsItem.setValue(new ArrayList<>());
        return columnsItem;
    }

    @Override
    public String getType() {
        return ComponentEnum.CASCADE.getValue();
    }
}
