/*
 Navicat Premium Data Transfer

 Source Server         : 250
 Source Server Type    : MySQL
 Source Server Version : 50743
 Source Host           : 192.168.0.250:3306
 Source Schema         : fill-platform

 Target Server Type    : MySQL
 Target Server Version : 50743
 File Encoding         : 65001

 Date: 13/02/2025 16:22:25
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for mortals_fill_matter_datum_print
-- ----------------------------
DROP TABLE IF EXISTS `mortals_fill_matter_datum_print`;
CREATE TABLE `mortals_fill_matter_datum_print`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `orderId` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '打印订单',
  `materialId` bigint(20) NULL DEFAULT NULL COMMENT '材料Id',
  `materialName` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '材料名',
  `page` int(8) NULL DEFAULT NULL COMMENT '材料页数',
  `type` tinyint(2) NULL DEFAULT NULL COMMENT '打印类型(1.本地打印,2.在线打印)',
  `docPath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '合成doc后地址',
  `formContent` mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '提交的表单',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '打印提交';

-- ----------------------------
-- Records of mortals_fill_matter_datum_print
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_sys_sheet_matter
-- ----------------------------
DROP TABLE IF EXISTS `mortals_sys_sheet_matter`;
CREATE TABLE `mortals_sys_sheet_matter`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `tid` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项id',
  `tcode` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项code',
  `tname` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项name',
  `matterName` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项名称',
  `englishName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '英语事项名',
  `matterNo` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项编号',
  `areaCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '区域编码',
  `deptCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门编号',
  `deptName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门名称',
  `powerCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '行政权力编号',
  `themeCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '主题编号',
  `usertypeCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '服务类型编号',
  `groupName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项组名',
  `url` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项详情链接',
  `haveGetMatterInfo` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否获取事项详情',
  `belongDept` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '所属部门',
  `appoveObjectShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '服务对象 （事业法人.事业法人，社会组织法人.社会组织法人，非法人企业.非法人企业，企业法人.企业法人，自然人.自然人，其他组织.其他组织）',
  `operatScopeShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '通办范围 （无.无，全国.全国，全市.全市，全县.全县，全镇[乡 街道].全镇[乡 街道]，跨村[社区].跨村[社区]）',
  `appoveTimeLimitShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办件类型（网络办件.网络办件，行政审批一般件.行政审批一般件，综合窗口件.综合窗口件）',
  `handleType` varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理形式（窗口办理.窗口办理，网上办理.网上办理）	',
  `legalTimeLimitShow` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '法定办结时限',
  `legalEndExplain` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '法定时限办结说明',
  `promiseTimeLimitShow` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '承诺办结时限',
  `promiseEndExplain` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '承诺时限办结说明',
  `isChargesShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否收费（否.否，是.是）',
  `certificationLevelsShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '认证等级需求（实名认证.实名认证，单次面签.单次面签，每次面签.每次面签）',
  `planTakeTime` datetime(0) NULL DEFAULT NULL COMMENT '计划生效日期',
  `promiseTakeTime` datetime(0) NULL DEFAULT NULL COMMENT '承诺生效日期',
  `specialProcedure` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '特别程序',
  `windowToTheSceneNum` tinyint(2) NULL DEFAULT NULL COMMENT '窗口到现场次数',
  `isOnlineSubscribeShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否网上预约,窗口办理选（否.否，是.是）',
  `isExpressTakeShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物流快递,窗口办理选（否.否，是.是）',
  `isProvinceAcquisitionShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否支持全省范围就近取件（否.否，是.是）',
  `isApplyProvinceShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否支持全省范围就近办理（否.否，是.是）',
  `mustSceneExplain` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '必须到现场原因',
  `onlineType` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '网办类型（原件预审.原件预审，原件核验.原件核验，全程网办.全程网办）',
  `onlineToTheSceneNum` tinyint(2) NULL DEFAULT NULL COMMENT '网办到现场次数',
  `onlineOperatDeep` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '网络办理深度（互联网咨询.互联网咨询，互联网收件.互联网收件，互联网预审.互联网预审，互联网受理.互联网受理，互联网办理.互联网办理，互联网办理结果信息反馈.互联网办理结果信息反馈，其他.其他）',
  `isExpressTakeOnlineShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物流快递，网上办理选（否.否，是.是）',
  `isDoorTakeShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否支持上门收取申请（否.否，是.是）',
  `onlineMustSceneExplain` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '网上必须到现场原因',
  `performDeptType` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施主体',
  `matterEdition` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项版本',
  `eventTypeShow` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项类型名称（行政许可.行政许可，行政处罚.行政处罚，行政强制.行政强制，行政征收.行政征收，行政给付.行政给付，行政检查.行政检查，行政确认.行政确认，行政奖励.行政奖励，行政裁决.行政裁决，其他行政权力.其他行政权力，主动服务.主动服务，依申请服务.依申请服务，咨询查询.咨询查询，未归类事项.未归类事项）',
  `performHierarchyShow` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '行使层级名称（省级.省级，市级.市级，县级.县级，镇[乡 街道].镇[乡 街道]，村[社区]级.村[社区]级）',
  `powerSourceShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '权力来源（法定本级行使.法定本级行使，上级下放.上级下放，上级授权.上级授权，同级授权.同级授权，上级委托.上级委托，同级委托.同级委托）',
  `performDeptTypeShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施主体性质（法定机关.法定机关，授权组织.授权组织，受委托组织.受委托组织）',
  `goveServiceCenterShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否进驻中心（否.否，是.是）',
  `isConvenientCenterShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否纳入便民服务中心（否.否，是.是）',
  `terminalHandle` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '自助终端办理 （否.否，是.是）',
  `isOnline` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否网办 （否.否，是.是）',
  `isOnlinePayShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '支持网上支付（否.否，是.是）',
  `entrustmentDepartmen` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '委托部门（否.否，是.是）',
  `jointInfoShow` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '联办机构',
  `matterStatus` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项状态（停用.停用，在用.在用）',
  `numberLimit` int(11) NULL DEFAULT NULL COMMENT '数量限制',
  `type` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '主题类型',
  `baseCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '基本编码',
  `implementCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施编码',
  `implementBodyCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施主体编码',
  `operateItemCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理项编码',
  `townshipName` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '乡镇街道名称',
  `townshipCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '乡镇街道代码',
  `villageName` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '村居社区名称',
  `villageCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '村居社区代码',
  `operateTime` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理时间',
  `operateSite` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理地点',
  `cousultingShow` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '咨询方式',
  `cousultingTelephoneShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '咨询电话',
  `superviseShow` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '监督投诉方式',
  `sort` int(4) NULL DEFAULT NULL COMMENT '排序',
  `source` tinyint(2) NULL DEFAULT NULL COMMENT '事项来源(0.政务网，1.自定义)',
  `evaluationUrl` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '评价地址',
  `netApplyUrl` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '申请地址',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `matterarea`(`matterNo`, `areaCode`) USING BTREE,
  INDEX `area`(`areaCode`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '基础事项';

-- ----------------------------
-- Records of mortals_sys_sheet_matter
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_sys_skin
-- ----------------------------
DROP TABLE IF EXISTS `mortals_sys_skin`;
CREATE TABLE `mortals_sys_skin`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `categoryId` bigint(20) NULL DEFAULT NULL COMMENT '所属种类,来源种类',
  `productId` bigint(20) NULL DEFAULT NULL COMMENT '产品id',
  `productName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '产品名称',
  `cssFilePath` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'css模板合成后文件地址',
  `name` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '产品皮肤名称，唯一且不为空',
  `imageResolution` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '分辨率 (1.1920*1080，2.1080*1920，3.1280*1280)',
  `previewImagePath` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '预览图片',
  `sortNum` int(9) NULL DEFAULT NULL COMMENT '排序编号',
  `used` tinyint(2) NULL DEFAULT 0 COMMENT '是否使用',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 200 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '皮肤';

-- ----------------------------
-- Records of mortals_sys_skin
-- ----------------------------
BEGIN;
INSERT INTO `mortals_sys_skin` VALUES (192, 6, 8, '填单机', '/file/fileupload/1710224902689.css', '填单机-中秋节皮肤', '1920x1080', '/file/fileupload/1710224902630.png', NULL, 0, '2024-03-12 14:28:23', 1, '2025-02-13 10:27:00'), (193, 8, 8, '填单机', '/file/fileupload/skin/1735289558310.css', '填单机-元旦皮肤（25年）', '1920x1080', '/file/fileupload/1735289558088.png', NULL, 0, '2024-03-12 14:31:59', 1, '2025-02-13 10:27:00'), (194, 3, 8, '填单机', '/file/fileupload/1710225207116.css', '填单机-清明节皮肤', '1920x1080', '/file/fileupload/1710225207080.png', NULL, 0, '2024-03-12 14:33:27', 1, '2025-02-13 10:27:00'), (195, 4, 8, '填单机', '/file/fileupload/1710225282087.css', '填单机-劳动节皮肤', '1920x1080', '/file/fileupload/1710225282053.png', NULL, 0, '2024-03-12 14:34:42', 1, '2025-02-13 10:27:00'), (196, 7, 8, '填单机', '/file/fileupload/1710225353031.css', '填单机-国庆节皮肤', '1920x1080', '/file/fileupload/1710225353000.png', NULL, 0, '2024-03-12 14:35:53', 1, '2025-02-13 10:27:00'), (197, 5, 8, '填单机', '/file/fileupload/1710225438118.css', '填单机-端午节皮肤', '1920x1080', '/file/fileupload/1710225438062.png', NULL, 0, '2024-03-12 14:37:18', 1, '2025-02-13 10:27:00'), (198, 2, 8, '填单机', '/file/fileupload/skin/1735289910358.css', '填单机-春节皮肤（25年）', '1920x1080', '/file/fileupload/1735289909814.png', NULL, 0, '2024-03-12 14:38:47', 1, '2025-02-13 10:27:00'), (199, 1, 8, '填单机', '/file/fileupload/1710833776771.css', '填单机-标准版', '1920x1080', '/file/fileupload/1710833776735.png', NULL, 0, '2024-03-12 14:41:41', 1, '2025-02-13 10:27:00');
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_app_config
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_app_config`;
CREATE TABLE `mortals_xhx_app_config`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `siteName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '站点名称',
  `siteCode` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '站点编号',
  `appId` bigint(20) NULL DEFAULT NULL COMMENT '应用ID',
  `appCode` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '应用编码',
  `appName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '应用名称',
  `order` int(9) NULL DEFAULT NULL COMMENT '应用顺序',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '应用列';

-- ----------------------------
-- Records of mortals_xhx_app_config
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_app_config` VALUES (1, 1, NULL, NULL, 6, 'wllz01', '网络理政', 3, '2025-02-13 10:41:51', 1, '2025-02-13 10:41:51'), (2, 1, NULL, NULL, 4, 'bszn01', '办事指南', 2, '2025-02-13 10:41:51', 1, '2025-02-13 10:41:51'), (3, 1, NULL, NULL, 3, 'zwgk', '政务资讯', 4, '2025-02-13 10:41:51', 1, '2025-02-13 10:41:51'), (4, 1, NULL, NULL, 2, 'zxjj01', '中心简介', 1, '2025-02-13 10:41:51', 1, '2025-02-13 10:41:51');
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_area
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_area`;
CREATE TABLE `mortals_xhx_area`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键,自增长',
  `parentId` bigint(20) NULL DEFAULT NULL COMMENT '上级区域ID',
  `name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '区域名称',
  `level` tinyint(4) NULL DEFAULT NULL COMMENT '区域级别，按所处树的节点层次',
  `code` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '区域编码，按全国省市编码',
  `contactsPeople` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '区域负责人',
  `contactsMobile` varchar(21) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '区域负责人电话',
  `childSize` int(11) NULL DEFAULT 0 COMMENT '子区域数量，默认0',
  `maxChildId` int(11) NULL DEFAULT 0 COMMENT '子区域的最大ID，默认0',
  `status` tinyint(4) NULL DEFAULT 1 COMMENT '状态，0停用，1启用',
  `remark` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '描述',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户ID',
  `createUserName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '区域信息';

-- ----------------------------
-- Records of mortals_xhx_area
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_baseset
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_baseset`;
CREATE TABLE `mortals_xhx_baseset`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `printDisplay` int(4) NULL DEFAULT NULL COMMENT '空白打印材料展示数量',
  `newsSource` tinyint(4) NULL DEFAULT NULL COMMENT '新闻来源(1.热点新闻,2.本地要闻,3.政策发布,4.通知公告)',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 3 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '填单服务基础设置';

-- ----------------------------
-- Records of mortals_xhx_baseset
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_baseset` VALUES (1, 1, 10, 1, '2022-12-08 14:50:41', 1, '2024-05-21 14:57:05'), (2, 24, 20, 1, '2023-12-19 22:53:56', 1, '2023-12-20 18:59:19');
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_datum_info_field
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_datum_info_field`;
CREATE TABLE `mortals_xhx_datum_info_field`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `datum_print_id` bigint(20) NULL DEFAULT NULL COMMENT '填单打印id',
  `idCard` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '身份证号',
  `fieldCode` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '字段编码',
  `fieldName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '字段名称',
  `fieldType` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '字段类型（input.单行输入框,textarea.多行输入框,SELECT.下拉选项框,date.日期选择框,checkbox.多项选择框）',
  `fieldTypeValue` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字段类型值，当字段类型为多选，单选时候，预设复选值',
  `dataType` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '数据类型（number.数字,string.字符串,arrays.数组,obj.对象）',
  `fieldValue` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '字段值',
  `defaultValue` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '字段默认值',
  `fieldLen` int(9) NULL DEFAULT NULL COMMENT '数据长度，默认128',
  `fieldNull` tinyint(2) NULL DEFAULT NULL COMMENT '是否允许为空，(0.否,1.是)',
  `isList` tinyint(2) NULL DEFAULT NULL COMMENT '字段是否列表显示(0.否,1.是)',
  `fieldOrderNo` int(9) NULL DEFAULT NULL COMMENT '排序号',
  `remark` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  `updateUserId` bigint(20) NULL DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '填单用户信息字段';

-- ----------------------------
-- Records of mortals_xhx_datum_info_field
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_device
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_device`;
CREATE TABLE `mortals_xhx_device`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键ID，主键，自增长',
  `deviceId` bigint(20) NULL DEFAULT NULL COMMENT '设备id',
  `deviceName` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '设备名称',
  `deviceCode` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备编码',
  `deviceMac` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备的MAC地址',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点Id',
  `siteCode` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '站点编号，来源基础服务平台',
  `siteName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '站点名称',
  `deviceFirmId` bigint(20) NULL DEFAULT NULL COMMENT '设备生产厂商ID',
  `deviceFirmname` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备生产厂商名称',
  `ip` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备访问ip',
  `port` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '端口',
  `enabled` tinyint(2) NULL DEFAULT NULL COMMENT '启用状态 (0.停止，1.启用)',
  `productCode` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '产品编码',
  `productName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '产品名称',
  `deviceSrc` tinyint(2) NULL DEFAULT 2 COMMENT '设备来源(0.子设备，1.网关设备，2.直连设备)',
  `lon` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '经度',
  `lati` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '纬度',
  `leadingOfficial` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '负责人',
  `leadingOfficialTelephone` varchar(11) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '联系电话',
  `deviceStatus` tinyint(2) NULL DEFAULT NULL COMMENT '设备状态 (0.未激活，1.离线,2.在线)',
  `deviceRemark` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  `belong` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '所属机构',
  `onlineTime` datetime(0) NULL DEFAULT NULL COMMENT '最近上线时间',
  `offlineTime` datetime(0) NULL DEFAULT NULL COMMENT '最近离线时间',
  `source` tinyint(2) NULL DEFAULT 1 COMMENT '设备来源(0.旧设备，1.新设备)',
  `createUserId` bigint(20) NOT NULL COMMENT '创建用户',
  `createTime` datetime(0) NOT NULL COMMENT '创建时间',
  `updateUserId` bigint(20) NULL DEFAULT NULL COMMENT '更新用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '更新时间',
  `deviceInBuilding` tinyint(4) NULL DEFAULT NULL COMMENT '所属楼栋',
  `deviceInFloor` tinyint(4) NULL DEFAULT NULL COMMENT '所属楼层',
  `resolution` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '分辨率',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `deviceCode`(`deviceCode`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '设备';

-- ----------------------------
-- Records of mortals_xhx_device
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_device_matter_datum
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_device_matter_datum`;
CREATE TABLE `mortals_xhx_device_matter_datum`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `deviceId` bigint(20) NULL DEFAULT NULL COMMENT '设备id',
  `deviceCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备编码',
  `deviceName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '设备名称',
  `matterId` bigint(20) NULL DEFAULT NULL COMMENT '事项id',
  `matterCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项编码',
  `matterName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项名称',
  `materiaFullName` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项全称',
  `deptId` bigint(20) NULL DEFAULT NULL COMMENT '部门ID',
  `deptCode` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门编号',
  `deptName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门名称',
  `source` tinyint(2) NULL DEFAULT NULL COMMENT '事项来源(0.政务网，1.自定义)',
  `isRecommend` tinyint(2) NULL DEFAULT NULL COMMENT '是否推荐(0.未推荐，1.推荐)',
  `sort` int(4) NULL DEFAULT NULL COMMENT '排序',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '设备事项申请材料业务';

-- ----------------------------
-- Records of mortals_xhx_device_matter_datum
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_hotword
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_hotword`;
CREATE TABLE `mortals_xhx_hotword`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `hotwords` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '热门词汇',
  `searchCount` int(9) NULL DEFAULT NULL COMMENT '查询次数',
  `wordsSource` tinyint(4) NULL DEFAULT NULL COMMENT '热门词汇来源（1.手动添加,2.查询添加）',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '热门词汇业务';

-- ----------------------------
-- Records of mortals_xhx_hotword
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_hotword` VALUES (1, 1, '%%', 1, 1, '2025-01-22 15:43:31', 1, NULL);
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_idgenerator
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_idgenerator`;
CREATE TABLE `mortals_xhx_idgenerator`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `idType` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT 'id类型',
  `idMaxValue` bigint(20) UNSIGNED NOT NULL COMMENT 'id值',
  `remark` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '备注',
  `versionNum` bigint(20) UNSIGNED NOT NULL DEFAULT 0 COMMENT '版本号，默认0',
  `gmtModify` timestamp(0) NOT NULL DEFAULT CURRENT_TIMESTAMP(0) ON UPDATE CURRENT_TIMESTAMP(0) COMMENT '最后修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '主键Id生成器';

-- ----------------------------
-- Records of mortals_xhx_idgenerator
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_idgenerator` VALUES (1, 'INFO_VERSION_KEY', 1, '基础信息版本号生成因子', 0, '2019-04-18 18:00:00');
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_matter
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_matter`;
CREATE TABLE `mortals_xhx_matter`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `tid` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项id',
  `tcode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项code',
  `tname` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项name',
  `matterName` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项名称',
  `englishName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '英语事项名',
  `matterNo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项编号',
  `matterFullName` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项全称',
  `deptId` bigint(20) NULL DEFAULT NULL COMMENT '部门ID',
  `deptCode` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门编号',
  `deptName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门名称',
  `total` int(8) NULL DEFAULT NULL COMMENT '填单次数',
  `sort` int(4) NULL DEFAULT NULL COMMENT '排序',
  `isRecommend` tinyint(2) NULL DEFAULT NULL COMMENT '是否推荐(0.未推荐，1.推荐)',
  `source` tinyint(2) NULL DEFAULT NULL COMMENT '事项来源(0.手动添加，1.站点事项)',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '事项申请材料业务';

-- ----------------------------
-- Records of mortals_xhx_matter
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_matter_datum
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_matter_datum`;
CREATE TABLE `mortals_xhx_matter_datum`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `matterId` bigint(20) NULL DEFAULT NULL COMMENT '事项matter id',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `deptId` bigint(20) NULL DEFAULT NULL COMMENT '部门ID',
  `deptCode` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门编号',
  `deptName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门名称',
  `materialName` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '材料名',
  `materiaFullName` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '材料全名',
  `source` tinyint(2) NULL DEFAULT NULL COMMENT '事项来源(0.政务网，1.自定义)',
  `isRecommend` tinyint(2) NULL DEFAULT NULL COMMENT '是否推荐(0.未推荐，1.推荐)',
  `total` int(8) NULL DEFAULT NULL COMMENT '填单次数',
  `sort` int(4) NULL DEFAULT NULL COMMENT '排序',
  `samplePrint` int(4) NULL DEFAULT NULL COMMENT '样表次数',
  `fileName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '填单的附件名称',
  `fileUrl` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '填单的附件下载地址',
  `filePreViewUrl` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '附件预览地址',
  `sampleName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '样表名称',
  `samplePath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '样表地址',
  `templateName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '模板名称',
  `templatePath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '模板地址',
  `preViewPath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '样表预览地址',
  `formContent` mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '表单内容',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '事项申请材料业务';

-- ----------------------------
-- Records of mortals_xhx_matter_datum
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_matter_datum_print
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_matter_datum_print`;
CREATE TABLE `mortals_xhx_matter_datum_print`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点id',
  `orderId` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '打印订单',
  `matterId` bigint(20) NULL DEFAULT NULL COMMENT '事项id',
  `matterName` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '事项名称',
  `matterCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '事项编码',
  `deviceCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '设备编码',
  `deviceName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '设备名称',
  `idCard` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '身份证号',
  `idName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '身份证名称',
  `mobile` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '手机号码',
  `materialId` bigint(20) NULL DEFAULT NULL COMMENT '材料Id',
  `materialName` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '材料名',
  `printPage` int(8) NULL DEFAULT NULL COMMENT '材料页数',
  `type` tinyint(2) NULL DEFAULT NULL COMMENT '打印类型(1.本地打印,2.在线打印)',
  `docPath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '合成doc后地址',
  `page` int(9) NULL DEFAULT NULL,
  `formContent` mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '提交的表单',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '打印提交';

-- ----------------------------
-- Records of mortals_xhx_matter_datum_print
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_menu
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_menu`;
CREATE TABLE `mortals_xhx_menu`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '菜单ID，主键，自增长',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '菜单名称',
  `url` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '连接地址',
  `parentId` bigint(20) NULL DEFAULT NULL COMMENT '父菜单ID，一级菜单的该字段值为-1',
  `orderId` int(11) NULL DEFAULT NULL COMMENT '排序编号',
  `status` tinyint(2) NULL DEFAULT 1 COMMENT '菜单状态，0：禁用，1：启用，默认1',
  `linkType` tinyint(2) NULL DEFAULT 0 COMMENT '链接方式，0：普通，1：弹出，2：脚本（JavaScript），默认0',
  `groupId` int(11) NULL DEFAULT 1 COMMENT '分组编号，使用菜单分隔符按该值分隔，默认1',
  `groupName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `imgPath` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '主菜单图标，主菜单图标的css样式名',
  `buttonImgPath` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '按钮图标，按钮图标的css样式名',
  `imgCommPath` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '常用菜单图标，常用菜单图标的css样式名',
  `commMenu` tinyint(2) NULL DEFAULT 0 COMMENT '是否常用菜单，0：非常用，1：常用，默认0',
  `menuType` tinyint(2) NULL DEFAULT 0 COMMENT '菜单类型，0：主菜单，1：非主菜单(功能操作组)，默认0',
  `authType` tinyint(2) NULL DEFAULT 3 COMMENT '权限类型，0：无限制，1：无需登录查看，2：需要登录查看，3：需要角色权限查看，默认3',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `createUserName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 9113 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '菜单信息';

-- ----------------------------
-- Records of mortals_xhx_menu
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_menu` VALUES (91, '系统管理', '', 0, 9999, 1, 0, 0, NULL, 'setting', '', '', 0, 0, 3, NULL, NULL, ''), (108, '区域信息', '/area/list', 91, 65, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9001, '主页', '/index', 90, 10, 1, 0, 1, NULL, '', NULL, NULL, 0, 0, 3, '2019-02-19 16:08:09', 1, 'admin'), (9101, '用户信息', '/user/list', 91, 10, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9102, '角色信息', '/role/list', 91, 20, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9103, '资源信息', '/resource/list', 91, 30, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9104, '菜单信息', '/menu/list', 91, 40, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9105, '参数信息', '/param/list', 91, 50, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9106, '任务信息', '/task/list', 91, 60, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9107, '操作日志', '/oper/log/list', 91, 70, 1, 0, 0, NULL, NULL, NULL, NULL, 0, 0, 3, NULL, NULL, NULL), (9108, '基础事项业务', '/sheet/matter/list', 0, 1, 1, 0, 0, '', NULL, NULL, NULL, 0, 0, 1, NULL, NULL, NULL), (9109, '事项申请材料业务', '/matter/list', 0, 1, 1, 0, 0, '', NULL, NULL, NULL, 0, 0, 1, NULL, NULL, NULL), (9110, '事项材料公共库', '/pubdatum/list', 0, 1, 1, 0, 0, '', NULL, NULL, NULL, 0, 0, 1, NULL, NULL, NULL), (9111, '热门词汇业务', '/hotword/list', 0, 1, 1, 0, 0, '', NULL, NULL, NULL, 0, 0, 1, NULL, NULL, NULL), (9112, '事项申请材料业务', '/matter/datum/list', 0, 1, 1, 0, 0, '', NULL, NULL, NULL, 0, 0, 1, NULL, NULL, NULL);
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_oper_log
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_oper_log`;
CREATE TABLE `mortals_xhx_oper_log`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `platformMark` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '平台标识',
  `userId` bigint(20) NULL DEFAULT NULL COMMENT '用户id',
  `userName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户名称',
  `loginName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户登录名',
  `requestUrl` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '请求地址',
  `content` varchar(2000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '操作内容，记录操作具体信息，如修改前修改或的数据',
  `ip` varchar(30) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '操作IP地址',
  `logDate` datetime(0) NULL DEFAULT NULL COMMENT '操作时间',
  `operType` tinyint(2) NULL DEFAULT NULL COMMENT '操作类型，0：新增，1：修改，2：删除',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '操作日志';

-- ----------------------------
-- Records of mortals_xhx_oper_log
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_param
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_param`;
CREATE TABLE `mortals_xhx_param`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '参数名称',
  `firstOrganize` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '一级组织，如：平台配置',
  `secondOrganize` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '二级组织，如：基础配置',
  `paramKey` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '参数键，全局唯一',
  `paramValue` varchar(2000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '参数值',
  `validStatus` tinyint(2) NULL DEFAULT 1 COMMENT '参数有效状态，0：禁用，1：启用，默认1',
  `modStatus` tinyint(2) NULL DEFAULT 4 COMMENT '参数修改状态，0：隐藏，1：页面仅查看，2：页面可修改，3：页面可删除，4：页面可修改删除，默认4',
  `displayType` tinyint(2) NULL DEFAULT 0 COMMENT '展现类型，0：普通文本框，1：多行文本框，2：开关，3：块输入框，默认：0',
  `remark` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `createUserName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 101 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '参数信息';

-- ----------------------------
-- Records of mortals_xhx_param
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_param` VALUES (1, '服务对象 ', 'SheetMatter', 'appoveObjectShow', '事业法人.事业法人', '事业法人.事业法人', 1, 4, 0, 'appoveObjectShow', NULL, NULL, NULL), (2, '服务对象 ', 'SheetMatter', 'appoveObjectShow', '社会组织法人.社会组织法人', '社会组织法人.社会组织法人', 1, 4, 0, 'appoveObjectShow', NULL, NULL, NULL), (3, '服务对象 ', 'SheetMatter', 'appoveObjectShow', '非法人企业.非法人企业', '非法人企业.非法人企业', 1, 4, 0, 'appoveObjectShow', NULL, NULL, NULL), (4, '服务对象 ', 'SheetMatter', 'appoveObjectShow', '企业法人.企业法人', '企业法人.企业法人', 1, 4, 0, 'appoveObjectShow', NULL, NULL, NULL), (5, '服务对象 ', 'SheetMatter', 'appoveObjectShow', '自然人.自然人', '自然人.自然人', 1, 4, 0, 'appoveObjectShow', NULL, NULL, NULL), (6, '服务对象 ', 'SheetMatter', 'appoveObjectShow', '其他组织.其他组织', '其他组织.其他组织', 1, 4, 0, 'appoveObjectShow', NULL, NULL, NULL), (7, '通办范围 ', 'SheetMatter', 'operatScopeShow', '无.无', '无.无', 1, 4, 0, 'operatScopeShow', NULL, NULL, NULL), (8, '通办范围 ', 'SheetMatter', 'operatScopeShow', '全国.全国', '全国.全国', 1, 4, 0, 'operatScopeShow', NULL, NULL, NULL), (9, '通办范围 ', 'SheetMatter', 'operatScopeShow', '全市.全市', '全市.全市', 1, 4, 0, 'operatScopeShow', NULL, NULL, NULL), (10, '通办范围 ', 'SheetMatter', 'operatScopeShow', '全县.全县', '全县.全县', 1, 4, 0, 'operatScopeShow', NULL, NULL, NULL), (11, '通办范围 ', 'SheetMatter', 'operatScopeShow', '全镇[乡 街道].全镇[乡 街道]', '全镇[乡 街道].全镇[乡 街道]', 1, 4, 0, 'operatScopeShow', NULL, NULL, NULL), (12, '通办范围 ', 'SheetMatter', 'operatScopeShow', '跨村[社区].跨村[社区]', '跨村[社区].跨村[社区]', 1, 4, 0, 'operatScopeShow', NULL, NULL, NULL), (13, '办件类型', 'SheetMatter', 'appoveTimeLimitShow', '网络办件.网络办件', '网络办件.网络办件', 1, 4, 0, 'appoveTimeLimitShow', NULL, NULL, NULL), (14, '办件类型', 'SheetMatter', 'appoveTimeLimitShow', '行政审批一般件.行政审批一般件', '行政审批一般件.行政审批一般件', 1, 4, 0, 'appoveTimeLimitShow', NULL, NULL, NULL), (15, '办件类型', 'SheetMatter', 'appoveTimeLimitShow', '综合窗口件.综合窗口件', '综合窗口件.综合窗口件', 1, 4, 0, 'appoveTimeLimitShow', NULL, NULL, NULL), (16, '办理形式', 'SheetMatter', 'handleType', '窗口办理.窗口办理', '窗口办理.窗口办理', 1, 4, 0, 'handleType', NULL, NULL, NULL), (17, '办理形式', 'SheetMatter', 'handleType', '网上办理.网上办理', '网上办理.网上办理', 1, 4, 0, 'handleType', NULL, NULL, NULL), (18, '是否收费', 'SheetMatter', 'isChargesShow', '否.否', '否.否', 1, 4, 0, 'isChargesShow', NULL, NULL, NULL), (19, '是否收费', 'SheetMatter', 'isChargesShow', '是.是', '是.是', 1, 4, 0, 'isChargesShow', NULL, NULL, NULL), (20, '认证等级需求', 'SheetMatter', 'certificationLevelsShow', '实名认证.实名认证', '实名认证.实名认证', 1, 4, 0, 'certificationLevelsShow', NULL, NULL, NULL), (21, '认证等级需求', 'SheetMatter', 'certificationLevelsShow', '单次面签.单次面签', '单次面签.单次面签', 1, 4, 0, 'certificationLevelsShow', NULL, NULL, NULL), (22, '认证等级需求', 'SheetMatter', 'certificationLevelsShow', '每次面签.每次面签', '每次面签.每次面签', 1, 4, 0, 'certificationLevelsShow', NULL, NULL, NULL), (23, '是否网上预约,窗口办理选', 'SheetMatter', 'isOnlineSubscribeShow', '否.否', '否.否', 1, 4, 0, 'isOnlineSubscribeShow', NULL, NULL, NULL), (24, '是否网上预约,窗口办理选', 'SheetMatter', 'isOnlineSubscribeShow', '是.是', '是.是', 1, 4, 0, 'isOnlineSubscribeShow', NULL, NULL, NULL), (25, '物流快递,窗口办理选', 'SheetMatter', 'isExpressTakeShow', '否.否', '否.否', 1, 4, 0, 'isExpressTakeShow', NULL, NULL, NULL), (26, '物流快递,窗口办理选', 'SheetMatter', 'isExpressTakeShow', '是.是', '是.是', 1, 4, 0, 'isExpressTakeShow', NULL, NULL, NULL), (27, '是否支持全省范围就近取件', 'SheetMatter', 'isProvinceAcquisitionShow', '否.否', '否.否', 1, 4, 0, 'isProvinceAcquisitionShow', NULL, NULL, NULL), (28, '是否支持全省范围就近取件', 'SheetMatter', 'isProvinceAcquisitionShow', '是.是', '是.是', 1, 4, 0, 'isProvinceAcquisitionShow', NULL, NULL, NULL), (29, '是否支持全省范围就近办理', 'SheetMatter', 'isApplyProvinceShow', '否.否', '否.否', 1, 4, 0, 'isApplyProvinceShow', NULL, NULL, NULL), (30, '是否支持全省范围就近办理', 'SheetMatter', 'isApplyProvinceShow', '是.是', '是.是', 1, 4, 0, 'isApplyProvinceShow', NULL, NULL, NULL), (31, '网办类型', 'SheetMatter', 'onlineType', '原件预审.原件预审', '原件预审.原件预审', 1, 4, 0, 'onlineType', NULL, NULL, NULL), (32, '网办类型', 'SheetMatter', 'onlineType', '原件核验.原件核验', '原件核验.原件核验', 1, 4, 0, 'onlineType', NULL, NULL, NULL), (33, '网办类型', 'SheetMatter', 'onlineType', '全程网办.全程网办', '全程网办.全程网办', 1, 4, 0, 'onlineType', NULL, NULL, NULL), (34, '网络办理深度', 'SheetMatter', 'onlineOperatDeep', '互联网咨询.互联网咨询', '互联网咨询.互联网咨询', 1, 4, 0, 'onlineOperatDeep', NULL, NULL, NULL), (35, '网络办理深度', 'SheetMatter', 'onlineOperatDeep', '互联网收件.互联网收件', '互联网收件.互联网收件', 1, 4, 0, 'onlineOperatDeep', NULL, NULL, NULL), (36, '网络办理深度', 'SheetMatter', 'onlineOperatDeep', '互联网预审.互联网预审', '互联网预审.互联网预审', 1, 4, 0, 'onlineOperatDeep', NULL, NULL, NULL), (37, '网络办理深度', 'SheetMatter', 'onlineOperatDeep', '互联网受理.互联网受理', '互联网受理.互联网受理', 1, 4, 0, 'onlineOperatDeep', NULL, NULL, NULL), (38, '网络办理深度', 'SheetMatter', 'onlineOperatDeep', '互联网办理.互联网办理', '互联网办理.互联网办理', 1, 4, 0, 'onlineOperatDeep', NULL, NULL, NULL), (39, '网络办理深度', 'SheetMatter', 'onlineOperatDeep', '互联网办理结果信息反馈.互联网办理结果信息反馈', '互联网办理结果信息反馈.互联网办理结果信息反馈', 1, 4, 0, 'onlineOperatDeep', NULL, NULL, NULL), (40, '网络办理深度', 'SheetMatter', 'onlineOperatDeep', '其他.其他', '其他.其他', 1, 4, 0, 'onlineOperatDeep', NULL, NULL, NULL), (41, '物流快递，网上办理选', 'SheetMatter', 'isExpressTakeOnlineShow', '否.否', '否.否', 1, 4, 0, 'isExpressTakeOnlineShow', NULL, NULL, NULL), (42, '物流快递，网上办理选', 'SheetMatter', 'isExpressTakeOnlineShow', '是.是', '是.是', 1, 4, 0, 'isExpressTakeOnlineShow', NULL, NULL, NULL), (43, '是否支持上门收取申请', 'SheetMatter', 'isDoorTakeShow', '否.否', '否.否', 1, 4, 0, 'isDoorTakeShow', NULL, NULL, NULL), (44, '是否支持上门收取申请', 'SheetMatter', 'isDoorTakeShow', '是.是', '是.是', 1, 4, 0, 'isDoorTakeShow', NULL, NULL, NULL), (45, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政许可.行政许可', '行政许可.行政许可', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (46, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政处罚.行政处罚', '行政处罚.行政处罚', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (47, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政强制.行政强制', '行政强制.行政强制', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (48, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政征收.行政征收', '行政征收.行政征收', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (49, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政给付.行政给付', '行政给付.行政给付', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (50, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政检查.行政检查', '行政检查.行政检查', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (51, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政确认.行政确认', '行政确认.行政确认', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (52, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政奖励.行政奖励', '行政奖励.行政奖励', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (53, '事项类型名称', 'SheetMatter', 'eventTypeShow', '行政裁决.行政裁决', '行政裁决.行政裁决', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (54, '事项类型名称', 'SheetMatter', 'eventTypeShow', '其他行政权力.其他行政权力', '其他行政权力.其他行政权力', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (55, '事项类型名称', 'SheetMatter', 'eventTypeShow', '主动服务.主动服务', '主动服务.主动服务', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (56, '事项类型名称', 'SheetMatter', 'eventTypeShow', '依申请服务.依申请服务', '依申请服务.依申请服务', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (57, '事项类型名称', 'SheetMatter', 'eventTypeShow', '咨询查询.咨询查询', '咨询查询.咨询查询', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (58, '事项类型名称', 'SheetMatter', 'eventTypeShow', '未归类事项.未归类事项', '未归类事项.未归类事项', 1, 4, 0, 'eventTypeShow', NULL, NULL, NULL), (59, '行使层级名称', 'SheetMatter', 'performHierarchyShow', '省级.省级', '省级.省级', 1, 4, 0, 'performHierarchyShow', NULL, NULL, NULL), (60, '行使层级名称', 'SheetMatter', 'performHierarchyShow', '市级.市级', '市级.市级', 1, 4, 0, 'performHierarchyShow', NULL, NULL, NULL), (61, '行使层级名称', 'SheetMatter', 'performHierarchyShow', '县级.县级', '县级.县级', 1, 4, 0, 'performHierarchyShow', NULL, NULL, NULL), (62, '行使层级名称', 'SheetMatter', 'performHierarchyShow', '镇[乡 街道].镇[乡 街道]', '镇[乡 街道].镇[乡 街道]', 1, 4, 0, 'performHierarchyShow', NULL, NULL, NULL), (63, '行使层级名称', 'SheetMatter', 'performHierarchyShow', '村[社区]级.村[社区]级', '村[社区]级.村[社区]级', 1, 4, 0, 'performHierarchyShow', NULL, NULL, NULL), (64, '权力来源', 'SheetMatter', 'powerSourceShow', '法定本级行使.法定本级行使', '法定本级行使.法定本级行使', 1, 4, 0, 'powerSourceShow', NULL, NULL, NULL), (65, '权力来源', 'SheetMatter', 'powerSourceShow', '上级下放.上级下放', '上级下放.上级下放', 1, 4, 0, 'powerSourceShow', NULL, NULL, NULL), (66, '权力来源', 'SheetMatter', 'powerSourceShow', '上级授权.上级授权', '上级授权.上级授权', 1, 4, 0, 'powerSourceShow', NULL, NULL, NULL), (67, '权力来源', 'SheetMatter', 'powerSourceShow', '同级授权.同级授权', '同级授权.同级授权', 1, 4, 0, 'powerSourceShow', NULL, NULL, NULL), (68, '权力来源', 'SheetMatter', 'powerSourceShow', '上级委托.上级委托', '上级委托.上级委托', 1, 4, 0, 'powerSourceShow', NULL, NULL, NULL), (69, '权力来源', 'SheetMatter', 'powerSourceShow', '同级委托.同级委托', '同级委托.同级委托', 1, 4, 0, 'powerSourceShow', NULL, NULL, NULL), (70, '实施主体性质', 'SheetMatter', 'performDeptTypeShow', '法定机关.法定机关', '法定机关.法定机关', 1, 4, 0, 'performDeptTypeShow', NULL, NULL, NULL), (71, '实施主体性质', 'SheetMatter', 'performDeptTypeShow', '授权组织.授权组织', '授权组织.授权组织', 1, 4, 0, 'performDeptTypeShow', NULL, NULL, NULL), (72, '实施主体性质', 'SheetMatter', 'performDeptTypeShow', '受委托组织.受委托组织', '受委托组织.受委托组织', 1, 4, 0, 'performDeptTypeShow', NULL, NULL, NULL), (73, '是否进驻中心', 'SheetMatter', 'goveServiceCenterShow', '否.否', '否.否', 1, 4, 0, 'goveServiceCenterShow', NULL, NULL, NULL), (74, '是否进驻中心', 'SheetMatter', 'goveServiceCenterShow', '是.是', '是.是', 1, 4, 0, 'goveServiceCenterShow', NULL, NULL, NULL), (75, '是否纳入便民服务中心', 'SheetMatter', 'isConvenientCenterShow', '否.否', '否.否', 1, 4, 0, 'isConvenientCenterShow', NULL, NULL, NULL), (76, '是否纳入便民服务中心', 'SheetMatter', 'isConvenientCenterShow', '是.是', '是.是', 1, 4, 0, 'isConvenientCenterShow', NULL, NULL, NULL), (77, '自助终端办理 ', 'SheetMatter', 'terminalHandle', '否.否', '否.否', 1, 4, 0, 'terminalHandle', NULL, NULL, NULL), (78, '自助终端办理 ', 'SheetMatter', 'terminalHandle', '是.是', '是.是', 1, 4, 0, 'terminalHandle', NULL, NULL, NULL), (79, '是否网办 ', 'SheetMatter', 'isOnline', '否.否', '否.否', 1, 4, 0, 'isOnline', NULL, NULL, NULL), (80, '是否网办 ', 'SheetMatter', 'isOnline', '是.是', '是.是', 1, 4, 0, 'isOnline', NULL, NULL, NULL), (81, '支持网上支付', 'SheetMatter', 'isOnlinePayShow', '否.否', '否.否', 1, 4, 0, 'isOnlinePayShow', NULL, NULL, NULL), (82, '支持网上支付', 'SheetMatter', 'isOnlinePayShow', '是.是', '是.是', 1, 4, 0, 'isOnlinePayShow', NULL, NULL, NULL), (83, '委托部门', 'SheetMatter', 'entrustmentDepartmen', '否.否', '否.否', 1, 4, 0, 'entrustmentDepartmen', NULL, NULL, NULL), (84, '委托部门', 'SheetMatter', 'entrustmentDepartmen', '是.是', '是.是', 1, 4, 0, 'entrustmentDepartmen', NULL, NULL, NULL), (85, '事项状态', 'SheetMatter', 'matterStatus', '停用.停用', '停用.停用', 1, 4, 0, 'matterStatus', NULL, NULL, NULL), (86, '事项状态', 'SheetMatter', 'matterStatus', '在用.在用', '在用.在用', 1, 4, 0, 'matterStatus', NULL, NULL, NULL), (87, '事项来源', 'SheetMatter', 'source', '0', '政务网', 1, 4, 0, 'source', NULL, NULL, NULL), (88, '事项来源', 'SheetMatter', 'source', '1', '自定义', 1, 4, 0, 'source', NULL, NULL, NULL), (89, '是否推荐', 'Matter', 'isRecommend', '0', '未推荐', 1, 4, 0, 'isRecommend', NULL, NULL, NULL), (90, '是否推荐', 'Matter', 'isRecommend', '1', '推荐', 1, 4, 0, 'isRecommend', NULL, NULL, NULL), (91, '事项来源', 'Matter', 'source', '0', '手动添加', 1, 4, 0, 'source', NULL, NULL, NULL), (92, '事项来源', 'Matter', 'source', '1', '站点事项', 1, 4, 0, 'source', NULL, NULL, NULL), (93, '事项来源', 'MatterDatum', 'source', '0', '政务网', 1, 4, 0, 'source', NULL, NULL, NULL), (94, '事项来源', 'MatterDatum', 'source', '1', '自定义', 1, 4, 0, 'source', NULL, NULL, NULL), (95, '是否推荐', 'MatterDatum', 'isRecommend', '0', '未推荐', 1, 4, 0, 'isRecommend', NULL, NULL, NULL), (96, '是否推荐', 'MatterDatum', 'isRecommend', '1', '推荐', 1, 4, 0, 'isRecommend', NULL, NULL, NULL), (97, 'php通知公告	', NULL, NULL, 'notice_url', 'http://172.15.28.116:8090/api/', 1, 4, 0, NULL, NULL, NULL, NULL), (98, '终端应用', 'MatterDatum', 'defaultValue', 'white_app_list', '中心简介,办事指南,网络理政,办件查询', 1, 4, 0, 'defaultValue', '2023-05-14 14:08:11', 1, '系统管理员'), (100, '推荐个数', '', '', 'recommend_count', '50', 1, 4, 0, '', '2023-12-07 17:49:06', 1, '系统管理员');
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_pubdatum
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_pubdatum`;
CREATE TABLE `mortals_xhx_pubdatum`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键，自增长',
  `matterId` bigint(20) NULL DEFAULT NULL COMMENT '事项matter id',
  `deptId` bigint(20) NULL DEFAULT NULL COMMENT '部门ID',
  `deptCode` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门编号',
  `deptName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门名称',
  `materialName` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '材料名',
  `materiaFullName` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '材料全名',
  `total` int(8) NULL DEFAULT NULL COMMENT '填单次数',
  `sort` int(4) NULL DEFAULT NULL COMMENT '排序',
  `fileName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `fileUrl` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `filePreViewUrl` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `sampleName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '样表名称',
  `samplePath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '样表地址',
  `templateName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '模板名称',
  `templatePath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '模板地址',
  `preViewPath` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '样表预览地址',
  `formContent` mediumtext CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '表单内容',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '事项材料公共库';

-- ----------------------------
-- Records of mortals_xhx_pubdatum
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_resource
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_resource`;
CREATE TABLE `mortals_xhx_resource`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '菜单ID，主键，自增长',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '名称',
  `url` varchar(2000) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '连接地址，多个地址以逗号分隔',
  `authType` tinyint(2) NULL DEFAULT 3 COMMENT '权限类型，0：无限制，1：无需登录查看，2：需要登录查看，3：需要角色权限查看，默认3',
  `sourceType` tinyint(2) NULL DEFAULT 0 COMMENT '资源类型，0：系统资源，1：开放资源，默认0',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `createUserName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户名称',
  `userType` tinyint(2) NULL DEFAULT NULL COMMENT '用户类型，0：系统用户 1:代理商用户 2:品牌商用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 150012 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '资源信息';

-- ----------------------------
-- Records of mortals_xhx_resource
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_resource` VALUES (101001, '系统管理-菜单管理-查看', '/menu/list,/menu/view', 3, 0, NULL, NULL, NULL, 0), (101002, '系统管理-菜单管理-维护', '/menu/add,/menu/edit,/menu/delete,/menu/save', 3, 0, NULL, NULL, NULL, 0), (101003, '系统管理-角色管理-查看', '/role/list,/role/view', 3, 0, NULL, NULL, NULL, 0), (101004, '系统管理-角色管理-维护', '/role/add,/role/edit,/role/save,/role/delete,/role/auth/list,/role/auth/distributionSource,/role/user/distributionUser,/user/list,/role/user/list,/role/user/distributionUser', 3, 0, NULL, NULL, NULL, 0), (101005, '系统管理-用户管理-查看', '/user/list,/user/view,/role/roleNameByUserId', 3, 0, NULL, NULL, NULL, 0), (101006, '系统管理-用户管理-维护', '/user/add,/user/edit,/user/delete,/user/save', 3, 0, NULL, NULL, NULL, 0), (101007, '系统管理-任务设置-查看', '/task/list,/task/view', 3, 0, NULL, NULL, NULL, 0), (101008, '系统管理-任务设置-维护', '/task/add,/task/edit,/task/delete,/task/save', 3, 0, NULL, NULL, NULL, 0), (101009, '系统管理-参数设置-查看', '/param/list,/param/view', 3, 0, NULL, NULL, NULL, 0), (101010, '系统管理-参数设置-维护', '/param/add,/param/edit,/param/delete,/param/save', 3, 0, NULL, NULL, NULL, 0), (101011, '系统管理-资源管理-查看', '/resource/list,/resource/view', 3, 0, NULL, NULL, NULL, 0), (101012, '系统管理-资源管理-维护', '/resource/add,/resource/edit,/resource/delete,/resource/save', 3, 0, NULL, NULL, NULL, 0), (101013, '系统管理-操作日志-查看', '/oper/log/list,/oper/log/view', 3, 0, NULL, NULL, NULL, 0), (101014, '系统管理-区域管理-查看', '/area/list,/area/view', 3, 0, NULL, NULL, NULL, 0), (101015, '系统管理-区域管理-维护', '/area/add,/area/edit,/area/delete,/area/save', 3, 0, NULL, NULL, NULL, 0), (150000, '控制台-主页', '/index', 3, 0, '2019-06-01 13:04:18', 1, '系统管理员', NULL), (150001, '公共资源', '/area/list', 2, 0, '2019-06-01 23:56:55', 1, '系统管理员', NULL), (150002, '基础事项业务-菜单管理-查看', '/sheet/matter/list,/sheet/matter/view,/sheet/matter/info,/sheet/matter/export,/sheet/matter/exportExcel,/sheet/matter/downloadTemplate,/sheet/matter/download', 3, 0, NULL, NULL, NULL, 0), (150003, '基础事项业务-菜单管理-维护', '/sheet/matter/add,/sheet/matter/edit,/sheet/matter/delete,/sheet/matter/logicDelete,/sheet/matter/save,/sheet/matter/importData', 3, 0, NULL, NULL, NULL, 0), (150004, '事项申请材料业务-菜单管理-查看', '/matter/list,/matter/view,/matter/info,/matter/export,/matter/exportExcel,/matter/downloadTemplate,/matter/download', 3, 0, NULL, NULL, NULL, 0), (150005, '事项申请材料业务-菜单管理-维护', '/matter/add,/matter/edit,/matter/delete,/matter/logicDelete,/matter/save,/matter/importData', 3, 0, NULL, NULL, NULL, 0), (150006, '事项材料公共库-菜单管理-查看', '/pubdatum/list,/pubdatum/view,/pubdatum/info,/pubdatum/export,/pubdatum/exportExcel,/pubdatum/downloadTemplate,/pubdatum/download', 3, 0, NULL, NULL, NULL, 0), (150007, '事项材料公共库-菜单管理-维护', '/pubdatum/add,/pubdatum/edit,/pubdatum/delete,/pubdatum/logicDelete,/pubdatum/save,/pubdatum/importData', 3, 0, NULL, NULL, NULL, 0), (150008, '热门词汇业务-菜单管理-查看', '/hotword/list,/hotword/view,/hotword/info,/hotword/export,/hotword/exportExcel,/hotword/downloadTemplate,/hotword/download', 3, 0, NULL, NULL, NULL, 0), (150009, '热门词汇业务-菜单管理-维护', '/hotword/add,/hotword/edit,/hotword/delete,/hotword/logicDelete,/hotword/save,/hotword/importData', 3, 0, NULL, NULL, NULL, 0), (150010, '事项申请材料业务-菜单管理-查看', '/matter/datum/list,/matter/datum/view,/matter/datum/info,/matter/datum/export,/matter/datum/exportExcel,/matter/datum/downloadTemplate,/matter/datum/download', 3, 0, NULL, NULL, NULL, 0), (150011, '事项申请材料业务-菜单管理-维护', '/matter/datum/add,/matter/datum/edit,/matter/datum/delete,/matter/datum/logicDelete,/matter/datum/save,/matter/datum/importData', 3, 0, NULL, NULL, NULL, 0);
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_role
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_role`;
CREATE TABLE `mortals_xhx_role`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `name` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '角色名称',
  `remark` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  `roleType` tinyint(2) NULL DEFAULT 2 COMMENT '角色类型，0：系统内置角色（不可删除），1：默认系统角色，2：普通角色，默认2',
  `customerId` bigint(20) NULL DEFAULT NULL COMMENT '归属客户ID',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `createUserName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户名称',
  `userType` tinyint(2) NULL DEFAULT NULL COMMENT '用户类型，0：系统用户 1:代理商用户 2:品牌商用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '角色信息';

-- ----------------------------
-- Records of mortals_xhx_role
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_role` VALUES (1, '管理员', '类似admin', 0, NULL, '2019-03-04 11:41:06', 1, 'admin', NULL);
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_role_auth
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_role_auth`;
CREATE TABLE `mortals_xhx_role_auth`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `roleId` bigint(20) NULL DEFAULT NULL COMMENT '角色ID',
  `resourceId` bigint(20) NULL DEFAULT NULL COMMENT '资源ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '角色资源权限';

-- ----------------------------
-- Records of mortals_xhx_role_auth
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_role_user
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_role_user`;
CREATE TABLE `mortals_xhx_role_user`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `roleId` bigint(20) NULL DEFAULT NULL COMMENT '角色ID',
  `userId` bigint(20) NULL DEFAULT NULL COMMENT '用户ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 40 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '角色用户';

-- ----------------------------
-- Records of mortals_xhx_role_user
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_role_user` VALUES (35, 1, 36), (36, 1, 37), (37, 1, 38), (38, 1, 39), (39, 1, 40);
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_sheet_matter
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_sheet_matter`;
CREATE TABLE `mortals_xhx_sheet_matter`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `siteId` bigint(20) NULL DEFAULT NULL COMMENT '站点ID',
  `tid` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项id',
  `tcode` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项code',
  `tname` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '从政务系统来的事项name',
  `matterName` varchar(2048) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项名称',
  `englishName` varchar(256) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '英语事项名',
  `matterNo` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项编号',
  `areaCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '区域编码',
  `deptCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门编号',
  `deptName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '部门名称',
  `powerCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '行政权力编号',
  `themeCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '主题编号',
  `usertypeCode` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '服务类型编号',
  `groupName` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项组名',
  `url` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项详情链接',
  `haveGetMatterInfo` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否获取事项详情',
  `belongDept` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '所属部门',
  `appoveObjectShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '服务对象 （事业法人.事业法人，社会组织法人.社会组织法人，非法人企业.非法人企业，企业法人.企业法人，自然人.自然人，其他组织.其他组织）',
  `operatScopeShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '通办范围 （无.无，全国.全国，全市.全市，全县.全县，全镇[乡 街道].全镇[乡 街道]，跨村[社区].跨村[社区]）',
  `appoveTimeLimitShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办件类型（网络办件.网络办件，行政审批一般件.行政审批一般件，综合窗口件.综合窗口件）',
  `handleType` varchar(12) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理形式（窗口办理.窗口办理，网上办理.网上办理）	',
  `legalTimeLimitShow` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '法定办结时限',
  `legalEndExplain` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '法定时限办结说明',
  `promiseTimeLimitShow` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '承诺办结时限',
  `promiseEndExplain` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '承诺时限办结说明',
  `isChargesShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否收费（否.否，是.是）',
  `certificationLevelsShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '认证等级需求（实名认证.实名认证，单次面签.单次面签，每次面签.每次面签）',
  `planTakeTime` datetime(0) NULL DEFAULT NULL COMMENT '计划生效日期',
  `promiseTakeTime` datetime(0) NULL DEFAULT NULL COMMENT '承诺生效日期',
  `specialProcedure` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '特别程序',
  `windowToTheSceneNum` tinyint(2) NULL DEFAULT NULL COMMENT '窗口到现场次数',
  `isOnlineSubscribeShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否网上预约,窗口办理选（否.否，是.是）',
  `isExpressTakeShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物流快递,窗口办理选（否.否，是.是）',
  `isProvinceAcquisitionShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否支持全省范围就近取件（否.否，是.是）',
  `isApplyProvinceShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否支持全省范围就近办理（否.否，是.是）',
  `mustSceneExplain` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '必须到现场原因',
  `onlineType` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '网办类型（原件预审.原件预审，原件核验.原件核验，全程网办.全程网办）',
  `onlineToTheSceneNum` tinyint(2) NULL DEFAULT NULL COMMENT '网办到现场次数',
  `onlineOperatDeep` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '网络办理深度（互联网咨询.互联网咨询，互联网收件.互联网收件，互联网预审.互联网预审，互联网受理.互联网受理，互联网办理.互联网办理，互联网办理结果信息反馈.互联网办理结果信息反馈，其他.其他）',
  `isExpressTakeOnlineShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '物流快递，网上办理选（否.否，是.是）',
  `isDoorTakeShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否支持上门收取申请（否.否，是.是）',
  `onlineMustSceneExplain` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '网上必须到现场原因',
  `performDeptType` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施主体',
  `matterEdition` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项版本',
  `eventTypeShow` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项类型名称（行政许可.行政许可，行政处罚.行政处罚，行政强制.行政强制，行政征收.行政征收，行政给付.行政给付，行政检查.行政检查，行政确认.行政确认，行政奖励.行政奖励，行政裁决.行政裁决，其他行政权力.其他行政权力，主动服务.主动服务，依申请服务.依申请服务，咨询查询.咨询查询，未归类事项.未归类事项）',
  `performHierarchyShow` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '行使层级名称（省级.省级，市级.市级，县级.县级，镇[乡 街道].镇[乡 街道]，村[社区]级.村[社区]级）',
  `powerSourceShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '权力来源（法定本级行使.法定本级行使，上级下放.上级下放，上级授权.上级授权，同级授权.同级授权，上级委托.上级委托，同级委托.同级委托）',
  `performDeptTypeShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施主体性质（法定机关.法定机关，授权组织.授权组织，受委托组织.受委托组织）',
  `goveServiceCenterShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否进驻中心（否.否，是.是）',
  `isConvenientCenterShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否纳入便民服务中心（否.否，是.是）',
  `terminalHandle` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '自助终端办理 （否.否，是.是）',
  `isOnline` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '是否网办 （否.否，是.是）',
  `isOnlinePayShow` varchar(16) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '支持网上支付（否.否，是.是）',
  `entrustmentDepartmen` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '委托部门（否.否，是.是）',
  `jointInfoShow` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '联办机构',
  `matterStatus` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '事项状态（停用.停用，在用.在用）',
  `numberLimit` int(11) NULL DEFAULT NULL COMMENT '数量限制',
  `type` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '主题类型',
  `baseCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '基本编码',
  `implementCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施编码',
  `implementBodyCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '实施主体编码',
  `operateItemCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理项编码',
  `townshipName` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '乡镇街道名称',
  `townshipCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '乡镇街道代码',
  `villageName` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '村居社区名称',
  `villageCode` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '村居社区代码',
  `operateTime` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理时间',
  `operateSite` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '办理地点',
  `cousultingShow` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '咨询方式',
  `cousultingTelephoneShow` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '咨询电话',
  `superviseShow` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '监督投诉方式',
  `sort` int(4) NULL DEFAULT NULL COMMENT '排序',
  `source` tinyint(2) NULL DEFAULT NULL COMMENT '事项来源(0.政务网，1.自定义)',
  `evaluationUrl` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '评价地址',
  `netApplyUrl` varchar(1024) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '申请地址',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE INDEX `matterarea`(`matterNo`, `areaCode`) USING BTREE,
  INDEX `area`(`areaCode`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1410 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '基础事项';

-- ----------------------------
-- Records of mortals_xhx_sheet_matter
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_sheet_matter` VALUES (1, 1, NULL, '', '', '公众聚集场所投入使用、营业前消防安全检查', '', '511A0021300001-510800000000-000-11510700MB1A206199-1-00', NULL, '4052473562718871552', '市消防救援支队', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (2, 1, NULL, '', '', '残疾人教育资助申请', '', '512B0569600000-510800000000-000-1351070045126761XG-null-00', NULL, '45126761X', '市残联', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (3, 1, NULL, '', '', '盲人保健按摩培训申请', '', '512B0569700000-510800000000-000-1351070045126761XG-null-00', NULL, '45126761X', '市残联', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (4, 1, NULL, '', '', '残疾人托养服务申请', '', '512B0569500000-510800000000-000-1351070045126761XG-null-00', NULL, '45126761X', '市残联', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (5, 1, NULL, '', '', '全国残疾人按比例就业情况联网认证', '', '511F0045400001-510800000000-000-1351070045126761XG-1-00', NULL, '45126761X', '市残联', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (6, 1, NULL, '', '', '对建设工程的抗震设防要求的审查备案(市级)', '', '511Z78006001-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (7, 1, NULL, '', '', '煤矿建设项目核准', '', '511A0098300001-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (8, 1, NULL, '', '', '煤矿建设项目设计审查（含设计修改）', '', '511A0098400001-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (9, 1, NULL, '', '', '生产经营单位生产安全事故应急预案备案', '', '511Z25396001-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (10, 1, NULL, '', '', '危险化学品建设项目安全许可（安全设施设计审查）', '', '511A0097800001-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (11, 1, NULL, '', '', '危险物品的生产、经营、储存单位以及矿山、金属冶炼单位主要负责人和安全生产管理人员安全生产知识和管理能力考核发证', '', '511F25001001-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (12, 1, NULL, '', '', '危险化学品建设项目安全许可（安全条件审查）', '', '511A0097700001-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (13, 1, NULL, '', '', '建设工程专用地震监测台网建设方案审查及强震动设施设置方案审查(市级)', '', '511Z78004002-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (14, 1, NULL, '', '', '地震活动断层信息服务', '', '51209928600084-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (15, 1, NULL, '', '', '烟花爆竹经营（批发）许可证变更申请', '', '511A0007600005-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (16, 1, NULL, '', '', '烟花爆竹经营（批发）许可证首次申请', '', '511A0007600009-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (17, 1, NULL, '', '', '烟花爆竹经营（批发）许可证延期申请', '', '511A0007600010-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (18, 1, NULL, '', '', '从事剧毒、易制爆、汽油加油站、专用危化品仓储的企业，中央企业所属省级、设区的市级公司（分公司）从事危险化学品经营活动的企业，带有储存设施经营除剧毒化学品、易制爆危险化学品以外的其他危险化学品的企业经营许可证变更审查', '', '511A0007500007-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (19, 1, NULL, '', '', '危险化学品经营许可证核发', '', '511A0007500014-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (20, 1, NULL, '', '', '危险化学品经营许可证延期审查', '', '511A0007500009-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (21, 1, NULL, '', '', '危险化学品安全使用许可证首次申请', '', '511A0006800009-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (22, 1, NULL, '', '', '危险化学品安全使用许可证变更审查', '', '511A0006800005-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (23, 1, NULL, '', '', '危险化学品安全使用许可证延期审查', '', '511A0006800003-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (24, 1, NULL, '', '', '金属非金属矿山、尾矿库、石油天然气新建、改建、扩建建设项目', '', '511A0007200004-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (25, 1, NULL, '', '', '金属非金属矿产资源地质勘探坑探工程项目', '', '511A0007200005-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (26, 1, NULL, '', '', '二、三类非药品类易制毒化学品生产备案', '', '511Z25392003-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (27, 1, NULL, '', '', '二类非药品类易制毒化学品经营备案', '', '511Z25392002-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (28, 1, NULL, '', '', '危险化学品生产企业安全生产许可首次申请', '', '511A0007400008-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (29, 1, NULL, '', '', '危险化学品生产企业安全生产许可证延期', '', '511A0007400010-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (30, 1, NULL, '', '', '危险化学品生产企业安全生产许可证变更', '', '511A0007400005-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (31, 1, NULL, '', '', '生产、储存烟花爆竹建设项目安全设施设计审查', '', '511A0097600001-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (32, 1, NULL, '', '', '应急管理信息查询', '', '512025394002-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (33, 1, NULL, '', '', '工矿商贸企业安全生产标准化达标认定', '', '512B0362600004-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (34, 1, NULL, '', '', '金属冶炼建设项目安全设施设计审查', '', '511A0097400001-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (35, 1, NULL, '', '', '特种作业操作证延期复审', '', '511A25012003-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (36, 1, NULL, '', '', '特种作业操作资格证复审', '', '511A25012002-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (37, 1, NULL, '', '', '特种作业操作证初次申领', '', '511A0097500001-510800000000-000-11510700MB1733417D-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (38, 1, NULL, '', '', '非煤矿山企业安全生产许可证延期', '', '511A0006600021-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (39, 1, NULL, '', '', '非煤矿山企业安全生产许可证变更', '', '511A0006600025-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (40, 1, NULL, '', '', '非煤矿山企业安全生产许可证首次发证', '', '511A0006600019-510800000000-000-510802731594447-1-00', NULL, '510802731594447', '市应急管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (41, 1, NULL, '', '', '废弃电器电子产品处理企业资格审批', '', '511A0147900000-510800000000-000-008450911_27032-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (42, 1, NULL, '', '', '建设用地土壤污染修复方案备案', '', '511Z0713100001-510800000000-000-11510700008450911F-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (43, 1, NULL, '', '', '必需经水路运输医疗废物审批', '', '511A0148500000-510800000000-000-008450911_27032-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (44, 1, NULL, '', '', '贮存危险废物超过一年的批准(市级)', '', '511A16012002-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (45, 1, NULL, '', '', '突发环境事件应急预案备案', '', '511Z0613600000-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (46, 1, NULL, '', '', '建设用地土壤污染风险管控、修复效果评估报告备案', '', '511Z0713200001-510800000000-000-11510700008450911F-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (47, 1, NULL, '', '', '环境影响登记表备案', '', '511Z16015001-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (48, 1, NULL, '', '', '建设单位进行环境影响后评价的备案(市级)', '', '511Z16016002-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (49, 1, NULL, '', '', '土壤污染防治工作方案备案', '', '511Z0713000001-510800000000-000-11510700008450911F-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (50, 1, NULL, '', '', '入河排污口设置审批(市级)', '', '511A16001002-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (51, 1, NULL, '', '', '危险废物申报登记备案', '', '511Z0611300000-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (52, 1, NULL, '', '', '排污许可变更审批（基本信息变更）', '', '511A16010007-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (53, 1, NULL, '', '', '排污许可申请审批（简化管理）', '', '511A16010006-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (54, 1, NULL, '', '', '排污许可延续审批', '', '511A16010009-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (55, 1, NULL, '', '', '排污许可变更审批（其它信息变更）', '', '511A16010008-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (56, 1, NULL, '', '', '排污许可申请审批（重点管理）', '', '511A0148000000-510800000000-000-008450911_27032-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (57, 1, NULL, '', '', '辐射建设项目环境影响报告表审批(市级)', '', '511A16007003-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (58, 1, NULL, '', '', '一般建设项目环境影响报告书审批(市级)', '', '511A16007005-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (59, 1, NULL, '', '', '一般建设项目环境影响报告表审批（市级）', '', '511A16007006-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (60, 1, NULL, '', '', '辐射安全许可变更审批(市级)', '', '511A16013002-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (61, 1, NULL, '', '', '辐射安全许可申请审批(市级)', '', '511A16013005-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (62, 1, NULL, '', '', '辐射安全许可注销审批(市级)', '', '511A16013003-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (63, 1, NULL, '', '', '辐射安全许可遗失补办(市级)', '', '511A16013001-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (64, 1, NULL, '', '', '辐射安全许可延续审批(市级)', '', '511A16013004-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (65, 1, NULL, '', '', '危险废物经营许可申请（市级）', '', '511A16002004-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (66, 1, NULL, '', '', '危险废物经营许可变更(市级)', '', '511A16002006-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (67, 1, NULL, '', '', '危险废物经营许可到期延续(市级)', '', '511A16002005-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (68, 1, NULL, '', '', '危险废物经营许可补办(市级)', '', '511A16002007-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (69, 1, NULL, '', '', '单位危险废物管理计划备案', '', '511Z0610900000-510800000000-000-11510700MB15760365-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (70, 1, NULL, '', '', '土壤污染状况调查报告备案', '', '511Z0713300001-510800000000-000-11510700008450911F-1-00', NULL, '008450911', '市生态环境局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (71, 1, NULL, '', '', '伤残抚恤关系接收、转移办理（市级）', '', '512B0003600038-510800000000-000-11510700MB150370X5-1-00', NULL, '3907873659423346688', '市退役军人局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (72, 1, NULL, '', '', '困难退役军人关爱帮扶专项基金资金帮扶', '', '512024028001-510800000000-000-11510700MB150370X5-1-00', NULL, '3907873659423346688', '市退役军人局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (73, 1, NULL, '', '', '伤残证件换发、补发', '', '512061006005-510800000000-000-11510700MB150370X5-1-00', NULL, '3907873659423346688', '市退役军人局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (74, 1, NULL, '', '', '方案设计审查', '', '511A0046600003-510800000000-000-11510000008450057Y-1-00', NULL, '29868', '广元国安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (75, 1, NULL, '', '', '选址审查', '', '511A0046600002-510800000000-000-11510000008450057Y-1-00', NULL, '29868', '广元国安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (76, 1, NULL, '', '', '竣工检查验收', '', '511A0046600004-510800000000-000-11510000008450057Y-1-00', NULL, '29868', '广元国安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (77, 1, NULL, '', '', '职工基本医疗保险费趸缴清算', '', '512036002003-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (78, 1, NULL, '', '', '定点医药机构信息变更', '', '512036010003-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (79, 1, NULL, '', '', '零售药店申请定点协议管理', '', '512036010001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (80, 1, NULL, '', '', '医疗机构申请定点协议管理', '', '512036010002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (81, 1, NULL, '', '', '参保人员个人账户资金一次性支取', '', '512036003003-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (82, 1, NULL, '', '', '医保电子凭证申领', '', '512036001008-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (83, 1, NULL, '', '', '基本医疗保险关系转移接续', '', '512036004002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (84, 1, NULL, '', '', '常驻异地工作人员备案', '', '512036005005-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (85, 1, NULL, '', '', '门诊费用报销', '', '512036007001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (86, 1, NULL, '', '', '异地安置退休人员备案', '', '512036005001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (87, 1, NULL, '', '', '参保单位参保信息查询', '', '512036003001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (88, 1, NULL, '', '', '基本医疗保险参保人员享受门诊慢特病病种待遇认定', '', '512036012001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (89, 1, NULL, '', '', '单行支付药品、高值药品支付管理病种待遇认定', '', '512036012003-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (90, 1, NULL, '', '', '定点医药机构申请恢复协议管理', '', '512036010005-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (91, 1, NULL, '', '', '定点医药机构申请暂停（终止）协议管理', '', '512036010004-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (92, 1, NULL, '', '', '参保人员参保信息查询', '', '512036003002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (93, 1, NULL, '', '', '异地长期居住人员备案', '', '512036005002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (94, 1, NULL, '', '', '单位参保登记', '', '512036001001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (95, 1, NULL, '', '', '生育医疗费支付', '', '512036008002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (96, 1, NULL, '', '', '职工参保登记', '', '512036001002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (97, 1, NULL, '', '', '计划生育医疗费支付', '', '512036008003-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (98, 1, NULL, '', '', '生育津贴支付', '', '512036008004-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (99, 1, NULL, '', '', '职工参保信息变更登记', '', '512036001005-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (100, 1, NULL, '', '', '其他临时外出就医人员备案', '', '51203600500012-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (101, 1, NULL, '', '', '城乡居民参保信息变更登记', '', '512036001006-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (102, 1, NULL, '', '', '产前检查费支付', '', '512036008001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (103, 1, NULL, '', '', '城乡居民参保登记', '', '512036001003-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (104, 1, NULL, '', '', '单位参保信息变更登记', '', '512036001004-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (105, 1, NULL, '', '', '住院费用报销', '', '512036007002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (106, 1, NULL, '', '', '基本医疗保险定点零售药店费用结算', '', '512036011002-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (107, 1, NULL, '', '', '基本医疗保险定点医疗机构费用结算', '', '512036011001-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (108, 1, NULL, '', '', '异地转诊人员备案', '', '512036005003-510800000000-000-11510700MB16788415-1-00', NULL, '3905239396123201536', '市医保局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (109, 1, NULL, '', '', '投标保证金退付', '', '512B0122600001-510800000000-000-115107007798238948-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (110, 1, NULL, '', '', '矿业权及土地转让信息发布', '', '512B0122100003-510800000000-000-115107007798238948-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (111, 1, NULL, '', '', '资产资源信息发布', '', '512B0122100004-510800000000-000-115107007798238948-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (112, 1, NULL, '', '', '工程建设信息发布', '', '512B0122100001-510800000000-000-115107007798238948-1-00', NULL, '115107007798238948', '市政务服务和数据局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (113, 1, NULL, '', '', '政府采购信息发布', '', '512B0122100002-510800000000-000-115107007798238948-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (114, 1, NULL, '', '', '民办非企业单位注销登记', '', '511A0045000028-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (115, 1, NULL, '', '', '社会团体成立登记', '', '511A0045000024-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (116, 1, NULL, '', '', '民办非企业单位成立登记', '', '511A0045000026-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (117, 1, NULL, '', '', '社会团体注销登记', '', '511A0045000025-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (118, 1, NULL, '', '', '民办非企业单位修改章程核准', '', '511A0045000038-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (119, 1, NULL, '', '', '社会团体变更登记', '', '511A0045000041-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (120, 1, NULL, '', '', '民办非企业单位变更登记', '', '511A0045000047-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (121, 1, NULL, '', '', '慈善组织认定', '', '511F0082000001-510800000000-000-115107000084502848-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (122, 1, NULL, '', '', '社会团体修改章程核准', '', '511A0045000036-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (123, 1, NULL, '', '', '养老机构设立备案', '', '512011001001-510800000000-000-115107000084502848-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (124, 1, NULL, '', '', '出具民办非企业单位开立验资账户通知书', '', '512B0003600022-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (125, 1, NULL, '', '', '出具社会团体开立验资账户通知书', '', '512B0003600021-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (126, 1, NULL, '', '', '华侨及居住在香港、澳门、台湾地区的中国公民在内地收养子女登记', '', '511F0285600000-510800000000-000-115107000084502848-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (127, 1, NULL, '', '', '建设殡仪服务站、骨灰堂审批', '', '511A0045000034-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (128, 1, NULL, '', '', '建设社会公共墓地审批', '', '511A0045000040-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (129, 1, NULL, '', '', '慈善组织公开募捐资格审批', '', '511A0045000039-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (130, 1, NULL, '', '', '《慈善组织公开募捐资格证书》补发、换发', '', '511A0045000063-510800000000-000-115107000084502848-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (131, 1, NULL, '', '', '社会组织活动异常名录信用修复申请', '', '512011046001-510800000000-000-115107000084502848-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (132, 1, NULL, '', '', '城市生活无着流浪乞讨人员救助', '', '512B0003600035-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (133, 1, NULL, '', '', '社会组织档案查询', '', '512B0003600023-510800000000-000-008450284-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (134, 1, NULL, '', '', '社会组织评估', '', '512011007003-510800000000-000-115107000084502848-1-00', NULL, '008450284', '市民政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (135, 1, NULL, '', '', '输油管网项目核准', '', '511A0025300242-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (136, 1, NULL, '', '', '独立公（铁）路桥梁、隧道项目核准', '', '511A0025300187-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (137, 1, NULL, '', '', '分散接入风电站项目核准', '', '511A0025300211-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (138, 1, NULL, '', '', '电网工程项目核准', '', '511A0025300139-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (139, 1, NULL, '', '', '液化石油气接收、存储设施项目核准', '', '511A0025300257-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (140, 1, NULL, '', '', '内河航运项目核准', '', '511A0025300203-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (141, 1, NULL, '', '', '生活垃圾环保发电、医疗废物、危险废弃物及污水污泥处理项目核准', '', '511A0025300264-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (142, 1, NULL, '', '', '石油天然气管道竣工验收', '', '511Z60002001-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (143, 1, NULL, '', '', '水利工程项目核准', '', '511A0025300263-510800000000-000-115107000084501617-null-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (144, 1, NULL, '', '', '水电站项目核准', '', '511A0025300164-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (145, 1, NULL, '', '', '公路项目核准', '', '511A0025300143-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (146, 1, NULL, '', '', '就业和社会保障项目核准', '', '511A0025300292-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (147, 1, NULL, '', '', '石油天然气管道受限制区域施工保护方案许可', '', '511A60003002-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (148, 1, NULL, '', '', '水电项目截流验收', '', '511Z04011003-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (149, 1, NULL, '', '', '水电项目机组启动验收', '', '511Z04011005-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (150, 1, NULL, '', '', '风电场机组启动验收', '', '511Z04011002-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (151, 1, NULL, '', '', '国家及省市核准的水电项目竣工验收', '', '511Z04011001-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (152, 1, NULL, '', '', '水电项目蓄水验收', '', '511Z04011004-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (153, 1, NULL, '', '', '水电项目特殊单项工程验收', '', '511Z04011007-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (154, 1, NULL, '', '', '光伏电站机组启动验收', '', '511Z04011008-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (155, 1, NULL, '', '', '水电项目枢纽工程专项验收', '', '511Z04011006-510800000000-000-115107000084501617-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (156, 1, NULL, '', '', '农林生物质热电联产项目核准', '', '511A0025300216-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (157, 1, NULL, '', '', '天然气分布式能源项目核准', '', '511A0025300255-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (158, 1, NULL, '', '', '热电站（含自备电站）项目核准', '', '511A0025300195-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (159, 1, NULL, '', '', '旅游项目核准', '', '511A0025300150-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (160, 1, NULL, '', '', '输气管网项目核准', '', '511A0025300243-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (161, 1, NULL, '', '', '固定资产投资项目节能审查（企业技术改造项目除外）', '', '511A0108100001-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (162, 1, NULL, '', '', '企业投资项目备案', '', '513A0166300000-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (163, 1, NULL, '', '', '殡葬服务项目核准', '', '511A0025300177-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (164, 1, NULL, '', '', '医疗卫生项目核准', '', '511A0025300137-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (165, 1, NULL, '', '', '教育项目核准', '', '511A0025300154-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (166, 1, NULL, '', '', '体育项目核准', '', '511A0025300160-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (167, 1, NULL, '', '', '养老项目核准', '', '511A0025300156-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (168, 1, NULL, '', '', '文化项目核准', '', '511A0025300170-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (169, 1, NULL, '', '', '残疾人服务项目核准', '', '511A0025300172-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (170, 1, NULL, '', '', '文联、作协等项目核准', '', '511A0025300181-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (171, 1, NULL, '', '', '精神卫生项目核准', '', '511A0025300180-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (172, 1, NULL, '', '', '妇女儿童项目核准', '', '511A0025300165-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (173, 1, NULL, '', '', '新闻出版广电项目核准', '', '511A0025300153-510800000000-000-008450161-1-00', NULL, '008450161', '市发展改革委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (174, 1, NULL, '', '', '生猪定点屠宰厂（场）设置审查', '', '511A0132000000-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (175, 1, NULL, '', '', '对检举、揭发渔业船舶拆船单位隐瞒不报或者谎报污染损害事故，以及采取措施制止或者减轻污染损害的单位和个人的奖励', '', 'H-000137-001-008450380', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (176, 1, NULL, '', '', '国内异地引进水产苗种检疫', '', '511A0130900000-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (177, 1, NULL, '', '', '水产苗种生产审批', '', '511A0131300000-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (178, 1, NULL, '', '', '省级畜禽遗传资源保种场保护区认定', '', '513A0133600000-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (179, 1, NULL, '', '', '无公害农产品认定', '', '511F0167100000-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (180, 1, NULL, '', '', '调运检疫证书签发', '', '511A0089300004-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (181, 1, NULL, '', '', '农村机电提灌站产权登记', '', '511F0127400000-510800000000-000-11510700MB18323867-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (182, 1, NULL, '', '', '农业机械事故认定', '', '511F20002001-510800000000-000-11510700MB18323867-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (183, 1, NULL, '', '', '新建或迁建农村机电提灌站审批', '', '511A0131200000-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (184, 1, NULL, '', '', '政府投资或补助的农村能源工程初步设计方案的审核', '', '513A0134700000-510800000000-000-11510700MB18323867-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (185, 1, NULL, '', '', '水下工程作业渔业资源补救措施审批', '', '511A0092400004-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (186, 1, NULL, '', '', '种畜禽生产经营许可证信息变更', '', '511A0090800010-510800000000-000-11510700MB18323867-null-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (187, 1, NULL, '', '', '种畜禽原种场及猪一级扩繁场种畜禽生产经营许可', '', '511A0090800008-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (188, 1, NULL, '', '', '一级扩繁场（生猪除外）种畜禽生产经营许可', '', '511A0090800011-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (189, 1, NULL, '', '', '种子生产经营许可变更', '', '511A0087700004-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (190, 1, NULL, '', '', '主要农作物常规种子或非主要农作物种子生产经营许可', '', '511A0087700003-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (191, 1, NULL, '', '', '兽药经营许可证核发（普通兽药）', '', '511A0091400006-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (192, 1, NULL, '', '', '兽药经营许可证信息变更', '', '511A0091400005-510800000000-000-11510700MB18323867-null-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (193, 1, NULL, '', '', '渔业船舶登记', '', '511A0130500000-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (194, 1, NULL, '', '', '农药经营许可证变更（其他农药）', '', '511A0093000028-510800000000-000-11510700MB18323867-null-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (195, 1, NULL, '', '', '农药经营许可证补发（其他农药）', '', '511A0093000030-510800000000-000-11510700MB18323867-null-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (196, 1, NULL, '', '', '农药经营许可证核发（其他农药）', '', '511A0093000024-510800000000-000-008450380-1-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (197, 1, NULL, '', '', '农药经营许可证延续（其他农药）', '', '511A0093000029-510800000000-000-11510700MB18323867-null-00', NULL, '008450380', '市农业农村局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (198, 1, NULL, '', '', '商业特许经营备案初审', '', '511Z21003002-510800000000-000-11510700008453514P-1-00', NULL, '008453514', '市商务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (199, 1, NULL, '', '', '洗染业经营者备案(市级、县级)', '', '513A0142200000-510800000000-000-008453514-1-00', NULL, '008453514', '市商务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (200, 1, NULL, '', '', '二手车交易市场是否符合规划的确认', '', '511F0166900000-510800000000-000-11510700008453514P-1-00', NULL, '008453514', '市商务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (201, 1, NULL, '', '', '零售商促销备案', '', '511Z0169600000-510800000000-000-008453514-1-00', NULL, '008453514', '市商务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (202, 1, NULL, '', '', '举办会展备案', '', '513A0144300000-510800000000-000-008453514-1-00', NULL, '008453514', '市商务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (203, 1, NULL, '', '', '单用途商业预付卡发卡企业备案', '', '511Z0169500000-510800000000-000-11510700008453514P-1-00', NULL, '008453514', '市商务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (204, 1, NULL, '', '', '对外劳务合作经营资格核准', '', '511A0002100001-510800000000-000-11510700008453514P-1-00', NULL, '008453514', '市商务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (205, 1, NULL, '', '', '利用堤顶、戗台兼做公路审批', '', '511A19019001-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (206, 1, NULL, '', '', '水利工程建设项目政府验收（含阶段验收、竣工验收）', '', '511Z0229200000-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (207, 1, NULL, '', '', '占用农业灌溉水源、水利工程及其附属设施，或者影响灌溉用水、供水水源的建设项目审批', '', '511A0045200001-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (208, 1, NULL, '', '', '水闸安全鉴定审定', '', '511Z19006002-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (209, 1, NULL, '', '', '农村集体经济组织修建水库审批', '', '511A0018100002-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (210, 1, NULL, '', '', '利用水利工程开展经营活动审批', '', '511A0017700001-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (211, 1, NULL, '', '', '在大坝管理和保护范围内修建码头、鱼塘许可', '', '511A0018000002-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (212, 1, NULL, '', '', '水利工程建设项目招投标活动投诉受理及处理', '', '511Z0228400000-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (213, 1, NULL, '', '', '一般设计变更核备或审批', '', '511Z0226500000-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (214, 1, NULL, '', '', '对在河道管理范围内从事有关活动造成国家、集体、个人经济损失的裁决', '', '511E19001006-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (215, 1, NULL, '', '', '水工程洪水影响评价审批', '', '511A0017500006-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (216, 1, NULL, '', '', '行洪论证与河势稳定评价审批', '', '511A0017500008-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (217, 1, NULL, '', '', '生产建设项目水土保持方案审批（新办）（据省政府令第349号,部分省级权限下放成都等８市)', '', '511A0045100002-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (218, 1, NULL, '', '', '生产建设项目水土保持方案审批（变更）（据省政府令第349号,部分省级权限下放成都等８市)', '', '511A0045100001-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (219, 1, NULL, '', '', '取水许可证新办审批', '', '511A0079400004-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (220, 1, NULL, '', '', '取水申请批准文件', '', '511A0079400007-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (221, 1, NULL, '', '', '取水许可证延续审批', '', '511A0079400005-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (222, 1, NULL, '', '', '取水许可证变更审批', '', '511A0079400006-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (223, 1, NULL, '', '', '水事纠纷处理', '', '511E19002002-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (224, 1, NULL, '', '', '违反河道管理条例经济损失处理', '', '511E19002003-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (225, 1, NULL, '', '', '初步设计文件审批(据省政府令第349号,部分省级权限下放成都等８市)', '', '511A0074200004-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (226, 1, NULL, '', '', '重大设计变更文件审批（含概算调整）', '', '511A0074200005-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (227, 1, NULL, '', '', '河道管理范围内有关活动（不含河道采砂）审批', '', '511A0018400001-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (228, 1, NULL, '', '', '河道采砂许可', '', '511A19016001-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (229, 1, NULL, '', '', '水库大坝坝顶兼做公路审批', '', '511A0569900000-510800000000-000-115107000084504012-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (230, 1, NULL, '', '', '水利工程可行性研究报告审查(据省政府令第349号,部分省级权限下放成都等８市)', '', '511A0017900001-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (231, 1, NULL, '', '', '水利工程管理范围内建设项目审批', '', '511A0019000001-510800000000-000-008450401-1-00', NULL, '008450401', '市水利局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (232, 1, NULL, '', '', '基层法律服务所及基层法律服务工作者信息查询', '', '512C0110000001-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (233, 1, NULL, '', '', '律师执业注销许可', '', '511A0079600017-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (234, 1, NULL, '', '', '公证机构及公证员信息查询', '', '512C0107500001-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (235, 1, NULL, '', '', '对公民法律援助申请的审批', '', '511G12015001-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (236, 1, NULL, '', '', '司法鉴定机构及其分支机构延续登记', '', '511A0079100015-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (237, 1, NULL, '', '', '司法鉴定机构及其分支机构注销登记', '', '511A0079100016-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (238, 1, NULL, '', '', '人民调解员补贴发放', '', '511G12017001-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (239, 1, NULL, '', '', '法律职业资格考试业务咨询', '', '512C0165400000-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (240, 1, NULL, '', '', '应届毕业生法律职业资格认定（享受放宽条件政策的除外）', '', '512012006003-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (241, 1, NULL, '', '', '律师执业变更许可', '', '511A0079600012-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (242, 1, NULL, '', '', '律师执业证换发、补办', '', '511A0079600016-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (243, 1, NULL, '', '', '学历公证（指引）', '', '512012002010-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (244, 1, NULL, '', '', '纳税状况公证（指引）', '', '51201200200013-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (245, 1, NULL, '', '', '机动车驾驶证公证（指引）', '', '512012002012-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (246, 1, NULL, '', '', '学位公证（指引）', '', '512012002011-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (247, 1, NULL, '', '', '公证业务预约办理', '', '512C0107500002-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (248, 1, NULL, '', '', '台湾居民申请在川从事律师职业注销', '', '511A0080400003-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (249, 1, NULL, '', '', '台湾居民申请在川从事律师职业变更', '', '511A0080400002-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (250, 1, NULL, '', '', '台湾居民申请在川从事律师职业许可', '', '511A0080400001-510800000000-000-11510700008450268J-null-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (251, 1, NULL, '', '', '司法鉴定机构及其分支机构变更登记', '', '511A0079100008-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (252, 1, NULL, '', '', '司法鉴定机构及其分支机构执业类别变更', '', '511A0079100012-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (253, 1, NULL, '', '', '司法鉴定机构及其分支机构许可证换发、补办', '', '511A0079100020-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (254, 1, NULL, '', '', '司法鉴定机构分支机构名称预核', '', '511A0079100018-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (255, 1, NULL, '', '', '司法鉴定机构分支机构设立登记', '', '511A0079100006-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (256, 1, NULL, '', '', '司法鉴定机构名称预核', '', '511A0079100017-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (257, 1, NULL, '', '', '司法鉴定机构设立登记', '', '511A0079100007-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (258, 1, NULL, '', '', '公证员免职许可', '', '511A0080700007-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (259, 1, NULL, '', '', '公证员执业证换发', '', '511A12002008-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (260, 1, NULL, '', '', '公证员执业许可', '', '511A0080700003-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (261, 1, NULL, '', '', '公证员执业证补办', '', '511A12002009-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (262, 1, NULL, '', '', '公证员执业变更许可', '', '511A0080700004-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (263, 1, NULL, '', '', '律师及律所信息查询', '', '512C0107400001-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (264, 1, NULL, '', '', '律师及律所投诉指引', '', '512C0107400003-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (265, 1, NULL, '', '', '司法鉴定机构及司法鉴定人信息查询', '', '512C0100900001-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (266, 1, NULL, '', '', '律师及律所业务咨询', '', '512C0107400002-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (267, 1, NULL, '', '', '司法鉴定咨询', '', '512C0100900002-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (268, 1, NULL, '', '', '司法鉴定机构及司法鉴定人员投诉指引', '', '512B0100900003-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (269, 1, NULL, '', '', '律师事务所（分所）注销', '', '511A0079000029-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (270, 1, NULL, '', '', '律师执业许可', '', '511A0079600009-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (271, 1, NULL, '', '', '人民调解业务信息查询', '', '512C0164900000-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (272, 1, NULL, '', '', '法律援助律师工作证颁发', '', '511F12013001-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (273, 1, NULL, '', '', '公司律师工作证颁发', '', '511F12013003-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (274, 1, NULL, '', '', '公职律师工作证颁发', '', '511F12013002-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (275, 1, NULL, '', '', '律师工作证注销', '', '511F12013005-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (276, 1, NULL, '', '', '律师工作证换发、补办', '', '511F12013004-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (277, 1, NULL, '', '', '香港、澳门永久性居民中的中国居民申请在川从事律师职业核准', '', '511A0080300003-510800000000-000-11510700008450268J-null-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (278, 1, NULL, '', '', '香港、澳门永久性居民中的中国居民申请在川从事律师职业变更', '', '511A0080300001-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (279, 1, NULL, '', '', '香港、澳门永久性居民中的中国居民申请在川从事律师职业注销', '', '511A0080300002-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (280, 1, NULL, '', '', '律师事务所分所变更', '', '511A0079000022-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (281, 1, NULL, '', '', '律师事务所（分所）执业证换发、补办', '', '511A0079000025-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (282, 1, NULL, '', '', '律师事务所更名预核名', '', '511A0079000020-510800000000-000-11510700008450268j-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (283, 1, NULL, '', '', '律师事务所变更', '', '511A0079000012-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (284, 1, NULL, '', '', '律师事务所设立', '', '511A0079000008-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (285, 1, NULL, '', '', '律师事务所设立预核名', '', '511A0079000009-510800000000-000-11510700008450268j-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (286, 1, NULL, '', '', '律师事务所分所名称核准', '', '511A0079000011-510800000000-000-11510700008450268j-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (287, 1, NULL, '', '', '律师事务所分所设立', '', '511A0079000010-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (288, 1, NULL, '', '', '基层法律服务工作者执业变更', '', '511A0081000003-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (289, 1, NULL, '', '', '基层法律服务工作者执业注销', '', '511A0081000005-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (290, 1, NULL, '', '', '基层法律服务工作者执业许可', '', '511A0081000002-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (291, 1, NULL, '', '', '法律援助补贴发放', '', '511G12016001-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (292, 1, NULL, '', '', '人民调解员因从事工作致伤残、牺牲的救助、抚恤', '', '511G12018001-510800000000-000-11510700008450268J-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (293, 1, NULL, '', '', '司法鉴定人延续登记', '', '511A0079300008-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (294, 1, NULL, '', '', '司法鉴定人变更执业类别', '', '511A0079300006-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (295, 1, NULL, '', '', '司法鉴定人执业证换发、补办', '', '511A0079300010-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (296, 1, NULL, '', '', '司法鉴定人执业登记', '', '511A0079300004-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (297, 1, NULL, '', '', '司法鉴定人注销登记', '', '511A0079300009-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (298, 1, NULL, '', '', '司法鉴定人变更执业机构', '', '511A0079300005-510800000000-000-008450268-1-00', NULL, '008450268', '市司法局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (299, 1, NULL, '', '', '固定资产投资项目节能审查（企业技术改造项目）（市级）', '', '511A07004002-510800000000-000-1151070000845017XY-1-00', NULL, '00845017X', '市经济和信息化局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (300, 1, NULL, '', '', '企业投资项目备案（技术改造）（市级/县级）', '', '511Z07001006-510800000000-000-1151070000845017XY-1-00', NULL, '00845017X', '市经济和信息化局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (301, 1, NULL, '', '', '企业投资项目核准（技术改造）(市级)', '', '511A07001005-510800000000-000-1151070000845017XY-1-00', NULL, '00845017X', '市经济和信息化局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (302, 1, NULL, '', '', '成品油零售经营资格审批', '', '511A0063500001-510800000000-000-00845017X-1-00', NULL, '00845017X', '市经济和信息化局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (303, 1, NULL, '', '', '在电力设施周围或电力设施保护区内进行可能危及电力设施安全作业的审批（市级）', '', '511A07005002-510800000000-000-1151070000845017XY-1-00', NULL, '00845017X', '市经济和信息化局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (304, 1, NULL, '', '', '地面无线电台（站）（业余无线电台除外）设置、使用许可首次申请', '', '511A0022300005-510000000000-000-699166855-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (305, 1, NULL, '', '', '地面无线电台（站）（业余无线电台除外）设置、使用许可注销申请', '', '511A0022300007-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (306, 1, NULL, '', '', '地面无线电台（站）（业余无线电台除外）设置、使用许可有效期届满延续申请', '', '511A0022300006-510000000000-000-699166855-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (307, 1, NULL, '', '', '地面无线电台（站）（业余无线电台除外）设置、使用许可事项变更申请', '', '511A0700900014-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (308, 1, NULL, '', '', '地面无线电业务频率使用许可注销申请', '', '511A0022300008-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (309, 1, NULL, '', '', '地面无线电业务频率使用许可事项变更申请', '', '511A0700900011-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (310, 1, NULL, '', '', '地面无线电业务频率使用许可有效期届满延续申请', '', '511A0700900010-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (311, 1, NULL, '', '', '地面无线电业务频率使用许可首次申请', '', '511A0022300004-510000000000-000-699166855-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (312, 1, NULL, '', '', '卫星地球站设置、使用许可事项变更申请', '', '511A07006002-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (313, 1, NULL, '', '', '卫星地球站设置、使用许可有效期届满延续申请', '', '511A07006001-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (314, 1, NULL, '', '', '卫星地球站设置、使用许可注销申请', '', '511A07006003-510000000000-000-11510000699166855E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (315, 1, NULL, '', '', '卫星地球站设置、使用许可首次申请', '', '511A0078400001-510000000000-000-699166855-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (316, 1, NULL, '', '', '临时性建筑物搭建、堆放物料、占道施工审批', '', '511A0149300000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (317, 1, NULL, '', '', '房地产开发企业项目手册备案', '', '511Z0163300000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (318, 1, NULL, '', '', '建设工程勘察文件及施工图设计文件审查备案', '', '511Z0128400000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (319, 1, NULL, '', '', '住宅专项维修资金交存', '', '512B0110100008-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (320, 1, NULL, '', '', '城市建筑垃圾处置核准', '', '511A17011001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (321, 1, NULL, '', '', '住宅专项维修资金使用备案', '', '512B0110100009-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (322, 1, NULL, '', '', '住宅专项维修资金查询', '', '512B0110100006-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (323, 1, NULL, '', '', '建设工程质量监督备案', '', '511Z0164100000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (324, 1, NULL, '', '', '住宅专项维修资金分户账更名', '', '512B0110100007-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (325, 1, NULL, '', '', '工程建设项目招标投标活动投诉的处理', '', 'Z-000045-001-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (326, 1, NULL, '', '', '其他建设工程消防验收备案', '', '511Z17419001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (327, 1, NULL, '', '', '建筑起重机械使用登记', '', '511Z17012002-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (328, 1, NULL, '', '', '供电报装', '', '512004013001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (329, 1, NULL, '', '', '燃气经营许可证延续', '', '511A17030001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (330, 1, NULL, '', '', '燃气经营许可证注销', '', '511A0024800019-510800000000-000-12510700G5327970X3-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (331, 1, NULL, '', '', '燃气经营许可证新办', '', '511A0024800004-510800000000-000-12510700G5327970X3-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (332, 1, NULL, '', '', '燃气经营许可证变更', '', '511A0024800013-510800000000-000-12510700G5327970X3-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (333, 1, NULL, '', '', '建筑工程施工许可证核发', '', '511A0126300000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (334, 1, NULL, '', '', '建筑工程施工许可证变更', '', '511A17018005-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (335, 1, NULL, '', '', '建设工程招标投标情况书面报告', '', '511Z0714600000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (336, 1, NULL, '', '', '燃气设施建设工程竣工验收情况备案', '', '511Z0298700000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (337, 1, NULL, '', '', '危旧房棚户区改造信息查询', '', '512B0371900000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (338, 1, NULL, '', '', '城镇污水排入排水管网许可', '', '511A0148600000-510800000000-000-12510700G5327970X3-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (339, 1, NULL, '', '', '公租房租金缴纳', '', '51201700200002-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (340, 1, NULL, '', '', '符合条件的非政府投资建设的城市照明设施移交城市照明主管部门管理', '', 'Z-000037-001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (341, 1, NULL, '', '', '住房保障家庭租赁补贴发放', '', '51201700200001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (342, 1, NULL, '', '', '拆除工程施工备案', '', '511Z0320700000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (343, 1, NULL, '', '', '供气报装', '', '512017438001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (344, 1, NULL, '', '', '商品房预售许可', '', '511A0161600000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (345, 1, NULL, '', '', '供水报装', '', '512017439001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (346, 1, NULL, '', '', '房屋产权面积测绘成果审核管理', '', '511Z0165000000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (347, 1, NULL, '', '', '最高投标限价（招标控制价）备案（市级）', '', '511Z17028001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (348, 1, NULL, '', '', '设置大型户外广告的审批', '', '511A0188100003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (349, 1, NULL, '', '', '城市建筑物、设施上张挂、张贴宣传品审批', '', '511A17033003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (350, 1, NULL, '', '', '城市建筑物、设施上张挂、张贴宣传品审批', '', '511A0188100004-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (351, 1, NULL, '', '', '历史文化街区、名镇、名村核心保护范围内拆除历史建筑以外的建筑物、构筑物或者其他设施审批新办', '', '511A0024700004-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (352, 1, NULL, '', '', '历史建筑实施原址保护审批新办', '', '511A0024700003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (353, 1, NULL, '', '', '历史建筑外部修缮装饰、添加设施以及改变历史建筑的结构或者使用性质审批新办', '', '511A0024700005-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (354, 1, NULL, '', '', '房地产经纪机构备案', '', '511Z17023004-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (355, 1, NULL, '', '', '房产信息查询', '', '512B0129000000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (356, 1, NULL, '', '', '建筑起重机械安装、拆卸告知', '', '511Z17013002-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (357, 1, NULL, '', '', '建设工程档案验收', '', 'Z-000071-001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (358, 1, NULL, '', '', '夜间建筑施工许可', '', '511A0149400000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (359, 1, NULL, '', '', '由于工程施工、设备维修等原因确需停止供水的审批', '', '511A0149600000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (360, 1, NULL, '', '', '工程竣工结算备案（市级）', '', '511Z0162800000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (361, 1, NULL, '', '', '公共租赁住房申请资格审核认定', '', '51201700200003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (362, 1, NULL, '', '', '规范户外招牌设施设置', '', '512017432001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (363, 1, NULL, '', '', '协议方式选聘物业服务企业的核准', '', '511Z0164500000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (364, 1, NULL, '', '', '存量房抵押合同网签备案', '', '51201742600012-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (365, 1, NULL, '', '', '城镇排水与污水处理设施竣工验收备案', '', '511Z0715800000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (366, 1, NULL, '', '', '专业作业企业备案注销', '', '511Z17428002-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (367, 1, NULL, '', '', '专业作业企业备案新办', '', '511Z17428001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (368, 1, NULL, '', '', '专业作业企业备案变更', '', '511Z17428003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (369, 1, NULL, '', '', '物业管理中标结果备案', '', 'Z-000077-001-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (370, 1, NULL, '', '', '前期物业管理招标备案', '', '511Z17033001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (371, 1, NULL, '', '', '城乡生活垃圾经营性处置许可', '', '511A0302700000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (372, 1, NULL, '', '', '城乡生活垃圾经营性清扫、收集、运输许可', '', '511A0302800001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (373, 1, NULL, '', '', '房地产开发项目转让备案', '', '511Z0307900000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (374, 1, NULL, '', '', '改变绿化规划、绿化用地的使用性质审批', '', '511A0151100000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (375, 1, NULL, '', '', '《四川省施工企业工程规费计取标准》市（州）办理', '', '512B0110300013-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (376, 1, NULL, '', '', '临时便民服务摊点设置', '', '511Z0298500000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (377, 1, NULL, '', '', '建筑垃圾处理方案备案', '', '511Z64048001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (378, 1, NULL, '', '', '存量房买卖合同网签备案', '', '51201742600009-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (379, 1, NULL, '', '', '房屋租赁合同网签备案', '', '51201742600013-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (380, 1, NULL, '', '', '燃气经营者改动市政燃气设施审批', '', '511A0150500000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (381, 1, NULL, '', '', '《四川省施工企业工程规费计取标准》市、州变更', '', '51201701300005-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (382, 1, NULL, '', '', '新建商品房抵押合同网签备案', '', '51201742600008-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (383, 1, NULL, '', '', '安全施工措施备案', '', '511Z0128700000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (384, 1, NULL, '', '', '新建商品房买卖合同网签备案', '', '51201742600011-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (385, 1, NULL, '', '', '关闭、闲置、拆除城市环卫设施许可', '', '511A0151700000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (386, 1, NULL, '', '', '特殊建设工程消防设计审查', '', '511A17023002-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (387, 1, NULL, '', '', '《四川省施工企业工程规费计取标准》市、州遗失补办', '', '51201701300006-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (388, 1, NULL, '', '', '预拌砂浆生产企业备案', '', '511Z0171700000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (389, 1, NULL, '', '', '建筑起重机械首次出租及首次安装前备案', '', '511Z0128600000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (390, 1, NULL, '', '', '建设工程竣工验收备案', '', '511Z0164700000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (391, 1, NULL, '', '', '环卫设施建设工程项目档案备案', '', '511Z0298600000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (392, 1, NULL, '', '', '特殊车辆在城市道路上行驶（包括经过城市桥梁）审批', '', '511A0149100000-510800000000-000-12510700G5327970X3-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (393, 1, NULL, '', '', '已购公有和经济适用住房上市交易审核', '', '511Z0306800000-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (394, 1, NULL, '', '', '农村危房改造农户档案信息查询', '', '512B0370200000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (395, 1, NULL, '', '', '一星级绿色建筑认定', '', '51201742700005-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (396, 1, NULL, '', '', '特殊建设工程消防验收', '', '511A0148400000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (397, 1, NULL, '', '', '关闭、闲置、拆除生活垃圾处置的设施、场所核准', '', '511A0151800000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (398, 1, NULL, '', '', '燃气经营者停业、歇业审批', '', '511Z0620000000-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (399, 1, NULL, '', '', '因工程建设确需改装、拆除或者迁移城市公共供水设施审批', '', '511A0150600000-510800000000-000-12510700G5327970X3-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (400, 1, NULL, '', '', '拆除、移动城镇排水与污水处理设施方案审核', '', '511A17010003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (401, 1, NULL, '', '', '城市桥梁上架设各类市政管线审批', '', '511A17017005-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (402, 1, NULL, '', '', '市政设施建设类审批', '', '511A0024900001-510800000000-000-12510700G5327970X3-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (403, 1, NULL, '', '', '占用、挖掘城市道路审批', '', '511A17017003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (404, 1, NULL, '', '', '依附于城市道路建设各种管线、杆线等设施审批', '', '511A17017004-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (405, 1, NULL, '', '', '古树名木砍伐审批', '', '511A17014001-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (406, 1, NULL, '', '', '工程建设涉及城市绿地、树木审批', '', '511A0025000003-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (407, 1, NULL, '', '', '古树名木移植审批', '', '511A17014004-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (408, 1, NULL, '', '', '施工资质增项', '', '511A0023700012-510800000000-000-11510700MB1658250H-null-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (409, 1, NULL, '', '', '施工资质新办', '', '511A0023700093-510800000000-000-11510700MB1658250H-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (410, 1, NULL, '', '', '施工资质变更', '', '511A0023700308-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (411, 1, NULL, '', '', '施工资质重组、合并、分立', '', '511A0023700312-510800000000-000-11510700MB1658250H-null-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (412, 1, NULL, '', '', '施工资质延续', '', '511A0023700206-510800000000-000-11510700MB1658250H-null-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (413, 1, NULL, '', '', '施工资质注销', '', '511A0023700383-510800000000-000-115107000084536026-1-00', NULL, '115107000084536026', '市住房城乡建设局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (414, 1, NULL, '', '', '中介机构从事代理记账业务审批', '', '511A0036800001-510800000000-000-11510700008450364U-1-00', NULL, '008450364', '市财政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (415, 1, NULL, '', '', '会计专业技术人员继续教育办理', '', '51201300200004-510800000000-000-11510700008450364U-1-00', NULL, '008450364', '市财政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (416, 1, NULL, '', '', '非营利组织免税资格认定', '', '511F13006002-510800000000-000-11510700008450364U-1-00', NULL, '008450364', '市财政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (417, 1, NULL, '', '', '会计专业技术人员继续教育信息查询', '', '51201300200005-510800000000-000-11510700008450364U-1-00', NULL, '008450364', '市财政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (418, 1, NULL, '', '', '对政府采购供应商投诉处理决定', '', 'E-000010-001-008450364', NULL, '008450364', '市财政局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (419, 1, NULL, '', '', '医院评审', '', '511F0127200000-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (420, 1, NULL, '', '', '《出生医学证明》首次签发', '', '512023377001-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (421, 1, NULL, '', '', '外籍医师来华短期执业许可', '', '511A0143200000-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (422, 1, NULL, '', '', '限制类医疗技术临床应用备案管理（市级）', '', '512023013004-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (423, 1, NULL, '', '', '病原微生物二级生物安全实验室备案', '', 'Z-000006-001-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (424, 1, NULL, '', '', '义诊活动备案', '', '512B0144800000-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (425, 1, NULL, '', '', '放射工作人员证办理', '', '512B0145200000-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (426, 1, NULL, '', '', '消毒产品卫生安全评价报告备案', '', '512B0144700000-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (427, 1, NULL, '', '', '医师定期考核结果备案', '', '512B0144500000-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (428, 1, NULL, '', '', '外出健康体检备案', '', '512B0144900000-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (429, 1, NULL, '', '', '食品安全企业标准备案', '', '512B0026600001-510000000000-000-1151000000828305XT-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (430, 1, NULL, '', '', '放射源诊疗技术和医用辐射机构许可校验（市级）', '', '511A2301800007-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (431, 1, NULL, '', '', '放射源诊疗技术和医用辐射机构许可新办审批（市级）', '', '511A2301800001-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (432, 1, NULL, '', '', '放射诊疗设备、放射诊疗项目、放射诊疗许可证注销（市级）', '', '511A2301800009-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (433, 1, NULL, '', '', '放射源诊疗技术和医用辐射机构变更（即办件）（市级）', '', '511A2301800014-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (434, 1, NULL, '', '', '放射诊疗许可证遗失补办（市级）', '', '511A2301800005-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (435, 1, NULL, '', '', '放射源诊疗技术和医用辐射机构变更（承诺件）（市级）', '', '511A2301800022-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (436, 1, NULL, '', '', '中外合资合作、港澳台医疗机构设置审批（市级）', '', '511A0037300002-510800000000-000-008450583-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (437, 1, NULL, '', '', '内资医疗机构设置审批（市级）', '', '511A2301400004-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (438, 1, NULL, '', '', '台湾医师来内地短期执业审批', '', '511A23006005-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (439, 1, NULL, '', '', '港澳医师来内地短期执业审批', '', '511A23006004-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (440, 1, NULL, '', '', '医疗机构执业变更（即办件）（市级）', '', '511A2301000020-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (441, 1, NULL, '', '', '医疗机构申请开展健康体检（市级）', '', '511A2301000003-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (442, 1, NULL, '', '', '医疗机构执业变更（承诺件）（市级）', '', '511A2301000015-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (443, 1, NULL, '', '', '医疗机构执业变更（冠名）（市级）', '', '511A0013700034-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (444, 1, NULL, '', '', '医疗机构执业审批（校验）（市级）', '', '511A2301000006-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (445, 1, NULL, '', '', '医疗机构执业许可证遗失补办(市级)', '', '511A2301000005-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (446, 1, NULL, '', '', '医疗机构执业审批（注销）（市级）', '', '511A2301000007-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (447, 1, NULL, '', '', '医疗机构执业审批（新办）（市级）', '', '511A2301000013-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (448, 1, NULL, '', '', '医疗机构放射性职业病危害建设项目竣工验收（市级）', '', '511A23011001-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (449, 1, NULL, '', '', '医疗机构放射性职业病危害建设项目预评价报告审核（市级）', '', '511A23012001-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (450, 1, NULL, '', '', '麻醉药品和第一类精神药品购用许可遗失补办', '', '511A23029001-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (451, 1, NULL, '', '', '麻醉药品和第一类精神药品购用许可延续', '', '511A0012800014-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (452, 1, NULL, '', '', '麻醉药品和第一类精神药品购用许可新办审批', '', '511A0012800013-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (453, 1, NULL, '', '', '麻醉药品和第一类精神药品购用许可变更', '', '511A0012800010-510800000000-000-11510700327061905F-1-00', NULL, '008450583', '市卫生健康委', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (454, 1, NULL, '', '', '企业年金方案终止备案', '', '512B0359900006-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (455, 1, NULL, '', '', '养老保险供养亲属领取待遇资格认证', '', '51201400600005-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (456, 1, NULL, '', '', '机关事业单位社会保险缴费申报与变更', '', '51201400100002-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (457, 1, NULL, '', '', '企业职工基本养老保险与城乡居民基本养老保险互转申请', '', '512B0068100006-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (458, 1, NULL, '', '', '机关事业单位基本养老保险与企业职工基本养老保险互转申请', '', '512B0359600021-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (459, 1, NULL, '', '', '企业年金方案重要条款变更备案', '', '512B0359900005-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (460, 1, NULL, '', '', '企业年金方案备案', '', '512B0359900004-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (461, 1, NULL, '', '', '养老保险定期待遇领取资格认证', '', '51201400600004-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (462, 1, NULL, '', '', '达到法定退休年龄缴费不满15年社保权益申请', '', '51201400600010-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (463, 1, NULL, '', '', '失业登记', '', '512B0066800002-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (464, 1, NULL, '', '', '就业登记', '', '512B0066800001-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (465, 1, NULL, '', '', '企业职工社会保险费补缴申报', '', '512B0068200006-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (466, 1, NULL, '', '', '企业职工社会保险费欠费补缴申报', '', '512B0359300008-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (467, 1, NULL, '', '', '军人退役养老保险关系转移接续申请', '', '51201400600032-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (468, 1, NULL, '', '', '未就业随军配偶养老保险关系转移接续申请', '', '512B0068100003-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (469, 1, NULL, '', '', '企业实行不定时工作制和综合计算工时工作制审批意见和制度方案异地备案（市级）', '', '511A0055000002-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (470, 1, NULL, '', '', '企业实行不定时工作制和综合计算工时制审批（市级）', '', '511A0055000001-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (471, 1, NULL, '', '', '企业职工基本养老保险关系转移接续申请', '', '512B0068100002-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (472, 1, NULL, '', '', '机关事业单位基本养老保险关系转移接续（含职业年金）申请', '', '512B0359600022-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (473, 1, NULL, '', '', '职业指导', '', '512B0066500002-510800000000-000-12510700451266668G-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (474, 1, NULL, '', '', '病残津贴申领', '', '512B0068400009-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (475, 1, NULL, '', '', '企业经济性裁员报告', '', '512B0071500001-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (476, 1, NULL, '', '', '集体合同审查', '', '512B0071400001-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (477, 1, NULL, '', '', '依据档案记载出具相关证明', '', '512B0071100004-510800000000-000-915108027779128268-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (478, 1, NULL, '', '', '政审（考察）服务', '', '512B0071100002-510800000000-000-915108027779128268-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (479, 1, NULL, '', '', '到档查询', '', '51201401600003-510800000000-000-915108027779128268-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (480, 1, NULL, '', '', '档案材料补充', '', '51201401600010-510800000000-000-915108027779128268-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (481, 1, NULL, '', '', '档案查（借）阅服务', '', '51201401600008-510800000000-000-915108027779128268-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (482, 1, NULL, '', '', '领取注册安全工程师资格证书或合格证明', '', '512B0361300038-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (483, 1, NULL, '', '', '领取经济专业技术资格（初级、中级）资格证书', '', '512B0361300039-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (484, 1, NULL, '', '', '职业介绍', '', '512B0066500001-510800000000-000-12510700451266668G-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (485, 1, NULL, '', '', '招聘服务', '', '512B0066500003-510800000000-000-12510700451266668G-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (486, 1, NULL, '', '', '档案接收', '', '51201401600009-510800000000-000-915108027779128268-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (487, 1, NULL, '', '', '档案转出', '', '512B0071100006-510800000000-000-915108027779128268-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (488, 1, NULL, '', '', '在校大学生创业担保贷款贴息申请', '', '512B0066700006-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (489, 1, NULL, '', '', '大学生创新创业园区（孵化基地）申请', '', '512B0067100001-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (490, 1, NULL, '', '', '大学生创业吸纳就业奖励申请', '', '512B0066700005-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (491, 1, NULL, '', '', '创业专家咨询', '', '512B0066700001-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (492, 1, NULL, '', '', '零就业家庭认定申请', '', '512B0066400008-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (493, 1, NULL, '', '', '求职创业补贴申领', '', '512B0159000000-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (494, 1, NULL, '', '', '供养亲属抚恤金申领', '', '512B0068500023-510800000000-000-115107005904526632_19582-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (495, 1, NULL, '', '', '一次性工亡补助金（含生活困难，预支50%确认）、丧葬补助金申领', '', '512B0068500019-510800000000-000-115107005904526632_19582-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (496, 1, NULL, '', '', '工伤保险定期待遇领取资格认证', '', '51201401400008-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (497, 1, NULL, '', '', '领取因工死亡职工供养亲属待遇资格认证', '', '51201401400009-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (498, 1, NULL, '', '', '工伤保险待遇变更', '', '51201401400005-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (499, 1, NULL, '', '', '领取一级注册消防工程师资格证书', '', '512B0361300040-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (500, 1, NULL, '', '', '社会保障卡申领', '', '512B0070200003-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (501, 1, NULL, '', '', '电子社会保障卡签发', '', '51201402100001-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (502, 1, NULL, '', '', '企业（单位）招用就业困难人员补贴申请', '', '512B0066400006-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (503, 1, NULL, '', '', '企业吸纳就业税收政策人员认定申请', '', '512B0066400007-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (504, 1, NULL, '', '', '经营性人力资源服务机构开展人力资源服务业务备案（市级）', '', '511A0217700001-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (505, 1, NULL, '', '', '经营性人力资源服务机构从事职业中介活动许可（市级）', '', '511A0284700000-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (506, 1, NULL, '', '', '经营性人力资源服务机构设立分支机构、变更名称、住所、法定代表人、终止经营活动书面报告（市级）', '', '511A0217700002-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (507, 1, NULL, '', '', '职业技能鉴定补贴申领', '', '512B0067700001-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (508, 1, NULL, '', '', '创业补贴申请', '', '512B0066700003-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (509, 1, NULL, '', '', '创业担保贷款申请', '', '512B0066700004-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (510, 1, NULL, '', '', '就业创业证查询、核验', '', '512B0066800003-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (511, 1, NULL, '', '', '职业年金个人权益记录单查询打印', '', '512014018003-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (512, 1, NULL, '', '', '个人参保证明查询打印', '', '51201401800006-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (513, 1, NULL, '', '', '个人权益记录查询打印', '', '51201401800008-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (514, 1, NULL, '', '', '社会保障卡启用（激活）', '', '512B0070200004-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (515, 1, NULL, '', '', '社会保障卡应用状态查询', '', '512B0070200011-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (516, 1, NULL, '', '', '单位参保证明查询打印', '', '512B0068700010-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (517, 1, NULL, '', '', '社会保障卡补领、换领、换发', '', '512B0070200006-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (518, 1, NULL, '', '', '经营劳务派遣业务（含新增业务、新设公司、分立、合并）许可（市级）', '', '511A0055200002-510800000000-000-115107005904526632_20846-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (519, 1, NULL, '', '', '劳务派遣经营许可证延续审批（市级）', '', '511A0055200003-510800000000-000-115107005904526632_20846-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (520, 1, NULL, '', '', '劳务派遣经营许可注销(市级)', '', '511A14012001-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (521, 1, NULL, '', '', '劳务派遣单位设立分公司书面报告（市级）', '', '511A0055200004-510800000000-000-115107005904526632_20846-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (522, 1, NULL, '', '', '劳务派遣单位设立分公司异地备案（市级）', '', '511A0055200005-510800000000-000-115107005904526632_20846-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (523, 1, NULL, '', '', '劳务派遣经营单位名称、住所、法定代表人、注册资本等变更审批（市级）', '', '511A0055200001-510800000000-000-115107005904526632_20846-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (524, 1, NULL, '', '', '社会保障卡参保地转移', '', '51201402100003-510800000000-000-12510700MB0M64311E-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (525, 1, NULL, '', '', '社会保障卡非关键信息变更', '', '512B0070200010-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (526, 1, NULL, '', '', '社会保障卡密码修改', '', '512B0070200002-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (527, 1, NULL, '', '', '社会保障卡密码重置', '', '512B0070200005-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (528, 1, NULL, '', '', '社会保障卡挂失', '', '512B0070200008-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (529, 1, NULL, '', '', '社会保障卡解挂', '', '512B0070200001-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (530, 1, NULL, '', '', '机关事业单位退休人员发放明细查询', '', '51201400800005-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (531, 1, NULL, '', '', '就业重点群体生活费（含交通费）补贴申请', '', '512B0067600003-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (532, 1, NULL, '', '', '企业职工养老金发放明细查询', '', '51201400800004-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (533, 1, NULL, '', '', '劳动人事争议仲裁申请', '', '51201400800001-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (534, 1, NULL, '', '', '工伤预防项目申报', '', '512A0359700061-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (535, 1, NULL, '', '', '劳动能力复查鉴定申请', '', '512B0071800003-510800000000-000-12510700MB0X12167A-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (536, 1, NULL, '', '', '工伤异地就医申请', '', '512B0359700032-510800000000-000-12510700451266764R-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (537, 1, NULL, '', '', '转诊转院到异地就医申请', '', '512B0363900000-510800000000-000-12510700451266764R-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (538, 1, NULL, '', '', '旧伤复发申请', '', '512B0363800000-510800000000-000-12510700451266764R-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (539, 1, NULL, '', '', '定期待遇发放账户维护申请', '', '512B0068000011-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (540, 1, NULL, '', '', '社会保障卡注销', '', '512B0070200007-510800000000-000-12510700MB0M64311E-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (541, 1, NULL, '', '', '就业技能培训补贴申请', '', '512B0067600001-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (542, 1, NULL, '', '', '创业培训补贴申请', '', '512B0067600002-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (543, 1, NULL, '', '', '创业培训开班（含报名）', '', '512B0066900002-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (544, 1, NULL, '', '', '就业技能培训开班（含报名）', '', '512B0066900001-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (545, 1, NULL, '', '', '企业信息变更', '', '512B0068000009-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (546, 1, NULL, '', '', '机关事业单位信息变更', '', '51201401700001-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (547, 1, NULL, '', '', '人员重要信息变更', '', '51201401700002-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (548, 1, NULL, '', '', '个人基本信息变更', '', '512B0068000007-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (549, 1, NULL, '', '', '机关事业单位职业年金缴纳', '', '512B0359400002-510800000000-000-12510700451266764R-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (550, 1, NULL, '', '', '机关事业单位职业年金缴费工资申报', '', '51201402000003-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (551, 1, NULL, '', '', '领取执业药师（药学、中药学）资格证书', '', '512B0361300035-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (552, 1, NULL, '', '', '招聘会服务', '', '512B0360200002-510800000000-000-915108027779128268-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (553, 1, NULL, '', '', '职业供求信息、市场工资指导价位信息和职业培训信息发布', '', '51201400500002-510800000000-000-915108027779128268-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (554, 1, NULL, '', '', '辅助器具配置（更换）申请', '', '512B0068500024-510800000000-000-115107005904526632_19582-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (555, 1, NULL, '', '', '住院伙食补助费申领', '', '512B0068500028-510800000000-000-115107005904526632_19582-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (556, 1, NULL, '', '', '工伤医疗（康复）费用申报', '', '512B0068500015-510800000000-000-115107005904526632_19582-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (557, 1, NULL, '', '', '停工留薪期确认和延长确认', '', '51201401400035-510800000000-000-12510700451266764R-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (558, 1, NULL, '', '', '就业困难人员灵活就业社保补贴申领', '', '512B0066400001-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (559, 1, NULL, '', '', '伤残待遇申领（一次性伤残补助金，伤残津贴和生活护理费）', '', '512B0068500017-510800000000-000-115107005904526632_19582-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (560, 1, NULL, '', '', '辅助器具配置（更换）费用申报', '', '512B0068500025-510800000000-000-115107005904526632_19582-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (561, 1, NULL, '', '', '一次性工伤医疗补助金申请', '', '51201401400038-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (562, 1, NULL, '', '', '就业困难人员认定', '', '512B0066400003-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (563, 1, NULL, '', '', '劳动能力鉴定费申报', '', '51201401400037-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (564, 1, NULL, '', '', '民办职业培训学校办学许可证延续审批（市级）', '', '511A0054800005-510800000000-000-115107005904526632_17899-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (565, 1, NULL, '', '', '民办职业培训学校终止审批（市级）', '', '511A0054800004-510800000000-000-115107005904526632_17899-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (566, 1, NULL, '', '', '民办职业培训学校设立审批（市级）', '', '511A0054800001-510800000000-000-115107005904526632_17899-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (567, 1, NULL, '', '', '民办职业培训学校分立、合并审批（市级）', '', '511A0054800002-510800000000-000-115107005904526632_17899-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (568, 1, NULL, '', '', '民办职业培训学校名称、地址、层次、类别、举办者（负责人）等变更审批（市级）', '', '511A0054800003-510800000000-000-115107005904526632_17899-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (569, 1, NULL, '', '', '公益性岗位申报', '', '512B0066400005-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (570, 1, NULL, '', '', '公益性岗位补贴申请', '', '512B0066400002-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (571, 1, NULL, '', '', '公益性岗位申请', '', '512B0066400004-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (572, 1, NULL, '', '', '领取注册城乡规划师资格证书', '', '512B0361300032-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (573, 1, NULL, '', '', '遗属待遇申领', '', '512B0068400008-510800000000-000-12510700451266764R-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (574, 1, NULL, '', '', '领取勘察设计注册工程师资格证书', '', '512B0361300036-510800000000-000-115107005904526632-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (575, 1, NULL, '', '', '暂停养老保险待遇申请', '', '512B0068400018-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (576, 1, NULL, '', '', '领取一级造价工程师职业资格证书或合格证明', '', '512B0361300037-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (577, 1, NULL, '', '', '恢复养老保险待遇申请', '', '512B0068400011-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (578, 1, NULL, '', '', '高校毕业生社保补贴申领', '', '512B0158800000-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (579, 1, NULL, '', '', '领取注册测绘师资格证书', '', '512B0361300030-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (580, 1, NULL, '', '', '领取一级建造师资格证书或合格证明', '', '512B0361300033-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (581, 1, NULL, '', '', '领取出版专业技术人员职业资格（初级、中级）证书', '', '512B0361300031-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (582, 1, NULL, '', '', '求职创业补贴申领', '', '512014025002-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (583, 1, NULL, '', '', '机关事业单位养老保险个人账户储存额一次性申领', '', '51201400600028-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (584, 1, NULL, '', '', '多重养老保险关系个人账户退费', '', '512B0068100004-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (585, 1, NULL, '', '', '企业职工基本养老保险个人账户储存额一次性申领', '', '51201400600031-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (586, 1, NULL, '', '', '集体户口管理', '', '51201402500003-510800000000-000-915108027779128268-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (587, 1, NULL, '', '', '离校未就业高校毕业生登记', '', '512B0157900000-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (588, 1, NULL, '', '', '高校毕业生报到', '', '51201402500004-510800000000-000-915108027779128268-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (589, 1, NULL, '', '', '机关事业单位人员基本养老保险视同缴费年限申报', '', '512B0068400012-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (590, 1, NULL, '', '', '机关事业单位基本养老保险退休人员待遇重新申报', '', '51201400600006-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (591, 1, NULL, '', '', '机关事业单位基本养老保险改革后退休人员预发待遇申领', '', '51201400600007-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (592, 1, NULL, '', '', '企业职工基本养老保险提前退休申请', '', '51201400600030-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (593, 1, NULL, '', '', '机关事业单位新增退休人员基础信息申报', '', '51201400600008-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (594, 1, NULL, '', '', '企业职工基本养老保险退休待遇重核申请', '', '51201400600029-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (595, 1, NULL, '', '', '企业职工基本养老保险正常退休申请', '', '51201400600001-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (596, 1, NULL, '', '', '就业见习岗位申报', '', '512B0158400000-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (597, 1, NULL, '', '', '就业见习申请', '', '512B0158000000-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (598, 1, NULL, '', '', '就业见习补贴申领', '', '512B0158200000-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (599, 1, NULL, '', '', '领取一、二级注册建筑师资格证书', '', '512B0361300022-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (600, 1, NULL, '', '', '领取监理工程师资格证书或合格证明', '', '512B0361300023-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (601, 1, NULL, '', '', '领取环境影响评价工程师资格证书', '', '512B0361300024-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (602, 1, NULL, '', '', '领取翻译专业资格（笔译、口译）证书或合格证明', '', '51201400300001-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (603, 1, NULL, '', '', '领取失业保险金期间职业培训补贴申领', '', '512B0070100007-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (604, 1, NULL, '', '', '缴费人员减少', '', '512B0067900010-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (605, 1, NULL, '', '', '失业保险金申领', '', '512B0070100003-510800000000-000-12510700451266668G-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (606, 1, NULL, '', '', '领取失业保险金期间丧葬补助金和抚恤金申领', '', '512B0070100010-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (607, 1, NULL, '', '', '机关事业单位社会保险登记', '', '51201401900003-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (608, 1, NULL, '', '', '领取助理社会工作师、社会工作师、高级社会工作师资格证书', '', '512B0361300027-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (609, 1, NULL, '', '', '领取一、二级注册计量师资格证书', '', '512B0361300026-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (610, 1, NULL, '', '', '领取注册设备监理师资格证书', '', '512B0361300029-510800000000-000-115107005904526632-2-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (611, 1, NULL, '', '', '机关事业单位社会保险注销登记', '', '512B0359100010-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (612, 1, NULL, '', '', '企业注销社会保险登记', '', '512B0359100009-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (613, 1, NULL, '', '', '工程建设项目人员增减申报', '', '51201401900002-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (614, 1, NULL, '', '', '工程建设项目办理工伤保险参保登记', '', '512B0067900015-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (615, 1, NULL, '', '', '工程建设项目参保项目维护', '', '51201401900001-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (616, 1, NULL, '', '', '机关事业单位职工参保登记', '', '512B0067900004-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (617, 1, NULL, '', '', '企业职工参保登记', '', '512B0067900008-510800000000-000-12510700451266764R-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (618, 1, NULL, '', '', '工伤事故备案', '', '512B0363500000-510800000000-000-115107005904526632-null-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (619, 1, NULL, '', '', '劳动能力鉴定申请', '', '512B0071800001-510800000000-000-12510700MB0X12167A-2-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (620, 1, NULL, '', '', '工伤认定申请', '', '512B0606800000-510800000000-000-115107005904526632-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (621, 1, NULL, '', '', '领取失业保险待遇期间生育补助金申请和发放', '', '512B0070100009-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (622, 1, NULL, '', '', '领取失业保险金期间职业介绍补贴申领', '', '512B0070100012-510800000000-000-12510700451266668G-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (623, 1, NULL, '', '', '失业保险技能提升补贴申领', '', '512B0070100005-510800000000-000-12510700451266668G-1-00', NULL, '115107005904526632', '市人力资源社会保障局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (624, 1, NULL, '', '', '失业保险金发放关系转移', '', '51201401100002-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (625, 1, NULL, '', '', '失业保险稳岗返还申领', '', '512B0070100004-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (626, 1, NULL, '', '', '失业保险补贴发放账户维护（用人单位）', '', '51201401100003-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (627, 1, NULL, '', '', '失业保险待遇发放账户维护（个人）', '', '51201401100004-510800000000-000-115107005904526632-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (628, 1, NULL, '', '', '地理信息公共服务平台服务', '', '512A0624800000-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (629, 1, NULL, '', '', '测绘地理信息法治政策咨询服务', '', '512081012001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (630, 1, NULL, '', '', '建设项目规划条件变更', '', '511Z0163200000-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (631, 1, NULL, '', '', '注册测绘师考试报名资格审查', '', '512081006002-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (632, 1, NULL, '', '', '测绘地理信息项目备案登记', '', '511Z0697300000-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (633, 1, NULL, '', '', '测绘地理信息行业统计年报查询服务', '', '512B0147800000-510800000000-000-12510700060342539F-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (634, 1, NULL, '', '', '临时用地审批', '', '511A0034800001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (635, 1, NULL, '', '', '永久基本农田划区定界验收确认', '', '511F15003001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (636, 1, NULL, '', '', '建设项目验线规划管理', '', '511Z0162900000-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (637, 1, NULL, '', '', '地图审核', '', '511A0195100000-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (638, 1, NULL, '', '', '抵押备案', '', '512B0103400001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (639, 1, NULL, '', '', '抵押备案解除', '', '51201500600004-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (640, 1, NULL, '', '', '首次登记（国有建设用地使用权登记）', '', '511F1500100016-510800000000-000-11510700MB16763796-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (641, 1, NULL, '', '', '注销登记（国有建设用地使用权登记）', '', '511F1500100019-510800000000-000-11510700MB16763796-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (642, 1, NULL, '', '', '转移登记（国有建设用地使用权登记）', '', '511F1500100018-510800000000-000-11510700MB16763796-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (643, 1, NULL, '', '', '变更登记（国有建设用地使用权登记）', '', '511F1500100017-510800000000-000-11510700MB16763796-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (644, 1, NULL, '', '', '设立异议登记（异议登记）', '', '511F0093300080-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (645, 1, NULL, '', '', '注销异议登记（异议登记）', '', '511F0093300082-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (646, 1, NULL, '', '', '注销查封登记（查封登记）', '', '511F0093300075-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (647, 1, NULL, '', '', '设立查封登记（查封登记）', '', '511F0093300073-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (648, 1, NULL, '', '', '建设工程设计方案审定', '', '511Z0163500000-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (649, 1, NULL, '', '', '依申请更正登记（更正登记）', '', '511F0093300085-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (650, 1, NULL, '', '', '乡（镇）村公共设施、公益事业使用集体建设用地审批', '', '511A15006001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (651, 1, NULL, '', '', '矿山地质环境保护与土地复垦方案审查', '', '511Z15027001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (652, 1, NULL, '', '', '新设探矿权登记', '', '511A0031900014-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (653, 1, NULL, '', '', '探矿权保留登记', '', '511A0031900024-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (654, 1, NULL, '', '', '探矿权延续登记', '', '511A15024003-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (655, 1, NULL, '', '', '探矿权注销登记', '', '511A0031900022-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (656, 1, NULL, '', '', '互联网地图新增内容审核备案', '', '511Z81001002-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (657, 1, NULL, '', '', '建设工程（含临时建设）规划许可证核发', '', '511A0024700001-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (658, 1, NULL, '', '', '补发（不动产权证书、证明的换发与补发）', '', '511F0093300072-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (659, 1, NULL, '', '', '换发（不动产权证书、证明的换发和补发）', '', '511F0093300070-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (660, 1, NULL, '', '', '转移登记（土地承包经营权登记）', '', '511F0093300076-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (661, 1, NULL, '', '', '注销登记（土地承包经营权登记）', '', '511F0093300077-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (662, 1, NULL, '', '', '变更登记（土地承包经营权登记）', '', '511F0093300074-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (663, 1, NULL, '', '', '首次登记（土地承包经营权）', '', '511F0093300071-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (664, 1, NULL, '', '', '预告登记注销（预告登记）', '', '511F0093300093-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (665, 1, NULL, '', '', '预告登记转移（预告登记）', '', '511F0093300096-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (666, 1, NULL, '', '', '预告登记设立（预告登记）', '', '511F0093300100-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (667, 1, NULL, '', '', '预告登记变更（预告登记）', '', '511F0093300099-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (668, 1, NULL, '', '', '变更登记（地役权登记）', '', '511F0093300081-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (669, 1, NULL, '', '', '首次登记（地役权登记）', '', '511F0093300079-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (670, 1, NULL, '', '', '注销登记（地役权登记）', '', '511F0093300094-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (671, 1, NULL, '', '', '转移登记（地役权登记）', '', '511F0093300084-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (672, 1, NULL, '', '', '缩小勘查范围（含分立）变更登记', '', '511A0031900017-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (673, 1, NULL, '', '', '勘查主矿种变更登记', '', '511A0031900019-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (674, 1, NULL, '', '', '扩大勘查范围（含合并）变更登记', '', '511A0031900016-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (675, 1, NULL, '', '', '探矿权转让变更登记', '', '511A0031900018-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (676, 1, NULL, '', '', '探矿权人名称变更登记', '', '511A0031900020-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (677, 1, NULL, '', '', '测绘资质单位名称、法人、地址变更登记与资质注销', '', '511F81001003-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (678, 1, NULL, '', '', '乡（镇）村企业使用集体建设用地审批', '', '511A0036500001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (679, 1, NULL, '', '', '采矿权注销登记', '', '511A0031800004-510800000000-000-008450508_30954-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (680, 1, NULL, '', '', '建设项目用地预审与选址意见书', '', '511A0034400001-510800000000-000-008450508_30954-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (681, 1, NULL, '', '', '矿产资源储量评审备案', '', '511F15043001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (682, 1, NULL, '', '', '采矿权延续登记', '', '511A0031800003-510800000000-000-11510700MB16763796-null-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (683, 1, NULL, '', '', '新设采矿权登记', '', '511A0031800001-510800000000-000-11510700MB16763796-null-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (684, 1, NULL, '', '', '勘查作业区范围和矿区范围争议裁决', '', '511E15001001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (685, 1, NULL, '', '', '转移登记（国有农用地使用权登记）', '', '511F0093300097-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (686, 1, NULL, '', '', '首次登记（国有农用地使用权登记）', '', '511F0093300078-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (687, 1, NULL, '', '', '变更登记（国有农用地使用权登记）', '', '511F0093300095-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (688, 1, NULL, '', '', '注销登记（国有农用地使用权登记）', '', '511F0093300098-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (689, 1, NULL, '', '', '注销登记（集体建设用地使用权及建筑物、构筑物所有权）', '', '511F0093300090-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (690, 1, NULL, '', '', '转移登记（集体建设用地使用权及建筑物、构筑物所有权）', '', '511F0093300089-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (691, 1, NULL, '', '', '首次登记（集体建设用地使用权及建筑物、构筑物所有权）', '', '511F0093300086-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (692, 1, NULL, '', '', '变更登记（集体建设用地使用权及建筑物、构筑物所有权）', '', '511F0093300088-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (693, 1, NULL, '', '', '注销登记（抵押权登记）', '', '511F0093300092-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (694, 1, NULL, '', '', '首次登记（抵押权登记）', '', '511F0093300101-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (695, 1, NULL, '', '', '转移登记（抵押权登记）', '', '511F0093300091-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (696, 1, NULL, '', '', '变更登记（抵押权登记）', '', '511F0093300087-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (697, 1, NULL, '', '', '注销登记（国有建设用地使用权及房屋所有权登记）', '', '511F0093300065-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (698, 1, NULL, '', '', '首次登记（国有建设用地使用权及房屋所有权登记）', '', '511F0093300062-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (699, 1, NULL, '', '', '转移登记（国有建设用地使用权及房屋所有权登记）', '', '511F0093300064-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (700, 1, NULL, '', '', '变更登记（国有建设用地使用权及房屋所有权登记）', '', '511F0093300063-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (701, 1, NULL, '', '', '变更登记（宅基地使用权及房屋所有权登记）', '', '511F0093300067-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (702, 1, NULL, '', '', '注销登记（宅基地使用权及房屋所有权登记）', '', '511F0093300069-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (703, 1, NULL, '', '', '转移登记（宅基地使用权及房屋所有权登记）', '', '511F0093300068-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (704, 1, NULL, '', '', '首次登记（宅基地使用权及房屋所有权登记）', '', '511F0093300066-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (705, 1, NULL, '', '', '转移登记（集体土地所有权登记）', '', '511F0093300059-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (706, 1, NULL, '', '', '首次登记(集体土地所有权登记）', '', '511F0093300060-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (707, 1, NULL, '', '', '变更登记（集体土地所有权登记）', '', '511F0093300058-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (708, 1, NULL, '', '', '注销登记（集体土地所有权登记）', '', '511F0093300061-510800000000-000-12510700MB10802250-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (709, 1, NULL, '', '', '缩小矿区范围变更登记', '', '511A15029004-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (710, 1, NULL, '', '', '采矿权人名称变更登记', '', '511A15029007-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (711, 1, NULL, '', '', '扩大矿区范围变更登记', '', '511A15029005-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (712, 1, NULL, '', '', '开采主矿种、开采方式变更登记', '', '511A15029006-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (713, 1, NULL, '', '', '采矿权转让变更登记', '', '511A15029003-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (714, 1, NULL, '', '', '土地权属争议裁决', '', '511E15002003-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (715, 1, NULL, '', '', '建筑工程竣工规划土地核实“多验合一”', '', '511Z0164200000-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (716, 1, NULL, '', '', '土地复垦验收确认', '', '511Z15012002-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (717, 1, NULL, '', '', '利用国家秘密测绘地理信息成果审批', '', '511A0195200000-510800000000-000-12510700060342539F-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (718, 1, NULL, '', '', '测绘资质单位分支机构登记', '', '511Z81007002-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (719, 1, NULL, '', '', '乡村建设规划许可证核发', '', '511A0149700000-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (720, 1, NULL, '', '', '地质灾害治理责任认定', '', '511F15002002-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (721, 1, NULL, '', '', '拟建项目范围内重要矿产资源分布和重要矿产资源矿业权设置情况查询', '', '512B0102600003-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (722, 1, NULL, '', '', '国有建设用地使用权出让后土地使用权分割转让批准', '', '511A0035800001-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (723, 1, NULL, '', '', '不动产登记资料查询', '', '512B0029400001-510800000000-000-12510700MB10802250-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (724, 1, NULL, '', '', '土地资产处置具体方案审核', '', '511Z0123900004-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (725, 1, NULL, '', '', '土地资产处置总体方案核准', '', '511Z0123900003-510800000000-000-11510700MB16763796-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (726, 1, NULL, '', '', '建设用地规划许可（划拨用地）', '', '511A0123100001-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (727, 1, NULL, '', '', '建设用地（含临时用地）规划许可证核发（出让用地）', '', '511A0123100002-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (728, 1, NULL, '', '', '建设用地规划许可证变更', '', '511A0123100004-510800000000-000-115107000084536026-1-00', NULL, '008450508', '市自然资源局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (729, 1, NULL, '', '', '华侨回国定居审批（拟定居地为原户籍注销地的）', '', '511A0045300005-510800000000-000-11510700008450129U-1-00', NULL, '4023400704831442944', '市侨务办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (730, 1, NULL, '', '', '华侨回国定居审批（拟定居地为非原户籍注销地）', '', '511A0045300006-510800000000-000-11510700008450129U-1-00', NULL, '4023400704831442944', '市侨务办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (731, 1, NULL, '', '', '民办普通高中、中职及非学历高等教育机构办学许可证到期换发', '', '511Z05002005-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (732, 1, NULL, '', '', '学生资助政策咨询', '', '512C0053300008-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (733, 1, NULL, '', '', '中等职业学校学生国家助学金查询', '', '512B0053300007-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (734, 1, NULL, '', '', '民办普通高中、中职校长变更审核确认', '', '511F05002003-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (735, 1, NULL, '', '', '普通高中国家助学金、免学费查询', '', '512B0053300004-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (736, 1, NULL, '', '', '普通话水平等级测试报名咨询', '', '51200501100005-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (737, 1, NULL, '', '', '教师资格认定', '', '511A0138600000-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (738, 1, NULL, '', '', '普通话证书查询', '', '512B0052700003-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (739, 1, NULL, '', '', '教师资格证相关政策咨询', '', '512C0051900002-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (740, 1, NULL, '', '', '学校办学基本情况咨询', '', '512C0052100002-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (741, 1, NULL, '', '', '教师资格证书补发、换发', '', '512B0155900000-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (742, 1, NULL, '', '', '四川省中等职业学校毕业生学历认证', '', '512B0358900000-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (743, 1, NULL, '', '', '招生考试政策咨询', '', '512C0052900007-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (744, 1, NULL, '', '', '中等职业学校筹设审批', '', '511A0050000037-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (745, 1, NULL, '', '', '普通高中设立审批', '', '511A0050000038-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (746, 1, NULL, '', '', '普通高中变更审批', '', '511A0050000039-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (747, 1, NULL, '', '', '普通高中筹设审批', '', '511A0050000036-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (748, 1, NULL, '', '', '其他高等教育机构筹设审批', '', '511A0050100023-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (749, 1, NULL, '', '', '其他高等教育机构设立审批', '', '511A0050100025-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (750, 1, NULL, '', '', '其他高等教育机构变更审批', '', '511A0050100029-510800000000-000-11510700008450209F-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (751, 1, NULL, '', '', '中小学教师职称评聘政策咨询', '', '512C0051800002-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (752, 1, NULL, '', '', '高中阶段（含中职学校）学籍异动政策咨询', '', '512C0052000010-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (753, 1, NULL, '', '', '高中阶段（含中职学校）学籍异动办理', '', '512B0052000008-510800000000-000-008450209-1-00', NULL, '008450209', '市教育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (754, 1, NULL, '', '', '国家4A级旅游景区推荐申报', '', '512B0049200006-510800000000-000-11510700451266246L-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (755, 1, NULL, '', '', '国家3A级及以下旅游景区评定', '', '512B0049200004-510800000000-000-11510700451266246L-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (756, 1, NULL, '', '', '省级生态旅游示范区等级初审', '', '512B0610100003-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (757, 1, NULL, '', '', '非国有文物收藏单位和其他单位借用国有文物收藏单位馆藏文物审批', '', '511A0073000001-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (758, 1, NULL, '', '', '文物定级', '', '511F0118100001-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (759, 1, NULL, '', '', '博物馆举办陈列展览备案', '', 'A-004013-4013-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (760, 1, NULL, '', '', '导游证核发', '', '511A22014002-510000000000-000-11510000MB1998968M-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (761, 1, NULL, '', '', '国有文物收藏单位之间借用馆藏文物备案', '', '511Z0224300000-510800000000-000-1151070006895023XR-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (762, 1, NULL, '', '', '广播电视视频点播业务许可证（乙种）审批', '', '511A0138400000-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (763, 1, NULL, '', '', '旅行社设立分社备案', '', '511Z22011005-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (764, 1, NULL, '', '', '县级广播电台、电视台变更节目设置范围审批', '', '511A32001002-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (765, 1, NULL, '', '', '县级广播电台、电视台变更节目套数审批', '', '511A32001003-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (766, 1, NULL, '', '', '县级广播电台、电视台变更台名审批', '', '511A32001001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (767, 1, NULL, '', '', '香港特别行政区、澳门特别行政区的投资者在内地投资设立合资、合作、独资经营的演出场所经营单位从事演出场所经营活动审批', '', '511A22009004-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (768, 1, NULL, '', '', '香港、澳门的投资者演出场所经营单位补证审批', '', '511A22009005-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (769, 1, NULL, '', '', '香港、澳门的投资者演出场所经营单位变更审批', '', '511A22009007-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (770, 1, NULL, '', '', '香港、澳门的投资者演出场所经营单位注销审批', '', '511A22009008-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (771, 1, NULL, '', '', '互联网上网服务营业场所经营单位变更审批', '', '511A2200200001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (772, 1, NULL, '', '', '互联网上网服务营业场所经营单位注销审批', '', '511A22002011-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (773, 1, NULL, '', '', '互联网上网服务营业场所经营单位补证审批', '', '511A22002010-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (774, 1, NULL, '', '', '互联网上网服务营业场所经营单位变更营业场所地址、改建、扩建终审审批', '', '511A22002014-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (775, 1, NULL, '', '', '艺术品经营单位注销备案', '', '511Z22003003-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (776, 1, NULL, '', '', '设立艺术品经营单位备案', '', '511Z0125100001-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (777, 1, NULL, '', '', '艺术品经营单位补证备案', '', '511Z22003004-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (778, 1, NULL, '', '', '艺术品经营单位变更备案', '', '511Z22003002-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (779, 1, NULL, '', '', '广播电台、电视台终止初审', '', '511A32006001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (780, 1, NULL, '', '', '广播电台、电视台设立初审', '', '511A0001400001-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (781, 1, NULL, '', '', '三星级及以下旅游饭店评定', '', 'A-005176-5176-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (782, 1, NULL, '', '', '五星、四星级旅游饭店评定推荐申报', '', '512B0049400005-510800000000-000-11510700451266246L-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (783, 1, NULL, '', '', '市级文物保护单位建设控制地带划定', '', 'F-000082-001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (784, 1, NULL, '', '', '变更县级文物保护单位用途审核', '', '511A0073600003-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (785, 1, NULL, '', '', '电视剧制作许可证（乙种）核发（此事项未列入国务院发布的《法律、行政法规、国务院决定设定的行政许可事项清单（2022年版）》，暂停办理）', '', '511A0351000000-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (786, 1, NULL, '', '', '其他经营单位增设艺术品经营业务的备案', '', '511Z22022001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (787, 1, NULL, '', '', '乡镇设立广播电视站和机关、部队、团体、企业事业单位设立有线广播电视站审批（根据省政府349号令，该事项办理已委托成都、德阳、绵阳、乐山、南充、泸州、宜宾、达州8个市实施）', '', '511A0139100000-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (788, 1, NULL, '', '', '市级文物保护单位原址保护措施审批', '', '511A0016700002-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (789, 1, NULL, '', '', '卫星电视广播地面接收设施安装服务许可', '', '511A0137400000-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (790, 1, NULL, '', '', '文物保护工程施工二级资质认定或增加二级资质业务范围的审批', '', '511A0044000033-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (791, 1, NULL, '', '', '文物保护工程监理乙级资质认定或增加乙级资质业务范围审批', '', '511A0044000030-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (792, 1, NULL, '', '', '对本级非物质文化遗产代表性项目的保护单位和代表性传承人的认定', '', '511F0554600000-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (793, 1, NULL, '', '', '文物保护工程勘察设计乙级资质认定或增加乙级资质业务范围的审批', '', '511A0044000017-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (794, 1, NULL, '', '', '台湾地区的投资者演出场所经营单位变更审批', '', '511A0072200006-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (795, 1, NULL, '', '', '台湾地区的投资者在内地投资设立合资、合作经营的演出场所经营单位从事演出场所经营活动审批', '', '511A0072300002-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (796, 1, NULL, '', '', '台湾地区的投资者演出场所经营单位注销审批', '', '511A22009009-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (797, 1, NULL, '', '', '台湾地区的投资者演出场所经营单位补证审批', '', '511A0072200004-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (798, 1, NULL, '', '', '文旅类民办非企业单位变更登记', '', '511A22005008-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (799, 1, NULL, '', '', '文旅类民办非企业单位设立登记', '', '511A22005009-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (800, 1, NULL, '', '', '文旅类民办非企业单位年检初审', '', '511A22005006-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (801, 1, NULL, '', '', '文旅类民办非企业单位注销登记', '', '511A22005007-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (802, 1, NULL, '', '', '文物认定', '', '511F0118200001-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (803, 1, NULL, '', '', '出境游名单审核', '', '511F22015001-510000000000-000-11510000MB1998968M-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (804, 1, NULL, '', '', '市级非国有不可移动文物转让、抵押或者改变用途备案', '', '511Z68005001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (805, 1, NULL, '', '', '博物馆处理不够入藏标准、无保存价值的文物或标本审批', '', '511A0073400001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (806, 1, NULL, '', '', '降低旅游服务质量保证金资格确认', '', '511F22016001-510000000000-000-11510000MB1998968M-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (807, 1, NULL, '', '', '市级文物保护单位修缮许可', '', '511A0013400003-510800000000-000-06895023X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (808, 1, NULL, '', '', '经营国内旅游和入境旅游业务旅行社设立许可', '', '511A2200700008-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (809, 1, NULL, '', '', '对本级非物质文化遗产代表性项目组织评审、推荐认定', '', 'F-000088-001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (810, 1, NULL, '', '', '博物馆、图书馆和其他文物收藏单位设置藏品档案的备案', '', '511Z68001002-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (811, 1, NULL, '', '', '博物馆、图书馆和其他文物收藏单位建立管理制度的备案', '', '511Z68001003-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (812, 1, NULL, '', '', '文物保护单位的建设控制地带内进行建设工程的许可', '', '511A0032000001-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (813, 1, NULL, '', '', '在县级文物保护单位保护范围内进行其他建设工程或者爆破、钻探、挖掘等作业审批', '', '511A68008010-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (814, 1, NULL, '', '', '旅行社注销审批', '', '511A2200700009-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (815, 1, NULL, '', '', '《旅行社业务经营许可证》变更审批', '', '511A2200700010-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (816, 1, NULL, '', '', '《旅行社业务经营许可证》补发审批', '', '511A2200700011-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (817, 1, NULL, '', '', '社会艺术水平考级机构发放艺术考级证书名单备案', '', '511Z22008004-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (818, 1, NULL, '', '', '社会艺术水平考级活动承办单位备案', '', '511Z22008003-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (819, 1, NULL, '', '', '社会艺术水平考级活动考前备案', '', '511Z22008002-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (820, 1, NULL, '', '', '文旅类社会团体年检初审', '', '511A22006012-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (821, 1, NULL, '', '', '文旅类社会团体筹备申请前审查', '', '511A22006010-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (822, 1, NULL, '', '', '文旅类社会团体成立登记前审查', '', '511A22006011-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (823, 1, NULL, '', '', '文旅类社会团体变更登记前审查', '', '511A22006013-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (824, 1, NULL, '', '', '文旅类社会团体注销登记前审查', '', '511A22006014-510800000000-000-11510700MB1934315X-1-00', NULL, '06895023X', '市文化广电旅游局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (825, 1, NULL, '', '', '纳税服务投诉处理', '', '51203002100002-510800000000-000-11510700MB1547518M-1-00', NULL, '008450524', '市税务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (826, 1, NULL, '', '', '社会公众涉税公开信息查询', '', '51203002000001-510800000000-000-11510700MB1547518M-1-00', NULL, '008450524', '市税务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (827, 1, NULL, '', '', '出口退（免）税分类管理评定申请', '', '511F3000200012-510800000000-000-11510700MB1547518M-1-00', NULL, '008450524', '市税务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (828, 1, NULL, '', '', '面对面咨询', '', '51203001900003-510800000000-000-11510700MB1547518M-1-00', NULL, '008450524', '市税务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (829, 1, NULL, '', '', '电话咨询', '', '51203001900001-510800000000-000-11510700MB1547518M-1-00', NULL, '008450524', '市税务局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (830, 1, NULL, '', '', '核实建设项目落实人民防空要求', '', '511Z99292001-510800000000-000-11510700744676177R-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (831, 1, NULL, '', '', '城市地下空间的规划和开发利用审批', '', '511Z0169800000-510800000000-000-744676177-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (832, 1, NULL, '', '', '人民防空工程平时使用备案', '', '512B0140700000-510800000000-000-744676177-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (833, 1, NULL, '', '', '建设项目人防工程设计审查施工许可阶段', '', '511A0047100009-510800000000-000-744676177-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (834, 1, NULL, '', '', '建设项目易地建设人防工程竣工验收', '', '511A35004001-510800000000-000-11510700744676177R-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (835, 1, NULL, '', '', '建设项目人防工程竣工验收', '', '511A0047100006-510800000000-000-744676177-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (836, 1, NULL, '', '', '建设项目人防工程设计审查规划审批阶段', '', '511A0047100008-510800000000-000-744676177-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (837, 1, NULL, '', '', '防空地下室易地建设费核定', '', '511A0047100007-510800000000-000-744676177-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (838, 1, NULL, '', '', '报废人民防空工程审批', '', '511A0046800004-510800000000-000-744676177-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (839, 1, NULL, '', '', '拆除人民防空工程审批', '', '511A35005002-510800000000-000-11510700744676177R-1-00', NULL, '744676177', '市国动办', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (840, 1, NULL, '', '', '统计严重失信企业名单信用修复', '', '512034008001-510800000000-000-115107000084504792-1-00', NULL, '115107000084504792', '市统计局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (841, 1, NULL, '', '', '再交易房个人住房公积金贷款预审', '', '512099175110-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (842, 1, NULL, '', '', '川渝签约城市联动治理违规提取使用公积金', '', '512099037002-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (843, 1, NULL, '', '', '职工到国外、港澳台地区定居提取', '', '512B0247900000-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (844, 1, NULL, '', '', '建造、翻建、大修自住住房提取', '', '512B0274000000-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (845, 1, NULL, '', '', '购房提取住房公积金', '', '512017019006-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (846, 1, NULL, '', '', '提前退休提取住房公积金', '', '51201742900011-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (847, 1, NULL, '', '', '个人住房公积金贷款提取', '', '51201742900004-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (848, 1, NULL, '', '', '退休提取住房公积金', '', '51201742900016-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (849, 1, NULL, '', '', '租房提取住房公积金', '', '51201742900005-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (850, 1, NULL, '', '', '住房公积金提取（死亡）', '', '51201742900006-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (851, 1, NULL, '', '', '正常退休提取住房公积金', '', '512017019003-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (852, 1, NULL, '', '', '开具住房公积金个人住房贷款全部还清证明', '', '512017021006-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (853, 1, NULL, '', '', '提前部分偿还住房公积金贷款', '', '51201742900010-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (854, 1, NULL, '', '', '提前还清住房公积金贷款', '', '512017021007-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (855, 1, NULL, '', '', '住房公积金单位登记开户', '', '512017020010-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (856, 1, NULL, '', '', '住房公积金个人账户封存', '', '51201742900015-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (857, 1, NULL, '', '', '住房公积金缴存单位信息变更', '', '51201742900017-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (858, 1, NULL, '', '', '单位账户封存', '', '51201742900012-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (859, 1, NULL, '', '', '出具单位住房公积金缴存证明', '', '51201742900019-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (860, 1, NULL, '', '', '住房公积金单位及个人缴存信息变更', '', '512017020011-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (861, 1, NULL, '', '', '个人住房公积金缴存贷款等信息查询（川渝签约城市公积金互认互贷）', '', '512038001001-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (862, 1, NULL, '', '', '个人住房公积金账号设立', '', '51201742900007-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (863, 1, NULL, '', '', '出具贷款职工住房公积金缴存使用证明', '', '512017020003-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (864, 1, NULL, '', '', '住房公积金转移接续', '', '51201742900018-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (865, 1, NULL, '', '', '住房公积金补缴', '', '51201742900009-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (866, 1, NULL, '', '', '住房公积金单位缴存登记注销', '', '51201742900014-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (867, 1, NULL, '', '', '住房公积金汇缴', '', '51201742900008-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (868, 1, NULL, '', '', '缴存比例调整', '', '512B0250100000-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (869, 1, NULL, '', '', '单位缴存登记注销（广元市）', '', '512B0249700000-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (870, 1, NULL, '', '', '缴存基数调整（广元市）', '', '512B0250000000-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (871, 1, NULL, '', '', '开具单位缴存证明', '', '512B0275400000-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (872, 1, NULL, '', '', '个人账户封存、启封', '', '512B0242600000-510800000000-000-125107007623014757-1-00', NULL, '3796903725084889088', '市公积金中心', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (873, 1, NULL, '', '', '举办攀登山峰活动审批', '', '511A0136000000-510800000000-000-058226168-1-00', NULL, '058226168', '市体育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (874, 1, NULL, '', '', '二级社会体育指导员技术等级称号认定', '', '511F33033002-510800000000-000-115107000582261686-1-00', NULL, '058226168', '市体育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (875, 1, NULL, '', '', '临时占用公共体育场（馆）设施审批（市级）', '', '511A33001001-510800000000-000-115107000582261686-1-00', NULL, '058226168', '市体育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (876, 1, NULL, '', '', '二级运动员称号授予', '', '511F33034002-510800000000-000-115107000582261686-1-00', NULL, '058226168', '市体育局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (877, 1, NULL, '', '', '停止办理或者限制办理邮政普遍服务特殊服务业务审批', '', '511A67002001-510800000000-000-111000000541444803-1-00', NULL, '4122768571212439552', '市邮政管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (878, 1, NULL, '', '', '撤销提供邮政普遍服务的邮政营业场所审批', '', '511A67001001-510800000000-000-111000000541444803-1-00', NULL, '4122768571212439552', '市邮政管理局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (879, 1, NULL, '', '', '对在气象工作中做出突出贡献的单位和个人进行奖励', '', 'H-000185-001-451266545', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (880, 1, NULL, '', '', '升放无人驾驶自由气球或者系留气球活动审批', '', '511A0154800000-510800000000-000-451266545-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (881, 1, NULL, '', '', '组织气候可行性论证', '', '511Z0170800000-510800000000-000-12510000451266545B-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (882, 1, NULL, '', '', '升放无人驾驶自由气球、系留气球单位资质认定', '', '511A0152800000-510800000000-000-451266545-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (883, 1, NULL, '', '', '雷电灾害鉴定', '', '511F0167300000-510800000000-000-451266545-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (884, 1, NULL, '', '', '新建、扩建、改建建设工程避免危害气象探测环境的审核转报', '', '511Z0170600000-510800000000-000-451266545-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (885, 1, NULL, '', '', '气象信息服务单位建立气象探测站（点）备案', '', '511Z0170100000-510800000000-000-451266545-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (886, 1, NULL, '', '', '雷电防护装置设计审核', '', '511A0155000000-510800000000-000-451266545-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (887, 1, NULL, '', '', '雷电防护装置竣工验收', '', '511A0036600001-510800000000-000-451266545-1-00', NULL, '451266545', '市气象局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (888, 1, NULL, '', '', '技术合同认定登记', '', '511F0053500001-510800000000-000-008450196-1-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (889, 1, NULL, '', '', '科技政策咨询服务', '', '512B0030200001-510800000000-000-11510700008450196R-null-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (890, 1, NULL, '', '', '外国人来华工作许可延期审批(高端、专业人才)', '', '511A0055300011-510800000000-000-11510700008450196R-null-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (891, 1, NULL, '', '', '境外外国人来华工作许可(高端、专业人才)', '', '511A0055300009-510800000000-000-11510700008450196R-null-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (892, 1, NULL, '', '', '外国人来华工作许可变更审批(高端、专业人才)', '', '511A0055300008-510800000000-000-11510700008450196R-null-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (893, 1, NULL, '', '', '境内外国人来华工作许可(高端、专业人才)', '', '511A0055300010-510800000000-000-11510700008450196R-null-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (894, 1, NULL, '', '', '外国人来华工作许可注销审批(高端、专业人才)', '', '511A0055300007-510800000000-000-11510700008450196R-null-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (895, 1, NULL, '', '', '境内外国人来华工作许可', '', '511A0055300002-510800000000-000-11510700MB1890113B-1-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (896, 1, NULL, '', '', '外国人来华工作许可延期审批', '', '511A0055300003-510800000000-000-11510700MB1890113B-1-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (897, 1, NULL, '', '', '外国人来华工作许可变更审批', '', '511A0055300004-510800000000-000-11510700MB1890113B-1-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (898, 1, NULL, '', '', '境外外国人来华工作许可', '', '511A0055300001-510800000000-000-11510700MB1890113B-1-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (899, 1, NULL, '', '', '外国人来华工作许可注销审批', '', '511A0055300005-510800000000-000-11510700MB1890113B-1-00', NULL, '008450196', '市科技局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (900, 1, NULL, '', '', '企业名称争议裁决', '', 'E-000021-001-008450567', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (901, 1, NULL, '', '', '承担国家法定计量检定机构任务授权', '', '511A0041800001-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (902, 1, NULL, '', '', '医疗器械经营企业跨行政区域设置库房备案', '', '513A0111400001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (903, 1, NULL, '', '', '市级“守合同重信用企业”公示', '', '51203100100006-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (904, 1, NULL, '', '', '企业登记档案资料查询', '', '512B0110700001-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (905, 1, NULL, '', '', '食品(含保健食品)经营许可变更经营者名称', '', '511A0005200010-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (906, 1, NULL, '', '', '食品(含保健食品)经营许可换发', '', '511A0005200005-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (907, 1, NULL, '', '', '食品(含保健食品)经营许可变更法定代表人（负责人）', '', '511A0005200001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (908, 1, NULL, '', '', '食品(含保健食品)经营许可核发', '', '511A0005200004-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (909, 1, NULL, '', '', '食品(含保健食品)经营许可注销', '', '511A0005200007-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (910, 1, NULL, '', '', '食品(含保健食品)经营许可补办', '', '511A0005200006-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (911, 1, NULL, '', '', '食品(含保健食品)经营许可变更经营场所（同址变更）', '', '511A0005200002-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (912, 1, NULL, '', '', '食品(含保健食品)经营许可变更主体业态', '', '511A0005200003-510800000000-000-115107000084508231-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (913, 1, NULL, '', '', '食品(含保健食品)经营许可变更经营项目', '', '511A0005200009-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (914, 1, NULL, '', '', '食品(含保健食品)经营许可变更住所', '', '511A0005200012-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (915, 1, NULL, '', '', '食品(含保健食品)经营许可延续', '', '511A0005200008-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (916, 1, NULL, '', '', '食品添加剂生产许可变更主要设施设备、工艺设备布局或工艺流程变更', '', '511A0005300011-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (917, 1, NULL, '', '', '食品添加剂生产许可核发', '', '511A0005300014-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (918, 1, NULL, '', '', '食品添加剂生产许可变更生产地址（增加/搬迁）', '', '511A0005300019-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (919, 1, NULL, '', '', '食品添加剂生产许可注销', '', '511A0005300018-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (920, 1, NULL, '', '', '食品添加剂生产许可延续', '', '511A0005300015-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (921, 1, NULL, '', '', '食品添加剂生产许可变更生产类别（减少，含同一类别内的明细减少）', '', '511A0005300012-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (922, 1, NULL, '', '', '食品添加剂生产许可变更生产地址（减少）', '', '511A0005300010-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (923, 1, NULL, '', '', '食品添加剂生产许可变更生产类别（增加，含同一类别内的明细增加）', '', '511A0005300013-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (924, 1, NULL, '', '', '食品添加剂生产许可变更住所名称', '', '511A0005300008-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (925, 1, NULL, '', '', '食品添加剂生产许可变更法定代表人（负责人）', '', '511A0005300007-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (926, 1, NULL, '', '', '食品添加剂生产许可补办', '', '511A0005300017-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (927, 1, NULL, '', '', '食品添加剂生产许可变更生产地址（同址变更）', '', '511A0005300009-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (928, 1, NULL, '', '', '食品添加剂生产许可变更生产者名称', '', '511A0005300016-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (929, 1, NULL, '', '', '股权出质注销/撤销登记', '', '511F31141003-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (930, 1, NULL, '', '', '股权出质设立登记', '', '511F31141001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (931, 1, NULL, '', '', '股权出质变更登记', '', '511F31141002-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (932, 1, NULL, '', '', '非公司企业法人分支机构设立登记', '', '511A0064100121-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (933, 1, NULL, '', '', '市场主体歇业备案', '', '511A31004005-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (934, 1, NULL, '', '', '申请增加、减少证照', '', '511A0064100220-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (935, 1, NULL, '', '', '分公司注销登记', '', '511A0064100064-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (936, 1, NULL, '', '', '因公司合并（分立）申请设立、变更或注销登记', '', '511A0064100098-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (937, 1, NULL, '', '', '公司备案', '', '511A0064100093-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (938, 1, NULL, '', '', '合伙企业变更登记', '', '511A0064100112-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (939, 1, NULL, '', '', '合伙企业注销登记', '', '511A0064100156-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (940, 1, NULL, '', '', '分公司设立登记', '', '511A0064100173-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (941, 1, NULL, '', '', '非公司企业法人备案', '', '511A0064100152-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (942, 1, NULL, '', '', '公司设立登记', '', '511A0064100070-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (943, 1, NULL, '', '', '个人独资企业设立登记', '', '511A0064100190-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (944, 1, NULL, '', '', '分公司变更登记（备案）', '', '511A0064100073-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (945, 1, NULL, '', '', '外商投资合伙企业分支机构设立登记', '', '511A0064100182-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (946, 1, NULL, '', '', '非公司企业法人分支机构变更登记（备案）', '', '511A0064100082-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (947, 1, NULL, '', '', '非公司企业法人设立登记', '', '511A0064100052-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (948, 1, NULL, '', '', '合伙企业分支机构设立登记', '', '511A0064100157-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (949, 1, NULL, '', '', '非公司企业法人按《公司法》改制登记', '', '511A0064100124-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (950, 1, NULL, '', '', '公司注销登记', '', '511A0064100118-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (951, 1, NULL, '', '', '公司变更登记', '', '511A0064100078-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (952, 1, NULL, '', '', '个人独资企业分支机构变更登记（备案）', '', '511A0064100214-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (953, 1, NULL, '', '', '非公司企业法人分支机构注销登记', '', '511A0064100109-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (954, 1, NULL, '', '', '个人独资企业注销登记', '', '511A0064100200-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (955, 1, NULL, '', '', '因公司的股东发生合并（分立），公司申请变更登记', '', '511A0064100128-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (956, 1, NULL, '', '', '合伙企业备案', '', '511A31004003-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (957, 1, NULL, '', '', '合伙企业设立登记', '', '511A0064100091-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (958, 1, NULL, '', '', '市场主体迁移调档', '', '511A0064100226-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (959, 1, NULL, '', '', '证照遗失补领、换发申请', '', '511A0064100101-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (960, 1, NULL, '', '', '个人独资企业分支机构注销登记', '', '511A0064100219-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (961, 1, NULL, '', '', '合伙企业分支机构变更登记（备案）', '', '511A0064100158-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (962, 1, NULL, '', '', '非公司企业法人变更登记', '', '511A0064100061-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (963, 1, NULL, '', '', '个人独资企业分支机构设立登记', '', '511A0064100213-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (964, 1, NULL, '', '', '非公司企业法人注销登记', '', '511A0064100063-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (965, 1, NULL, '', '', '撤销变更登记', '', '511A0064100083-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (966, 1, NULL, '', '', '个人独资企业变更登记（备案）', '', '511A0064100195-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (967, 1, NULL, '', '', '合伙企业分支机构注销登记', '', '511A0064100187-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (968, 1, NULL, '', '', '农民专业合作社（联合社）注销登记', '', '511A0074400020-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (969, 1, NULL, '', '', '农民专业合作社（联合社）备案登记', '', '511A0716700000-510800000000-000-11510700MB15766266-null-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (970, 1, NULL, '', '', '农民专业合作社（联合社）分支机构设立登记', '', '511A0074400012-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (971, 1, NULL, '', '', '农民专业合作社（联合社）分支机构注销登记', '', '511A0074400025-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (972, 1, NULL, '', '', '农民专业合作社（联合社）变更登记', '', '511A0074400011-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (973, 1, NULL, '', '', '农民专业合作社（联合社）分支机构变更登记（备案）', '', '511A0074400026-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (974, 1, NULL, '', '', '农民专业合作社（联合社）设立登记', '', '511A0074400015-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (975, 1, NULL, '', '', '《药品经营许可证》（零售连锁总部）补办', '', '511A72033005-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (976, 1, NULL, '', '', '《药品经营许可证》（零售连锁总部）许可事项变更', '', '511A72033007-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (977, 1, NULL, '', '', '《药品经营许可证》（零售连锁总部）重新审查发证', '', '511A72033003-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (978, 1, NULL, '', '', '《药品经营许可证》（零售）核发', '', '511A0026000011-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (979, 1, NULL, '', '', '《药品经营许可证》（零售连锁总部）登记事项变更', '', '511A72033006-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (980, 1, NULL, '', '', '《药品经营许可证》（零售连锁总部）注销', '', '511A72033004-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (981, 1, NULL, '', '', '《药品经营许可证》（零售）登记事项变更', '', '511A72033001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (982, 1, NULL, '', '', '《药品经营许可证》（零售）注销', '', '511A0026000013-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (983, 1, NULL, '', '', '《药品经营许可证》（零售）许可事项变更', '', '511A0023700034-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (984, 1, NULL, '', '', '《药品经营许可证》（零售）补办', '', '511A0026000014-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (985, 1, NULL, '', '', '《药品经营许可证》（零售）重新审查发证', '', '511A0026000015-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (986, 1, NULL, '', '', '第一类医疗器械产品备案变更', '', '513A0111600002-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (987, 1, NULL, '', '', '第一类医疗器械产品备案补证', '', '513A0111600003-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (988, 1, NULL, '', '', '第一类医疗器械产品备案', '', '513A0111600001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (989, 1, NULL, '', '', '第一类医疗器械产品备案取消', '', '513A0111600004-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (990, 1, NULL, '', '', '特种设备作业人员资格认定复审', '', '511A0358400002-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (991, 1, NULL, '', '', '特种设备作业人员资格认定取证', '', '511A0358400001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (992, 1, NULL, '', '', '特种设备作业人员资格认定补发', '', '511A0358400003-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (993, 1, NULL, '', '', '仅销售预包装食品经营者备案信息采集', '', '511Z31138001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (994, 1, NULL, '', '', '仅销售预包装食品经营者备案注销', '', '511Z31138005-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (995, 1, NULL, '', '', '仅销售预包装食品经营者备案信息变更', '', '511Z31138003-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (996, 1, NULL, '', '', '《放射性药品使用许可证》换发', '', '511A72006004-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (997, 1, NULL, '', '', '《放射性药品使用许可证》补办', '', '511A0075600002-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (998, 1, NULL, '', '', '《放射性药品使用许可证》核发', '', '511A0075600005-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (999, 1, NULL, '', '', '《放射性药品使用许可证》换发（一、二类放射性药品承诺方式）', '', '511A72006002-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1000, 1, NULL, '', '', '《放射性药品使用许可证》变更(一、二类放射性药品承诺方式）', '', '511A72006005-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (1001, 1, NULL, '', '', '《放射性药品使用许可证》注销', '', '511A0075600003-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1002, 1, NULL, '', '', '《放射性药品使用许可证》变更', '', '511A0075600007-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1003, 1, NULL, '', '', '《放射性药品使用许可证》核发（一、二类放射性药品承诺方式）', '', '511A72006001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1004, 1, NULL, '', '', '执业药师变更注册', '', '511A0019600003-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1005, 1, NULL, '', '', '专利侵权纠纷行政裁决', '', '511E31002002-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1006, 1, NULL, '', '', '麻醉药品和第一类精神药品运输证明核发', '', '511A0075300001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1007, 1, NULL, '', '', '对计量纠纷进行调解及仲裁检定', '', '511Z0100400001-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1008, 1, NULL, '', '', '四川省专利实施与产业化奖推荐', '', '51209929100097-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1009, 1, NULL, '', '', '执业药师首次注册', '', '511A0019600001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1010, 1, NULL, '', '', '医疗用毒性药品零售企业批准', '', '511A72011001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1011, 1, NULL, '', '', '麻醉药品和精神药品邮寄证明核发', '', '511A0075500001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1012, 1, NULL, '', '', '异地开展电梯维护保养单位相应资质证明告知', '', '512B0099600001-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1013, 1, NULL, '', '', '特种设备安装改造维修施工前告知', '', '512B0200500001-510800000000-000-11510700008450807B-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1014, 1, NULL, '', '', '食品生产许可变更生产地址（同址变更）（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600058-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1015, 1, NULL, '', '', '食品生产许可变更生产者名称（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600031-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1016, 1, NULL, '', '', '食品生产许可核发（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600053-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1017, 1, NULL, '', '', '食品生产许可延续（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐等除外）', '', '511A0080600054-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1018, 1, NULL, '', '', '食品生产许可变更生产类别（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600059-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1019, 1, NULL, '', '', '食品生产许可变更法定代表人（负责人）（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600039-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1020, 1, NULL, '', '', '食品生产许可注销（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600056-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1021, 1, NULL, '', '', '食品生产许可变更工艺设备布局和工艺流程（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600035-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1022, 1, NULL, '', '', '食品生产许可变更住所名称（保健食品、特殊医学用途配方食品、婴幼儿配方食品和白酒类除外）', '', '511A0080600032-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1023, 1, NULL, '', '', '食品生产许可补办（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600055-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1024, 1, NULL, '', '', '食品生产许可变更主要设施设备（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600030-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1025, 1, NULL, '', '', '食品生产许可变更生产地址（保健食品、特殊医学用途配方食品、婴幼儿配方食品、婴幼儿辅助食品、食盐除外）', '', '511A0080600036-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1026, 1, NULL, '', '', '对食品生产经营者自建网站交易备案进行发放', '', '513A0111500003-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1027, 1, NULL, '', '', '对食品生产者自建网站交易进行备案', '', '511Z31019001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1028, 1, NULL, '', '', '对食品生产经营者自建网站交易备案进行注销', '', '513A0111500001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1029, 1, NULL, '', '', '对食品生产经营者自建网站交易备案进行补办', '', '513A0111500004-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1030, 1, NULL, '', '', '对食品生产经营者自建网站交易进行备案', '', '513A0111500002-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1031, 1, NULL, '', '', '特种设备安装改造修理单位许可取证', '', '511A0358300022-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1032, 1, NULL, '', '', '移动式压力容器（气瓶）充装单位许可取证', '', '511A0358600000-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1033, 1, NULL, '', '', '移动式压力容器（气瓶）充装单位许可证补发', '', '511A0358300017-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1034, 1, NULL, '', '', '特种设备安装改造修理单位许可换证', '', '511A0358300019-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1035, 1, NULL, '', '', '移动式压力容器（气瓶）充装单位许可变更', '', '511A0358300014-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1036, 1, NULL, '', '', '特种设备安装改造修理单位许可增项', '', '511A0358300021-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1037, 1, NULL, '', '', '特种设备安装改造修理单位许可补发', '', '511A0358300020-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1038, 1, NULL, '', '', '特种设备安装改造修理单位许可变更', '', '511A0358700000-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1039, 1, NULL, '', '', '移动式压力容器（气瓶）充装单位许可换证', '', '511A0358300011-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1040, 1, NULL, '', '', '移动式压力容器（气瓶）充装单位许可增项', '', '511A0358300008-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1041, 1, NULL, '', '', '特种设备安装改造修理单位许可注销', '', '511A0358300025-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1042, 1, NULL, '', '', '移动式压力容器（气瓶）充装单位许可注销', '', '511A0358300026-510000000000-000-11510000MB1690541M-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1043, 1, NULL, '', '', '计量标准器具核准新建', '', '511A0041000003-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1044, 1, NULL, '', '', '计量标准变更', '', '511A0041000004-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1045, 1, NULL, '', '', '计量标准器具核准证书变更', '', '511A0041000006-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1046, 1, NULL, '', '', '计量标准器具核准复查', '', '511A0041000002-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1047, 1, NULL, '', '', '计量标准器具核准证书补办', '', '511A0041000007-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1048, 1, NULL, '', '', '计量标准封存或撤销', '', '511A0041000005-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1049, 1, NULL, '', '', '第三类医疗器械经营许可补办', '', '511A0026100015-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1050, 1, NULL, '', '', '第三类医疗器械经营许可变更(需现场核查)', '', '511A0026100004-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1051, 1, NULL, '', '', '第三类医疗器械经营许可注销', '', '511A0026100016-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1052, 1, NULL, '', '', '第三类医疗器械经营许可核发', '', '511A0026100005-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1053, 1, NULL, '', '', '第三类医疗器械经营许可延续', '', '511A0026100014-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1054, 1, NULL, '', '', '第三类医疗器械经营许可变更(不需现场核查)', '', '511A72021001-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1055, 1, NULL, '', '', '执业药师注销注册', '', '511A0019600004-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1056, 1, NULL, '', '', '执业药师延续注册', '', '511A0019600002-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1057, 1, NULL, '', '', '四川省专利实施与产业化奖评审', '', '512099291001-510000000000-000-125100004507240067-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1058, 1, NULL, '', '', '企事业单位计量器具检定授权', '', '511Z0100300001-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1059, 1, NULL, '', '', '第二类精神药品零售业务审批', '', '511A0075200001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1060, 1, NULL, '', '', '消费纠纷调解', '', 'A-005818-5818-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1061, 1, NULL, '', '', '特种设备使用登记', '', '511A0041400002-510800000000-000-008450807-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1062, 1, NULL, '', '', '特殊标志使用人书面使用合同存查', '', '511Z0113600001-510800000000-000-11510700008450567G-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1063, 1, NULL, '', '', '麻醉药品和精神药品购买审批', '', '511A0075400001-510000000000-000-11510000MB1808933T-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1064, 1, NULL, '', '', '医疗机构炮制中药饮片备案', '', '511Z72008002-510800000000-000-11510700MB15766266-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1065, 1, NULL, '', '', '第一类医疗器械生产备案补证', '', '513A0111700003-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1066, 1, NULL, '', '', '第一类医疗器械生产备案变更', '', '513A0111700002-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1067, 1, NULL, '', '', '第一类医疗器械生产备案', '', '513A0111700001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1068, 1, NULL, '', '', '医疗器械网络销售备案变更', '', '513A0118500002-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1069, 1, NULL, '', '', '医疗器械网络销售备案', '', '513A0118500001-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1070, 1, NULL, '', '', '第二类医疗器械经营备案', '', '513A0106300015-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1071, 1, NULL, '', '', '第二类医疗器械经营备案补证', '', '513A0106300016-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1072, 1, NULL, '', '', '第二类医疗器械经营备案变更', '', '513A0106300005-510800000000-000-008450823-1-00', NULL, '11510700008450567G', '市市场监管局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1073, 1, NULL, '', '', '在公路增设或改造平面交叉道口审批', '', '511A0141700000-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1074, 1, NULL, '', '', '水路旅客班轮运输业务经营者对班轮运输航线停止经营的备案', '', '513A0128000000-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1075, 1, NULL, '', '', '网约车车辆信息备案', '', '511Z0169300000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1076, 1, NULL, '', '', '通航建筑物运行方案审批(市级)', '', '511A18052001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1077, 1, NULL, '', '', '从事船舶代理、水路旅客运输代理、水路货物运输代理业务的备案', '', '1J-5100-00030-510800000000-000-12510700451268305E-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1078, 1, NULL, '', '', '定制客运备案', '', '511Z18280001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1079, 1, NULL, '', '', '普通公路建设项目施工许可', '', '511A0016100001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1080, 1, NULL, '', '', '新建、改建、扩建储存、装卸危险货物的港口建设项目的安全条件审查', '', '511A0156900000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1081, 1, NULL, '', '', '公路工程招标备案', '', '511Z18020001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1082, 1, NULL, '', '', '水运工程招标备案', '', '513A0127800000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1083, 1, NULL, '', '', '非经营性危险货物运输许可（注销）', '', '511A1802800002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1084, 1, NULL, '', '', '非经营性危险货物运输许可（换发）', '', '511A1802800001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1085, 1, NULL, '', '', '非经营性危险货物运输许可', '', '511A0014700001-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1086, 1, NULL, '', '', '网络预约出租汽车驾驶员从业资格证换发', '', '511A1840000015-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1087, 1, NULL, '', '', '网络预约出租汽车驾驶员证发放', '', '511A0015000004-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1088, 1, NULL, '', '', '网络预约出租汽车驾驶员从业资格证件注销', '', '511A1840000018-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1089, 1, NULL, '', '', '网络预约出租汽车驾驶员从业资格证件变更', '', '511A1840000017-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1090, 1, NULL, '', '', '网络预约出租汽车驾驶员从业资格证补办', '', '511A1840000016-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1091, 1, NULL, '', '', '经营性道路货物运输驾驶员从业资格证注销', '', '511A1840000009-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1092, 1, NULL, '', '', '经营性道路货物运输驾驶员从业资格证转籍', '', '511A1840000010-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1093, 1, NULL, '', '', '经营性道路货物运输驾驶员从业资格证核发', '', '511A0015000002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1094, 1, NULL, '', '', '经营性道路货物运输驾驶员从业资格证变更', '', '511A1840000008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1095, 1, NULL, '', '', '经营性道路货物运输驾驶员从业资格证补发', '', '511A1840000007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1096, 1, NULL, '', '', '经营性道路货物运输驾驶员从业资格证换证', '', '511A1840000006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1097, 1, NULL, '', '', '巡游出租汽车驾驶员从业资格证件变更', '', '511A1840000013-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (1098, 1, NULL, '', '', '巡游出租汽车驾驶员从业资格证件补发', '', '511A1840000012-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1099, 1, NULL, '', '', '巡游出租汽车驾驶员从业资格证件核发', '', '511A0015000003-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1100, 1, NULL, '', '', '巡游出租汽车驾驶员从业资格证件换证', '', '511A1840000011-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1101, 1, NULL, '', '', '巡游出租汽车驾驶员从业资格证件注销', '', '511A1840000014-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1102, 1, NULL, '', '', '经营性道路旅客运输驾驶员从业资格证注销', '', '511A1840000005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1103, 1, NULL, '', '', '经营性道路旅客运输驾驶员从业资格证核发', '', '511A0015000001-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1104, 1, NULL, '', '', '经营性道路旅客运输驾驶员从业资格证转籍', '', '511A1840000003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1105, 1, NULL, '', '', '经营性道路旅客运输驾驶员从业资格证换证', '', '511A1840000001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1106, 1, NULL, '', '', '经营性道路旅客运输驾驶员从业资格证变更', '', '511A1840000004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1107, 1, NULL, '', '', '经营性道路旅客运输驾驶员从业资格证补发', '', '511A1840000002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1108, 1, NULL, '', '', '因修建铁路、机场、供电、水利、通信等建设工程需要占用、挖掘高速（大件）公路、高速（大件）公路用地或者使高速（大件）公路改线审批', '', '511A0099100006-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1109, 1, NULL, '', '', '占用、挖掘普通公路、普通公路用地或者使公路改线审批', '', '511A0099100005-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1110, 1, NULL, '', '', '汽车客运站的站级核定', '', '511Z18021004-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1111, 1, NULL, '', '', '大型设施、移动式平台、超限物体水上拖带审批', '', '511A0140900000-510800000000-000-12510700451268305E-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1112, 1, NULL, '', '', '水运工程建设项目初步设计审批', '', '511A0013800005-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1113, 1, NULL, '', '', '适用于四川省高速公路范围内需半幅断道7天及以上的养护工程', '', '511A0099300002-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1114, 1, NULL, '', '', '更新采伐护路林审批', '', '511A0141000000-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1115, 1, NULL, '', '', '普通公路工程交工验收备案', '', '511Z18003007-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1116, 1, NULL, '', '', '普通公路参建单位（设计、施工、监理等）相关资质、信用等级查询', '', '51201828400003-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1117, 1, NULL, '', '', '道路危险货物运输变更许可事项', '', '511A0014700004-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1118, 1, NULL, '', '', '水运工程建设项目施工图设计审批', '', '511A0013800006-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1119, 1, NULL, '', '', '船舶国籍证书核发', '', '511A0141300000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1120, 1, NULL, '', '', '客货运输车辆年度审验', '', '511Z0168300000-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1121, 1, NULL, '', '', '网络预约出租汽车运输证发放（新增）', '', '511A1839100006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1122, 1, NULL, '', '', '网络预约出租汽车运输证发放（换发）', '', '511A1839100014-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1123, 1, NULL, '', '', '网络预约出租汽车运输证发放（信息变更）', '', '511A1839100008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1124, 1, NULL, '', '', '网络预约出租汽车运输证发放（注销）', '', '511A1839100009-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1125, 1, NULL, '', '', '网络预约出租汽车运输证发放（补办）', '', '511A1839100007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1126, 1, NULL, '', '', '巡游出租汽车道路运输证核发（新增）', '', '511A0015400002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1127, 1, NULL, '', '', '巡游出租汽车道路运输证核发（信息变更）', '', '511A1839100004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1128, 1, NULL, '', '', '巡游出租汽车道路运输证核发（注销）', '', '511A1839100005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1129, 1, NULL, '', '', '巡游出租汽车道路运输证核发（换发）', '', '511A1839100003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1130, 1, NULL, '', '', '巡游出租汽车道路运输证核发（补办）', '', '511A1839100002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1131, 1, NULL, '', '', '省内水路运输船舶营业运输证配发（到期换证）', '', '511Z1829500006-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1132, 1, NULL, '', '', '省内水路运输船舶营业运输证配发（注销）', '', '511Z1829500007-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1133, 1, NULL, '', '', '省内水路运输船舶营业运输证配发（变更）', '', '511Z1829500005-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1134, 1, NULL, '', '', '省内水路运输船舶营业运输证配发（新办）', '', '511Z1829500004-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1135, 1, NULL, '', '', '危险货物运输车辆道路运输证办理(换发)', '', '511A1802800010-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1136, 1, NULL, '', '', '危险货物运输车辆道路运输证办理(补办)', '', '511A1802800009-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1137, 1, NULL, '', '', '危险货物运输车辆道路运输证办理（延期）', '', '511A1802800016-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1138, 1, NULL, '', '', '危险货物运输车辆道路运输证办理（变更）', '', '511A1802800011-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1139, 1, NULL, '', '', '危险货物运输车辆道路运输证办理(配发)', '', '511A1802800008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1140, 1, NULL, '', '', '危险货物运输车辆道路运输证办理（转入）', '', '511A1802800014-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1141, 1, NULL, '', '', '危险货物运输车辆道路运输证办理（过户）', '', '511A1802800015-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1142, 1, NULL, '', '', '危险货物运输车辆道路运输证办理(注销)', '', '511A1802800012-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1143, 1, NULL, '', '', '危险货物运输车辆道路运输证办理（转出）', '', '511A1802800013-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1144, 1, NULL, '', '', '客运班线延续经营许可', '', '511A0014100002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1145, 1, NULL, '', '', '设置非公路标志审批', '', '511A0141500000-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1146, 1, NULL, '', '', '对客运经营者在发车时间安排上发生纠纷客运站经营者协调无效的裁决', '', 'E-000004-001-008450356', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1147, 1, NULL, '', '', '变更或改造码头等固定经营设施的备案', '', '513A0128100000-510800000000-000-12510700451268305E-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1148, 1, NULL, '', '', '普通公路项目信息（进度、资金补助政策等）查询', '', '51201828400004-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1149, 1, NULL, '', '', '道路危险货物运输企业设立子公司许可', '', '511A0014700003-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1150, 1, NULL, '', '', '道路危险货物运输企业异地经营备案', '', '511Z0169100000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1151, 1, NULL, '', '', '城市公共汽电车线路运营权特许经营', '', '511Z0112100001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1152, 1, NULL, '', '', '客运线路经营主体、起讫地变更许可（变更经营主体）', '', '511A1804500003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1153, 1, NULL, '', '', '客运线路经营主体、起讫地变更许可（变更起讫地）', '', '511A1804500004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1154, 1, NULL, '', '', '道路客运班线经营许可证明（初领）', '', '511A1804500009-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1155, 1, NULL, '', '', '道路客运班线经营许可证明（换发）', '', '511A1804500011-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1156, 1, NULL, '', '', '道路旅客包车客运经营许可证明（补发）', '', '511A1804500016-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1157, 1, NULL, '', '', '道路客运班线经营许可证明（补发）', '', '511A1804500012-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1158, 1, NULL, '', '', '道路旅客包车客运经营许可证明（初领）', '', '511A1804500013-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1159, 1, NULL, '', '', '道路客运班线经营许可证明（变更）', '', '511A1804500010-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1160, 1, NULL, '', '', '道路旅客包车客运经营许可证明（变更）', '', '511A1804500014-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1161, 1, NULL, '', '', '道路旅客包车客运经营许可证明（换发）', '', '511A1804500015-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1162, 1, NULL, '', '', '在高速（大件）公路建筑控制区内埋设管道、电缆等设施许可', '', '511A0100800003-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1163, 1, NULL, '', '', '在普通公路建筑控制区内埋设管线、电缆等设施许可', '', '511A0100800004-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1164, 1, NULL, '', '', '道路危险货物运输经营许可（换发）', '', '511A1802800003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1165, 1, NULL, '', '', '道路危险货物运输经营许可（注销）', '', '511A1802800004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1166, 1, NULL, '', '', '道路危险货物运输经营许可', '', '511A0014700002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1167, 1, NULL, '', '', '农村公路建设项目初步设计审批', '', '511A1801000023-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1168, 1, NULL, '', '', '除省级交通运输主管部门负责审批的普通国省干线公路桥梁大中修、改建（重建）工程两阶段初步设计审批', '', '511A1801000016-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1169, 1, NULL, '', '', '农村公路建设项目施工图设计审批', '', '511A1801000030-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1170, 1, NULL, '', '', '库区淹没还建公路两阶段施工图', '', '511A1801000010-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1171, 1, NULL, '', '', '大件公路新改建两阶段施工图', '', '511A1801000006-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1172, 1, NULL, '', '', '除大件公路、库区淹没还建公路以外的普通国省干线新改建项目两阶段施工图设计', '', '511A1801000018-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1173, 1, NULL, '', '', '普通国省干线公路申请部、省补助的4类或5类长大桥隧或特殊桥梁的大修和改建（重建）工程两阶段施工图设计审批', '', '511A1801000032-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1174, 1, NULL, '', '', '普通国省干线公路较大设计变更审批', '', '511A1801000019-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1175, 1, NULL, '', '', '普通国省干线公路重大设计变更施工图审批', '', '511A1801000015-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1176, 1, NULL, '', '', '农村公路建设项目设计变更审批', '', '511A1801000013-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1177, 1, NULL, '', '', '专用航标设置、撤除、位置移动和其他状况改变审批', '', '511A0140300000-510800000000-000-12510700451268305E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1178, 1, NULL, '', '', '船舶最低安全配员证书签发', '', '511A0125600000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1179, 1, NULL, '', '', '道路旅客运输企业设立子公司经营许可', '', '511A0014200003-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1180, 1, NULL, '', '', '普通货船新增备案', '', '1J-5100-00022-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1181, 1, NULL, '', '', '道路旅客运输经营者扩大经营范围', '', '511A0014200002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1182, 1, NULL, '', '', '船舶进行散装液体污染危害性货物水上过驳作业审批', '', '511A0101900002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1183, 1, NULL, '', '', '巡游出租汽车车辆经营权变更', '', '511A0015200003-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1184, 1, NULL, '', '', '国内水路运输经营范围变更（个人）', '', '511A18032009-510800000000-000-12510700451268305E-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1185, 1, NULL, '', '', '国内水路运输经营许可证补办(市级)', '', '511A18019009-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1186, 1, NULL, '', '', '国内水路运输经营省内危险品船运输新办（企业）', '', '511A18032006-510800000000-000-12510700451268305E-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1187, 1, NULL, '', '', '国内水路运输经营省内普货、客船运输新办（企业）', '', '511A18032005-510800000000-000-12510700451268305E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1188, 1, NULL, '', '', '国内水路运输经营延续经营', '', '511A18032010-510800000000-000-12510700451268305E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1189, 1, NULL, '', '', '国内水路运输经营范围变更（企业）(市级)', '', '511A18019008-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1190, 1, NULL, '', '', '国内水路运输客船、危险品船新增运力', '', '511A18032013-510800000000-000-12510700451268305E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1191, 1, NULL, '', '', '国内水路运输经营普货运输新办（个人）', '', '511A18032007-510800000000-000-12510700451268305E-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1192, 1, NULL, '', '', '国内水路运输经营许可证注销(市级)', '', '511A18019010-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1193, 1, NULL, '', '', '客运车辆道路运输证办理（转入）', '', '511A1839800011-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1194, 1, NULL, '', '', '客运车辆道路运输证办理（换发）', '', '511A1839800007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1195, 1, NULL, '', '', '客运车辆道路运输证办理（转出）', '', '511A1839800010-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (1196, 1, NULL, '', '', '客运车辆道路运输证办理（补办）', '', '511A1839800006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1197, 1, NULL, '', '', '客运车辆道路运输证办理（配发）', '', '511A18398001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1198, 1, NULL, '', '', '客运车辆道路运输证办理（注销）', '', '511A1839800009-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1199, 1, NULL, '', '', '客运车辆道路运输证办理（延期）', '', '511A1839800013-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1200, 1, NULL, '', '', '客运车辆道路运输证办理（过户）', '', '511A1839800012-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1201, 1, NULL, '', '', '客运车辆道路运输证办理（变更）', '', '511A1839800008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1202, 1, NULL, '', '', '跨越、穿越高速（大件）公路修建桥梁、渡槽及在高速（大件）公路用地范围内架设、埋设管线、电缆等设施，或者利用高速（大件）公路桥梁、隧道、涵洞铺设电缆等设施许可', '', '511A0099200010-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1203, 1, NULL, '', '', '跨越、穿越普通公路修建桥梁、渡槽或者架设、埋设管线等设施的，以及在普通公路用地范围内架设、埋设管线、电缆等设施，或者利用普通公路桥梁、普通公路隧道、涵洞铺设电缆等设施的许可', '', '511A0099200009-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1204, 1, NULL, '', '', '客运线路许可（新增）', '', '511A0014100001-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1205, 1, NULL, '', '', '客运线路经营许可（变更）', '', '511A1804500001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1206, 1, NULL, '', '', '客运线路经营许可（终止运营）', '', '511A1804500002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1207, 1, NULL, '', '', '包车客运（旅游）经营许可（增投运力）', '', '511A1804500007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1208, 1, NULL, '', '', '包车客运（旅游）经营许可（新增）', '', '511A0014100004-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1209, 1, NULL, '', '', '包车客运（旅游）经营许可（变更经营主体）', '', '511A1804500005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1210, 1, NULL, '', '', '包车客运（旅游）经营许可（终止运营）', '', '511A1804500008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1211, 1, NULL, '', '', '包车客运（旅游）经营许可（延续经营）', '', '511A1804500006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1212, 1, NULL, '', '', '道路旅客运输经营许可（注销）', '', '511A1839800003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1213, 1, NULL, '', '', '道路旅客运输经营许可（新增）', '', '511A0014200001-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1214, 1, NULL, '', '', '道路旅客运输经营许可（换发）', '', '511A1839800002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1215, 1, NULL, '', '', '光船租赁登记', '', '511F0108800008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1216, 1, NULL, '', '', '船舶变更登记', '', '511F0108800010-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1217, 1, NULL, '', '', '船舶注销登记', '', '511F0108800009-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1218, 1, NULL, '', '', '船舶所有权登记', '', '511F0108800006-510800000000-000-008450356-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1219, 1, NULL, '', '', '船舶抵押权登记', '', '511F0108800007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1220, 1, NULL, '', '', '重大事故隐患的排查和处理情况的备案', '', '1J-5100-00027-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1221, 1, NULL, '', '', '安全评价报告以及落实情况的备案', '', '1J-5100-00019-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1222, 1, NULL, '', '', '重大危险源安全、应急措施备案', '', '1J-5100-00025-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1223, 1, NULL, '', '', '建设港口设施使用非深水岸线审批', '', '511A0139900000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1224, 1, NULL, '', '', '与航道有关的工程建设项目对航道通航条件影响评价审核', '', '511F18001002-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1225, 1, NULL, '', '', '道路危险货物运输押运员信息查询', '', '51201828200008-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1226, 1, NULL, '', '', '经营性道路旅客运输驾驶员信息查询', '', '51201828200007-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1227, 1, NULL, '', '', '经营性道路普货运输驾驶员信息查询', '', '51201828200005-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1228, 1, NULL, '', '', '普通公路行业技术标准查询', '', '51201828500003-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1229, 1, NULL, '', '', '普通公路行业政策制度查询', '', '51201828500004-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1230, 1, NULL, '', '', '船员培训机构开班备案', '', '513A0142300000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1231, 1, NULL, '', '', '巡游出租汽车车辆经营权到期后继续经营', '', '511A0015200004-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1232, 1, NULL, '', '', '水路运输业务变化事项的备案(法定代表人、固定办公场所、公司名称、经济类型变化)', '', '511Z18019001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1233, 1, NULL, '', '', '水路运输业务变化事项的备案(船舶管理企业发生变化)', '', '511Z18019003-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1234, 1, NULL, '', '', '水路运输业务变化事项的备案(主要股东、海务机务、高级船员比例发生变化、船舶发生重大以上事故、船舶管理企业协议发生变化)', '', '511Z18019002-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1235, 1, NULL, '', '', '道路危险货物运输装卸管理人员和押运人员从业资格证注销', '', '511A1802900012-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1236, 1, NULL, '', '', '道路危险货物运输装卸管理人员和押运人员从业资格证变更', '', '511A1802900011-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1237, 1, NULL, '', '', '道路危险货物运输装卸管理人员和押运人员从业资格证转籍', '', '511A1802900010-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1238, 1, NULL, '', '', '道路危险货物运输装卸管理人员和押运人员从业资格证换证', '', '511A1802900008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1239, 1, NULL, '', '', '道路危险货物运输装卸管理人员和押运人员从业资格证补发', '', '511A1802900009-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1240, 1, NULL, '', '', '道路危险货物运输装卸管理人员和押运人员从业资格证核发', '', '511A0015300002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1241, 1, NULL, '', '', '巡游出租汽车经营许可证到期换证', '', '511A1802200004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1242, 1, NULL, '', '', '巡游出租汽车业户信息变更', '', '511A1802200002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1243, 1, NULL, '', '', '巡游出租汽车经营许可注销', '', '511A1802200003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1244, 1, NULL, '', '', '巡游出租汽车经营许可', '', '511A1802200001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1245, 1, NULL, '', '', '放射性物品道路运输从业人员资格证补发', '', '511A18346002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1246, 1, NULL, '', '', '放射性物品道路运输从业人员资格证核发', '', '511A0140000000-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1247, 1, NULL, '', '', '放射性物品道路运输从业人员资格证转籍', '', '511A18346003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1248, 1, NULL, '', '', '放射性物品道路运输从业人员资格证换证', '', '511A18346001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1249, 1, NULL, '', '', '放射性物品道路运输从业人员资格证变更', '', '511A18346004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1250, 1, NULL, '', '', '放射性物品道路运输从业人员资格证注销', '', '511A18346005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1251, 1, NULL, '', '', '小微型客车租赁备案（变更）', '', '511Z18013001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1252, 1, NULL, '', '', '小微型客车租赁备案（注销）', '', '511Z18013002-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1253, 1, NULL, '', '', '小微型客车租赁备案（新增）', '', '513A0139800000-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1254, 1, NULL, '', '', '网络预约出租汽车经营许可', '', '511A0015200005-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1255, 1, NULL, '', '', '网络预约出租汽车业户信息变更', '', '511A1802200006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1256, 1, NULL, '', '', '网络预约出租汽车经营注销', '', '511A1802200007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1257, 1, NULL, '', '', '网络预约出租汽车经营许可证到期换证', '', '511A1802200005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1258, 1, NULL, '', '', '道路危险货物运输驾驶员信息查询', '', '51201828200006-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1259, 1, NULL, '', '', '公路超限运输许可', '', '511A0101400001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1260, 1, NULL, '', '', '水运工程建设项目竣工验收', '', '511A0140600000-510800000000-000-008450356-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1261, 1, NULL, '', '', '在内河通航水域进行可能影响通航安全的作业前备案', '', '513A0142100000-510800000000-000-12510700451268305E-1-00', NULL, '', '', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1262, 1, NULL, '', '', '船舶港口服务和港口设施设备机械租赁维修业务', '', '511Z0301000000-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1263, 1, NULL, '', '', '道路危险货物运输驾驶员从业资格证转籍', '', '511A1802900007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1264, 1, NULL, '', '', '道路危险货物运输驾驶员从业资格证注销', '', '511A1802900006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1265, 1, NULL, '', '', '道路危险货物运输驾驶员从业资格证补发', '', '511A1802900004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1266, 1, NULL, '', '', '道路危险货物运输驾驶员从业资格证变更', '', '511A1802900005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1267, 1, NULL, '', '', '道路危险货物运输驾驶员从业资格证换证', '', '511A1802900003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1268, 1, NULL, '', '', '道路危险货物运输驾驶员从业资格证核发', '', '511A0015300001-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1269, 1, NULL, '', '', '港口经营许可经营范围变更', '', '511A18370003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1270, 1, NULL, '', '', '港口经营许可延续经营', '', '511A18370004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1271, 1, NULL, '', '', '港口经营许可新办（拖轮除外）', '', '511A18370001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1272, 1, NULL, '', '', '港口经营许可补办', '', '511A18370005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1273, 1, NULL, '', '', '港口经营许可换证', '', '511A18370006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1274, 1, NULL, '', '', '港口经营许可新办（拖轮）', '', '511A18370002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1275, 1, NULL, '', '', '港口经营许可注销', '', '511A18370007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1276, 1, NULL, '', '', '通航水域岸线安全适用许可', '', '511A18394001-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1277, 1, NULL, '', '', '通航水域水上水下活动许可', '', '511A0105300002-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1278, 1, NULL, '', '', '省际包车客运趟次备案', '', '511Z18005001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1279, 1, NULL, '', '', '省内包车客运趟次备案', '', '511Z18005003-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1280, 1, NULL, '', '', '经营性放射性物品道路运输经营许可（注销）', '', '511A1834700004-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1281, 1, NULL, '', '', '经营性放射性物品道路运输经营许可（换发）', '', '511A1834700003-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1282, 1, NULL, '', '', '经营性放射性物品道路运输经营许可', '', '511A0014800002-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1283, 1, NULL, '', '', '农村公路建设项目竣工验收审批', '', '511A1800800003-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1284, 1, NULL, '', '', '国省道建设项目竣工验收', '', '511A1800800004-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1285, 1, NULL, '', '', '非经营性放射性物品道路运输许可（换发）', '', '511A1834700001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1286, 1, NULL, '', '', '非经营性放射性物品道路运输许可', '', '511A0014800001-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1287, 1, NULL, '', '', '非经营性放射性物品道路运输许可（注销）', '', '511A1834700002-510800000000-000-115107000084503561-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1288, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理(换发)', '', '511A1834700007-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1289, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理(注销)', '', '511A1834700009-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1290, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理(补办)', '', '511A1834700006-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1291, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理（变更）', '', '511A1834700008-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1292, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理（转出）', '', '511A1834700010-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1293, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理（转入）', '', '511A1834700011-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (1294, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理(配发)', '', '511A1834700005-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1295, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理（过户）', '', '511A1834700012-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1296, 1, NULL, '', '', '放射性物品运输车辆道路运输证办理（延期）', '', '511A1834700013-510800000000-000-115107000084503561-null-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1297, 1, NULL, '', '', '船员适任证书核发', '', '511A0112800003-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1298, 1, NULL, '', '', '船员特殊培训资格认定', '', '511A0112800004-510800000000-000-008450356-1-00', NULL, '008450356', '市交通运输局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1299, 1, NULL, '', '', '出售、收购国家二级保护野生植物新办审批', '', '511A0144200000-510000000000-000-8282348-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1300, 1, NULL, '', '', '森林更新验收合格证核发', '', '511Z64216001-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1301, 1, NULL, '', '', '采伐作业质量验收证明签发', '', '511Z64216002-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1302, 1, NULL, '', '', '在风景名胜区内从事建设、设置广告、举办大型游乐活动以及其他影响生态和景观活动新办许可（设区的市级权限）', '', '511A6422200003-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1303, 1, NULL, '', '', '古树名木认定', '', '511F64043001-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1304, 1, NULL, '', '', '森林经营单位修筑直接为林业生产服务的工程设施占用林地审批(市级)', '', '511A64026003-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1305, 1, NULL, '', '', '进入地方级自然保护区核心区从事科学研究观测、调查活动新办审批（设区的市级权限）', '', '511A6422100011-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1306, 1, NULL, '', '', '森林高火险期内进入森林高火险区新办审批（设区的市级权限）', '', '511A64029001-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1307, 1, NULL, '', '', '草原防火期内在草原上进行爆破、勘察和施工等活动新办审批（设区的市级权限）', '', '511A64185002-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1308, 1, NULL, '', '', '临时占用林地审批(市级)', '', '511A64001001-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1309, 1, NULL, '', '', '林木种子采种林的确定（市级）', '', '511F64201002-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1310, 1, NULL, '', '', '伐区调查设计材料的审核(市级)', '', '511Z64006003-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1311, 1, NULL, '', '', '森林植物产地检疫合格证签发（市级）', '', '511Z64007004-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1312, 1, NULL, '', '', '林木采伐许可证核发(设区的市级权限)', '', '511A64025001-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1313, 1, NULL, '', '', '林木采伐许可证延续核发（设区的市级权限）', '', '511A64025005-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1314, 1, NULL, '', '', '普通林草种子生产经营许可新办审批（市级）', '', '511A64023008-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1315, 1, NULL, '', '', '林草种子生产经营许可证延续（市级）', '', '511A64023005-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1316, 1, NULL, '', '', '林草种子生产经营许可证变更（市级）', '', '511A64023003-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1317, 1, NULL, '', '', '草原等级评定（市级）', '', 'F-000102-001-510800000000-000-11510700008450380H-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1318, 1, NULL, '', '', '临时占用、在草原上修建为草原保护和畜牧业生产服务的工程设施审批(市级)', '', '511A64019001-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1319, 1, NULL, '', '', '在自然保护区缓冲区从事非破坏性科研教学实习和标本采集新办审批（设区的市级权限）', '', '511A6422100014-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1320, 1, NULL, '', '', '紧急情况林木采伐备案(市级)', '', '511Z64008003-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1321, 1, NULL, '', '', '从事营利性治沙活动新办许可（设区的市级权限）', '', '511A64003004-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1322, 1, NULL, '', '', '矿藏勘查、开采以及其他各类工程建设占用林地变更审核（省级权限）', '', '511A64018008-510000000000-000-11510000MB1907659R-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1323, 1, NULL, '', '', '矿藏勘查、开采以及其他各类工程建设占用林地新办审核（省级权限）', '', '511A64018005-510000000000-000-11510000MB1907659R-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1324, 1, NULL, '', '', '矿藏勘查、开采以及其他各类工程建设占用林地延续审核（省级权限）', '', '511A64018009-510000000000-000-11510000MB1907659R-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1325, 1, NULL, '', '', '采集国家二级保护野生植物以及甘草和麻黄草新办审批', '', '511A0143000000-510000000000-000-8282348-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1326, 1, NULL, '', '', '采集国家二级保护野生植物以及甘草和麻黄草变更审批', '', '511A64039004-510000000000-000-11510000MB1907659R-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1327, 1, NULL, '', '', '采集国家二级保护野生植物以及甘草和麻黄草延续审批', '', '511A64039003-510000000000-000-11510000MB1907659R-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1328, 1, NULL, '', '', '省内调运林草植物检疫证书新办核发（设区的市级权限）', '', '511A64022001-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1329, 1, NULL, '', '', '省际间调运林草植物检疫证书新办核发', '', '511A0077700002-510000000000-000-8282348-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1330, 1, NULL, '', '', '工商企业等社会资本通过流转取得林地经营权新办审批（设区的市级权限）', '', '511A6421900006-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1331, 1, NULL, '', '', '工商企业等社会资本通过流转取得林地经营权变更审批（设区的市级权限）', '', '511A6421900007-510800000000-000-11510700MB15550247-1-00', NULL, '008450399', '市林业局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1332, 1, NULL, '', '', '对重大活动档案延期移交的审查', '', 'Z-000287-001-008450452', NULL, '008450452', '市档案局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1333, 1, NULL, '', '', '对重点建设项目（工程）档案的验收', '', 'Z-000408-001-008450452', NULL, '008450452', '市档案局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1334, 1, NULL, '', '', '销毁国有企业资产与产权变动档案备案', '', 'Z-000324-001-008450452', NULL, '008450452', '市档案局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1335, 1, NULL, '', '', '对国有企业文件材料归档范围和保管期限表的审查', '', '511Z75003001-510800000000-000-12510700MB0X49189C-1-00', NULL, '008450452', '市档案局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1336, 1, NULL, '', '', '电影放映单位设立审批（外商投资）', '', '511A0101000001-510800000000-000-11510700008450110Y-1-00', NULL, '3912551085516312576', '市新闻出版局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1337, 1, NULL, '', '', '出版物批发单位设立审批(初审)', '', '511A02003001-510800000000-000-11510700008450110Y-1-00', NULL, '3912551085516312576', '市新闻出版局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1338, 1, NULL, '', '', '一次性内部资料性出版物准印证核发(市级)', '', '511A02002002-510800000000-000-11510700008450110Y-1-00', NULL, '3912551085516312576', '市新闻出版局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1339, 1, NULL, '', '', '对非法出版物和违禁出版物的鉴定', '', '511F39004001-510800000000-000-11510700008450110Y-1-00', NULL, '3912551085516312576', '市新闻出版局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1340, 1, NULL, '', '', '包装装潢印刷品印刷设立审批', '', '511A0000400003-510800000000-000-11510700008450110Y-1-00', NULL, '3912551085516312576', '市新闻出版局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1341, 1, NULL, '', '', '其他印刷品印刷设立审批', '', '511A0000400004-510800000000-000-11510700008450110Y-1-00', NULL, '3912551085516312576', '市新闻出版局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1342, 1, NULL, '', '', '第一类易制毒化学品运输许可', '', '511A0080800001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1343, 1, NULL, '', '', '爆破作业单位许可（非营业性）', '', '511A0020400002-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1344, 1, NULL, '', '', '保安服务公司的法定代表人变更审核', '', '511A0151200000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1345, 1, NULL, '', '', '出入境证件真伪认定', '', '511F0614800000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1346, 1, NULL, '', '', '网络安全等级保护备案', '', '511F09005006-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1347, 1, NULL, '', '', '举办焰火晚会以及其他大型焰火燃放活动许可', '', '511A0020600003-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1348, 1, NULL, '', '', '预计参加人数在5000人以上的大型群众性活动安全许可或变更', '', '511A0020500001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1349, 1, NULL, '', '', '对中国境内死亡的外国人注销停留居留证件', '', '511F0612100000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1350, 1, NULL, '', '', '外国人护照报失证明', '', '511F0613100000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1351, 1, NULL, '', '', '出入境记录证明', '', '511F09757001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1352, 1, NULL, '', '', '校车标牌核发', '', '513A0152000000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1353, 1, NULL, '', '', '校车驾驶资格核发', '', '511A0146600000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1354, 1, NULL, '', '', '普通护照签发', '', '511A0116400001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1355, 1, NULL, '', '', '城市、风景名胜区和重要工程设施附近实施爆破作业审批', '', '511A0153500000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1356, 1, NULL, '', '', '补领、换领驾驶证', '', '513A0117200005-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1357, 1, NULL, '', '', '注销驾驶证', '', '511A09032001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1358, 1, NULL, '', '', '机动车驾驶证核发、审验', '', '511A0151400000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1359, 1, NULL, '', '', '对中国境内出生外国婴儿的停留或者居留登记', '', '511F0611700000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1360, 1, NULL, '', '', '放射性物品道路运输许可', '', '511A0153700000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1361, 1, NULL, '', '', '爆破作业人员许可', '', '511A0150400000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1362, 1, NULL, '', '', '大陆居民往来台湾通行证和签注签发', '', '511A0101700002-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1363, 1, NULL, '', '', '举行集会游行示威许可', '', '511A0151500000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1364, 1, NULL, '', '', '非机动车登记', '', '511A0152600000-510800000000-000-11510700008450495Q-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1365, 1, NULL, '', '', '保安培训备案', '', '511Z09755001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1366, 1, NULL, '', '', '对护照、出入境通行证的宣布作废', '', '511F0615500000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1367, 1, NULL, '', '', '民用枪支(弹药)配购证核发', '', '511A0098800001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1368, 1, NULL, '', '', '对外国人身份信息的核实', '', '511F0612900000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1369, 1, NULL, '', '', '出入境通行证签发', '', '511A0101600004-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1370, 1, NULL, '', '', '香港特别行政区、澳门特别行政区和台湾地区投资者设立合资、合作或者独资经营的保安服务公司审批', '', '511A0019200003-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1371, 1, NULL, '', '', '外资保安服务企业审批', '', '511A0019200002-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1372, 1, NULL, '', '', '内资保安服务企业审批', '', '511A0019200001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1373, 1, NULL, '', '', '省内枪支（弹药）运输许可', '', '511A0020200004-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1374, 1, NULL, '', '', '省内携运枪支（弹药）许可', '', '511A0020200001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1375, 1, NULL, '', '', '金融机构营业场所和金库安全防范设施建设工程验收', '', '511A09053002-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1376, 1, NULL, '', '', '金融机构营业场所和金库安全防范设施建设方案审批', '', '511A09053001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1377, 1, NULL, '', '', '机动车检验合格标志核发', '', '511A0152700000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1378, 1, NULL, '', '', '机动车补领、换领检验合格标志', '', '513A0011200076-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1379, 1, NULL, '', '', '机动车异地核发检验合格标志', '', '511A09030001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1380, 1, NULL, '', '', '由当地公安机关核发的机动车驾驶证并有3年以上驾龄，并安全行车，无重大交通事故责任记录', '', '513A0146800000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1381, 1, NULL, '', '', '台湾居民来往大陆通行证签发', '', 'A-004220-4220-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1382, 1, NULL, '', '', '出具已聘用或者拟聘用驾驶人员的3年内无重大以上交通责任事故的证明', '', '513A0083400001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1383, 1, NULL, '', '', '民用枪支持枪证（除射击运动枪支外的其他民用枪支）核发', '', '511A0019500002-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1384, 1, NULL, '', '', '内地居民前往港澳通行证、往来港澳通行证和签注签发', '', '511A0116500003-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1385, 1, NULL, '', '', '出具的相关人员安全驾驶经历证明', '', '513A0083400003-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1386, 1, NULL, '', '', '对签证、外国人停留居留证件等出境入境证件的宣布作废', '', '511F0612700000-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1387, 1, NULL, '', '', '机动车登记证、行驶证、号牌核发', '', '511A0021000001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1388, 1, NULL, '', '', '机动车解除抵押登记', '', '513A0117200009-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1389, 1, NULL, '', '', '机动车补领、换领号牌、行驶证', '', '513A0117200007-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1390, 1, NULL, '', '', '机动车补、换领登记证', '', '513A0117200008-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1391, 1, NULL, '', '', '机动车转移登记', '', '513A0117200003-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1392, 1, NULL, '', '', '机动车抵押登记', '', '513A0117200001-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
INSERT INTO `mortals_xhx_sheet_matter` VALUES (1393, 1, NULL, '', '', '机动车注销登记', '', '513A0117200002-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1394, 1, NULL, '', '', '机动车临时通行牌证核发', '', '511A0021000002-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1395, 1, NULL, '', '', '机动车变更登记', '', '513A0117200006-510800000000-000-11510700008450495P-1-00', NULL, '008450495', '市公安局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1396, 1, NULL, '', '', '举行大型宗教活动审批', '', '511A0033600001-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1397, 1, NULL, '', '', '公民民族成份确认和变更（未满十八岁）', '', '511F0127600000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1398, 1, NULL, '', '', '在宗教活动场所内改建或者新建建筑物审批', '', '511A0146300000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1399, 1, NULL, '', '', '开展宗教教育培训审批', '', '511A0126700000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1400, 1, NULL, '', '', '公民民族成份确认和变更（满十八岁）', '', '511F0167400000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1401, 1, NULL, '', '', '跨县（市、区）宗教活动审批', '', '511A0154900000-510800000000-000-008453661-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1402, 1, NULL, '', '', '宗教团体认定的宗教教职人员的备案', '', '511Z0171200000-510800000000-000-008453661-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1403, 1, NULL, '', '', '宗教活动场所主要教职人员任职的备案', '', '511Z0171300000-510800000000-000-008453661-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1404, 1, NULL, '', '', '宗教活动场所异地重建审批', '', '511A0602600000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1405, 1, NULL, '', '', '设立其它固定处所审批', '', '511A0126600000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1406, 1, NULL, '', '', '筹备设立寺院、宫观、清真寺、教堂审批', '', '511A0033400001-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1407, 1, NULL, '', '', '宗教活动场所扩建审批', '', '511A0602900000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1408, 1, NULL, '', '', '宗教团体、宗教院校、宗教活动场所接受境外组织和个人捐赠审批', '', '511A0126800000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL), (1409, 1, NULL, '', '', '宗教团体、宗教院校、宗教活动场所接受境外组织和个人捐赠（超过十万元）审批', '', '511A0603600000-510800000000-000-115107000084536619-1-00', NULL, '008453661', '市民宗局', NULL, NULL, NULL, NULL, NULL, '0', '', '事业法人', '无', '网络办件', '窗口办理', NULL, NULL, NULL, NULL, '否', '实名认证', NULL, NULL, NULL, NULL, '否', '否', '否', '否', NULL, '原件预审', 0, '互联网咨询', NULL, '否', NULL, NULL, NULL, '行政许可', NULL, NULL, NULL, '否', '否', '是', '是', '是', '是', NULL, '在用', NULL, '', NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, 0, NULL, NULL, NULL, NULL, NULL);
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_site
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_site`;
CREATE TABLE `mortals_xhx_site`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID，主键，自增长',
  `siteName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '站点名',
  `parentId` bigint(11) NOT NULL COMMENT '父级id',
  `ancestors` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '' COMMENT '祖级列表，逗号分隔',
  `address` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '地址',
  `mobile` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '电话',
  `introduce` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '单位介绍',
  `workday1` tinyint(1) NULL DEFAULT NULL COMMENT '周一 1上班 0不上',
  `workday2` tinyint(1) NULL DEFAULT NULL COMMENT '周二 1上班 0不上',
  `workday3` tinyint(1) NULL DEFAULT NULL COMMENT '周三 1上班 0不上',
  `workday4` tinyint(1) NULL DEFAULT NULL COMMENT '周四 1上班 0不上',
  `workday5` tinyint(1) NULL DEFAULT NULL COMMENT '周五 1上班 0不上',
  `workday6` tinyint(1) NULL DEFAULT NULL COMMENT '周六 1上班 0不上',
  `workday7` tinyint(1) NULL DEFAULT NULL COMMENT '周日 1上班 0不上',
  `number` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '站点编号',
  `summary` text CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '中心介绍',
  `orderNum` int(9) NULL DEFAULT 0 COMMENT '排序字段',
  `status` tinyint(2) NULL DEFAULT 1 COMMENT '站点状态 ，0，停用，1，正常 默认1',
  `updateTime` datetime(0) NULL DEFAULT NULL COMMENT '变更时间',
  `updateUser` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '变更用户loginName',
  `createTime` datetime(0) NOT NULL COMMENT '创建时间',
  `createUser` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '创建用户loginName',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '站点信息表';

-- ----------------------------
-- Records of mortals_xhx_site
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_table_index
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_table_index`;
CREATE TABLE `mortals_xhx_table_index`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '菜单ID，主键，自增长',
  `tableName` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '表名称',
  `tableMark` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '表标识',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '分表索引信息';

-- ----------------------------
-- Records of mortals_xhx_table_index
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_task
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_task`;
CREATE TABLE `mortals_xhx_task`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '序号，主键，自增长',
  `name` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '任务名称',
  `taskKey` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '任务关键字，区分任务执行流程',
  `status` tinyint(2) NULL DEFAULT 0 COMMENT '任务状态，0：未启动，1：执行中，默认0',
  `excuteService` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '任务执行服务',
  `excuteParam` text CHARACTER SET utf8 COLLATE utf8_general_ci NULL COMMENT '任务执行参数',
  `excuteHost` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '任务执行主机，为空表示不限制任务的执行主机，多个用逗号分隔',
  `excuteStrategy` tinyint(2) NULL DEFAULT 1 COMMENT '执行策略，1：按日，2：按周，3：按月，4：按间隔时间，默认1',
  `excuteDate` int(11) NULL DEFAULT 0 COMMENT '执行日期，按日：则为0；按周：则为1-7；按月：则为：1-31；按间隔时间：则为间隔时间，单位：秒；默认0',
  `excuteTime` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '00' COMMENT '执行时间，格式：HH:mm，默认：00:00',
  `remark` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '备注',
  `lastExcuteHost` varchar(32) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '最后执行主机',
  `lastExcuteTime` datetime(0) NULL DEFAULT NULL COMMENT '最后执行时间',
  `interimExcuteStatus` tinyint(2) NULL DEFAULT 0 COMMENT '临时执行状态，0：未启用，1：立即执行并保留，2：立即执行并删除，默认0',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `createUserName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户名称',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 5 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '任务信息';

-- ----------------------------
-- Records of mortals_xhx_task
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_task` VALUES (2, '分表创建任务', 'tableIndexService', 0, 'tableIndexService', NULL, NULL, 1, 0, '00:30', NULL, '192.168.0.221', '2025-02-13 00:30:01', 0, '2021-08-12 11:07:23', 1, '系统管理员'), (3, '同步事项', 'SyncSiteMatterTask', 0, 'SyncSiteMatterTask', NULL, NULL, 1, 0, '19:05', NULL, '192.168.0.221', '2025-02-12 19:05:01', 0, NULL, NULL, NULL), (4, '同步设备', 'SyncSiteDeviceTask', 0, 'SyncSiteDeviceTask', NULL, NULL, 3, 0, '02:55', NULL, '172.17.0.1', '2024-01-15 02:55:01', 0, '2023-02-25 14:34:12', 1, NULL);
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_uploadfile
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_uploadfile`;
CREATE TABLE `mortals_xhx_uploadfile`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT 'ID，主键，自增长',
  `fileName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '文件名称',
  `filePath` varchar(100) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '文件路径',
  `fileType` tinyint(2) NULL DEFAULT NULL COMMENT '文件类型，1 excel ,2 img,3 zip, 4 pdf',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '上传文件';

-- ----------------------------
-- Records of mortals_xhx_uploadfile
-- ----------------------------
BEGIN;
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_user
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_user`;
CREATE TABLE `mortals_xhx_user`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '用户ID，主键，自增长',
  `loginName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '登录名',
  `loginPwd` varchar(128) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '登录密码，使用md5双次加密',
  `loginLimitAddress` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '登录限制地址，多个IP地址用逗号分隔，可以使用IP段匹配，如：172.17.*非空：则只能该值内的IP可以登录',
  `realName` varchar(64) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户名',
  `mobile` varchar(21) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户手机号',
  `phone` varchar(21) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户联系电话',
  `email` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户邮箱',
  `qq` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'QQ号码',
  `userType` tinyint(2) NULL DEFAULT NULL COMMENT '用户类型(0.系统用户,1.普通用户,2.工作人员)',
  `siteIds` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '所属站点id,多个逗号分隔',
  `areaCodes` varchar(512) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '所属区域code,多个逗号分隔',
  `status` tinyint(2) NULL DEFAULT NULL COMMENT '用户状态(0.停用，1.正常，2.冻结，3.销户，4.离职)',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `createUserId` bigint(20) NULL DEFAULT NULL COMMENT '创建用户',
  `createUserName` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '创建用户名称',
  `lastLoginTime` datetime(0) NULL DEFAULT NULL COMMENT '最后一次登录时间',
  `lastLoginAddress` varchar(21) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '最后一次登录地址',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 2 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '用户信息业务';

-- ----------------------------
-- Records of mortals_xhx_user
-- ----------------------------
BEGIN;
INSERT INTO `mortals_xhx_user` VALUES (1, 'admin', 'de7abfba6f99cb20b794867cdf664445', NULL, '系统管理员', '13808095770', NULL, NULL, NULL, 1, '1', '510109000000', 1, '2022-06-02 09:12:26', 1, 'admin', '2022-06-02 09:12:26', '');
COMMIT;

-- ----------------------------
-- Table structure for mortals_xhx_valid_code
-- ----------------------------
DROP TABLE IF EXISTS `mortals_xhx_valid_code`;
CREATE TABLE `mortals_xhx_valid_code`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '菜单ID，主键，自增长',
  `code` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '验证码',
  `url` varchar(500) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '校验地址，email校验使用',
  `mobile` varchar(21) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '校验手机号',
  `email` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '校验邮箱',
  `type` tinyint(2) NULL DEFAULT 0 COMMENT '校验方式，0：图片校验，1：手机校验，2：邮箱校验，默认0',
  `sessionId` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '会话ID',
  `ip` varchar(50) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'IP地址',
  `createTime` datetime(0) NULL DEFAULT NULL COMMENT '创建时间',
  `lapseTime` datetime(0) NULL DEFAULT NULL COMMENT '失效时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 1 CHARACTER SET = utf8 COLLATE = utf8_general_ci COMMENT = '验证码信息';

-- ----------------------------
-- Records of mortals_xhx_valid_code
-- ----------------------------
BEGIN;
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;
